C     Last change:  BG   21 Feb 2005    1:58 pm
      SUBROUTINE A21AST(XORY,A21, IER)
C
C     Last change:  MDB  26 Apr 2001    4:21 pm
C ======================================================================
C
C                             A 2 1 A S T
C                            =============
C                            =============
C
C     S T A N D            :  04.03.2001
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C
C     Z W E C K :             ADDS CONTRIBUTION OF STIFFENERS
C                             TO MATRIX A21
C     ===========
C
C
C     P A R A M E T E R S : A
C     ===================
C
C     INPUT :
C        XOR                  (CHARACTER*1)
C                             DECIDES WHETHER TO TREAT STIFFENERS
C                             RUNNING IN X-DIRECTION (XORY .EQ. 'X')
C                             OR Y-DIRECTION (XORY .EQ. 'Y')
C        A21(LENGTH,*)        ARRAY STORING A21
C        LENGTH               NUMBER OF ROWS OF MATRIX A21 AS DEFINED
C                             IN THE DIMENSION STATEMENT IN THE CALLING
C                             PROGRAM UNIT
C
C     OUTPUT :                UPDATED MATRIX
C        A21
C        IER                  ERROR INDEX
C                             IER=0:  NO ERROR
C                             IER=1   FUNCTIONAL DEGREES OF FREEDOM u,v
C                                     NOT AVAILABLE
C                             IER=2:  ERROR FROM SUBROUTINE KUORKV
C                             IER=3:  ERROR FROM SUBROUTINE KUORKV                             IER=3:  ARGUMENT XORY NEITHER 'X' NOR 'Y'
C
C     S U B R O U T I N E  CALLED
C     =============================
C
C        KUORKV         DETERMINES DEGREES OF FREEDOMM AT NODES
C                       OF STIFFENER SECTIONS
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
      REAL, DIMENSION(1:11,1:3):: FEPS
      INTEGER, DIMENSION(1:11,1:3):: KEPS
      COMMON /F01EPS/ FEPS, KEPS
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*1      XORY
#ifndef MBEOS5
      DOUBLE PRECISION, DIMENSION(1:P_NY,1:*):: A21	 
#else
      DOUBLE PRECISION, DIMENSION(1:16*P_NODES,1:*):: A21
#endif
C
      DOUBLE PRECISION:: 				F1,F2,F3,F4
      REAL, DIMENSION(1:4):: 			BX
      REAL, DIMENSION(1:2):: 			FQ
      INTEGER, DIMENSION(1:2,1:4):: KPQ, JRS
      INTEGER, DIMENSION(1:2):: 		KQA
      INTEGER::          				RHO
C
      DATA KQA/0,2/
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      WRITE (NWRITE,'("ENTERING A21AST")')
C
      IER = 0
      IF (.NOT.(KU(2).EQ.2 .AND. KU(3).EQ.3)) THEN
      	WRITE (NWRITE,2000)
         WRITE (NWRITE,2003)
         IER = 1
         GOTO 999
      END IF
      IF (XORY .EQ. 'X') THEN
         IIMA   = MX - 1
         IMA  = NOX
         JFCT = 2
      ELSE IF (XORY .EQ. 'Y') THEN
         IIMA = MY - 1
         IMA  = NOY
         JFCT = 3
      ELSE
         WRITE (NWRITE,2000)
         WRITE (NWRITE,2001)
         GOTO 999
      END IF
C
C     LOOP OVER STIFFENERS
C
      DO 800, I=1,IMA
C
C        COMPUTE STIFFNESS FACTORS. CURVATURES ARE TAKEN FROM
C        COMMON /F01EPS /FEPS(*,*)
         IF (XORY .EQ. 'X') THEN
            FQ(1) = 2.*STEIFX(1,I)*FEPS(1,2)
            FQ(2) = 2.*STEIFX(2,I)
            III   = ISTX(I)
         ELSE
            FQ(1) = 2.*STEIFY(1,I)*FEPS(2,2)
            FQ(2) = 2.*STEIFY(2,I)
            III   = ISTY(I)
         END IF
C
C        LOOP OVER TERMS
         DO 600, ITRM=1,2
            NUE = 1
            RHO = KQA(ITRM)
            IXP = NUE + RHO - 1
C           FOR USE AS MATRIX SUBSCRIPTS NUE, RHO ARE INCREMENTED BY 1
            NUE = NUE + 1
            RHO = RHO + 1
            F1 = FQ(ITRM)
            IF (ABS(F1) .LT. 1.D-30) GOTO 600
C           LOOP OVER SUBDIVISIONS
            DO 500, II = 1,IIMA
C              TO ESTABLISH MATRIX BX(4) USE MATRIX B1 (COMMON/F07PD)
               BX(1) = B1(1,1)
               IF (XORY .EQ. 'X') THEN
                  RA = A(II)
                  BX(2) = RA*B1(1,2)
               ELSE
                  RA = B(II)
                  BX(2) = RA*B1(2,1)
               END IF
               F2 = F1/RA**IXP
               BX(3) = BX(1)
               BX(4) = BX(2)
               CALL KUORKV(XORY,III,II,1,KPQ, IER)
                  IF (IER .NE. 0) THEN
                     WRITE (NWRITE,2000)
                     WRITE (NWRITE,2002) III,II
                     IER = 2
                     GOTO 999
                  END IF
               CALL KUORKV(XORY,III,II,JFCT,JRS, IER)
                  IF (IER .NE. 0) THEN
                     WRITE (NWRITE,2000)
                     WRITE (NWRITE,2002) III,II
                     IER = 3
                     GOTO 999
                  END IF
C#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
C 7001 FORMAT(1X,'III, II, JFCT: ',A1,3I3)
C      WRITE (NWRITE,7002) ((KPQ(I4I,J4J),J4J=1,4),I4I=1,2),
C     *                    ((JRS(I4I,J4J),J4J=1,4),I4I=1,2)
C 7002 FORMAT(1X,'KPQ: ',4I3,5X,4I3/1X,'JRS: ',4I3,5X,4I3)
C#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
C              INTERPOLATION LOOPS
               DO 400, IS=1,4
                  JLS = JRS(1,IS)
                  IF (JLS .EQ. 0) GOTO 400
                  F3 = F2*BX(IS)
                  DO 300, IQ=1,4
                     KMQ = KPQ(1,IQ)
                     IF (KMQ .EQ. 0) GOTO 300
                     F4  =
     *               F3*BX(IQ)*(S1(RHO,IQ,NUE,IS)+S2(RHO,IQ,NUE,IS))
C                    UPDATE MATRIX
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      WRITE (NWRITE,2005)  JLS, KMQ, 0.5D0*F4, ITRM,XORY,NUE,IQ,RHO,IS
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                     A21(JLS,KMQ) = A21(JLS,KMQ) + 0.5D0*F4
  300               CONTINUE
  400          CONTINUE
  500       CONTINUE
  600    CONTINUE
  800 CONTINUE
  999 RETURN
C
 2000 FORMAT(/1X,'MESSAGE FROM SUBROUTINE A21AST:')
 2001 FORMAT(1X,'INADMISSIBLE FIRST ARGUMENT, NEITHER ''X'' NOR ''Y''')
 2002 FORMAT(1X,'ERROR RETURN FROM KUORKV, I=', I4,'J=', I4)
 2003 FORMAT(1X,'Using BEOS with stiffened panels requires functional
     * dofs u,v (2,3).'/
     *1X,'Please correct input of KU in NAMELIST SUBDIV')
 2005 FORMAT(1X,'UPDATING A21(',I4,',',I4,')',4X, D15.6,4X,
     *       'TERM',I4, 'DIRECTION ',A1,4X,4I3)
C     END OF SUBROUTINE A21AST
      END

