C     Last change:  BG   21 Feb 2005    1:59 pm
C
      SUBROUTINE A22AST(XORY,A22, IER)
C
C ======================================================================
C
C                             A 2 2 A S T
C                            =============
C                            =============
C
C     S T A N D            :  04.03.2001
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C
C     Z W E C K :             ADDS CONTRIBUTION OF STIFFENERS
C     ===========             TO MATRIX A22
C
C
C     P A R A M E T E R S :
C     ===================
C
C     INPUT :
C        XORY                 (CHARACTER*1)
C                             DECIDES WHETHER TO TREAT STIFFENERS
C                             RUNNING IN X-DIRECTION (XORY .EQ. 'X')
C                             OR Y-DIRECTION (XORY .EQ. 'Y')
C        A22(*)               MATRIX TO BE UPDATED
C
C     OUTPUT :
C        A22
C        IER                  ERROR INDEX
C                             IER=0:  NO ERROR
C                             IER=1   FUNCTIONAL DEGREES OF FREEDOM u,v
C                                     NOT AVAILABLE
C                             IER=2:  ERROR FROM SUBROUTINE KUORKV
C                             IER=3:  ARGUMENT XORY NEITHER 'X' NOR 'Y'
C
C     S U B R O U T I N E S CALLED
C     =============================
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
      INTEGER, DIMENSION(1:P_NX):: LVTRI,LVB
      INTEGER, DIMENSION(1:P_NY):: LVA22
      COMMON /COMLV/  LVTRI,LVA22,LVB
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C
C
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*1      XORY
      DOUBLE PRECISION, DIMENSION(1:*):: A22
C
      DOUBLE PRECISION:: 				F2,F3,F4
      INTEGER::          				RHO
      INTEGER, DIMENSION(1:2,1:4):: KPQ
      REAL, DIMENSION(1:4)::     	BX(4)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C      WRITE (NWRITE,'("ENTERING A22AST")')
C
      IER = 0
C     Check functional degrees of freeedom
      IF (.NOT.(KU(2).EQ.2 .AND. KU(3).EQ.3)) THEN
      	WRITE (NWRITE,2000)
         WRITE (NWRITE,2003)
         IER = 1
         GOTO 999
      END IF
      IF (XORY .EQ. 'X') THEN
         JFCT = 2
         IMA  = NOX
         IIMA = MX - 1
      ELSE IF (XORY .EQ. 'Y') THEN
         JFCT = 3
         IMA  = NOY
         IIMA = MY - 1
      ELSE
         IER = 3
         WRITE (NWRITE,2000)
         WRITE (NWRITE,2001)
         GOTO 999
      END IF
         RHO = 1
         NUE = 1
C         IXP = NUE + RHO - 1
C        FOR USE AS MATRIX SUBSCRIPTS NUE, RHO ARE INCREMENTED BY 1
         NUE = NUE + 1
         RHO = RHO + 1
C
C     LOOP OVER STIFFENERS
C
      DO 800, I=1,IMA
C        COMPUTE STIFFNESS FACTOR.
         IF (XORY .EQ. 'X') THEN
            FQ   = STEIFX(1,I)
            III  = ISTX(I)
         ELSE IF (XORY .EQ. 'Y') THEN
            FQ   = STEIFY(1,I)
            III  = ISTY(I)
         END IF
         IF (ABS(FQ) .LT. 1.D-30) GOTO 800
C
C        LOOP OVER TERMS (ONE TERM ONLY, NO LOOP)
C        LOOP OVER SUBDIVISIONS
         DO 500, II = 1,IIMA
C           TO ESTABLISH MATRIX BX(4) USE MATRIX B1 (COMMON/F07PD)
            BX(1) = B1(1,1)
            IF (XORY .EQ. 'X') THEN
               RA = A(II)
               BX(2) = B1(1,2)*RA
            ELSE
               RA = B(II)
               BX(2) = B1(2,1)*RA
            END IF
C            F2 = FQ/RA**IXP; SINCE IXP=1 USE NEXT STATEMENT
            F2 = FQ/RA
            BX(3) = BX(1)
            BX(4) = BX(2)
            CALL KUORKV(XORY,III,II,JFCT,KPQ, IER)
               IF (IER .NE. 0) THEN
                  WRITE (NWRITE,2000)
                  WRITE (NWRITE,2002) III,II
                  IER = 2
                  GOTO 999
               END IF
C#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
C      WRITE (NWRITE,7001) XORY,III, II, JFCT
C 7001 FORMAT(1X,'III, II, JFCT: ',A1,3I3)
C      WRITE (NWRITE,7002) ((KPQ(I4I,J4J),J4J=1,4),I4I=1,2)
C 7002 FORMAT(1X,'KPQ: ',4I3,5X,4I3)
C#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
C
C           INTERPOLATION LOOPS
            DO 400, IS=1,4
               F3 = F2*BX(IS)
               JLS = KPQ(1,IS)
               IF (JLS .EQ. 0) GOTO 400
               DO 300, IQ=1,4
                  KMQ = KPQ(1,IQ)
                  IF (KMQ .EQ. 0) GOTO 300
                  F4  =
     *            F3*BX(IQ)*(S1(NUE,IQ,RHO,IS)+S2(NUE,IQ,RHO,IS))
C                 UPDATE MATRIX
                  IF (JLS .GE. KMQ) THEN
                     IA22 = LVA22(JLS) + KMQ
                  ELSE
                     IA22 = LVA22(KMQ) + JLS
                  END IF
                  IF (JLS .EQ. KMQ) THEN
                     A22(IA22) = A22(IA22) + F4
                  ELSE
                     A22(IA22) = A22(IA22) + 0.5D0*F4
                  END IF
  300          CONTINUE
  400       CONTINUE
  500    CONTINUE
  800 CONTINUE
  999 RETURN
C
 2000 FORMAT(/1X,'MESSAGE FROM SUBROUTINE A22AST:')
 2001 FORMAT(1X,'INADMISSIBLE FIRST ARGUMENT, NEITHER ''X'' NOR ''Y''')
 2002 FORMAT(1X,'ERROR RETURN FROM KUORKV, I=',I4,' J=',I4)
 2003 FORMAT(1X,'Using BEOS with stiffened panels requires functional
     * dofs u,v (2,3).'/
     *1X,'Please correct input of KU in NAMELIST SUBDIV')
C     END OF SUBROUTINE A22AST
      END

