C     Last change:  BG   18 Nov 2004    4:06 pm
      SUBROUTINE BMATST(XORY,BMT,LV,PMEM,FAKT, IER)
C
C ======================================================================
C
C                             B M A T S T
C                            =============
C                            =============
C
C     S T A N D            :  08.03.2001
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C
C     M O D I F I E D      : 08.06.2007
C							 Conny Schillo
C                            DLR BRAUNSCHWEIG, INST. FA-SM
C
C     Z W E C K :    ADDS CONTRIBUTION OF STIFFENERS
C                    TO GEOMETRIC STIFFNESS MATRIX
C     ===========
C
C
C     P A R A M E T E R :
C     ===================
C
C     INPUT :
C        XORY          (CHARACTER*1) DECIDES WHETHER TO TREAT STIFFENERS
C                      RUNNING IN X-DIRECTION (XORY .EQ. 'X')
C                      OR Y-DIRECTION (XORY .EQ. 'Y')
C        BMT(*)        MATRIX TO BE UPDATED
C        LV(*)         ARRAY ASSISTING INDEX COMPUTATION
C        PMEM(130,3)   MEMBRANE FORCES IN THE SKIN
C        FKT          FACTOR TO BE APPLIED ON ALL ELEMENTS OF BMT
C     OUTPUT :
C        BMT
C        IER           ERROR INDEX
C                      IER=1: FIRST ARGUMENT (XORY) NEITHER 'X' NOR 'Y'
C                      IER=2: ERROR RETURN FROM SUBROUTINE KUORKV
C
C     S U B R O U T I N E S CALLED
C     =============================
C     KUORKV        ESTABLISH MATRIX CONTAINING NUMBERS OF DEGREES OF
C                   FREEDOM FOR A STIFFENER ELEMENT OF BEOS
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
C
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
      REAL, DIMENSION(1:3,1:3):: AIJ
      COMMON /F07AIJ/ AIJ
C
C     COMMON /COMLV/  LVTRI(430),LVA22(1200),LVB(400)
C     COMMON /F01EPS/ FEPS(11,3), KEPS(11,3)
C     COMMON /F01QUA/ FQUAD(340), KQUAD(340,3), M
C     COMMON /F07MAT/ LM(5,4,130)
C     COMMON /CPFEST/  PFEST(130,3)
      INTEGER:: NREAD, NWRITE, NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*1 XORY
      DOUBLE PRECISION, DIMENSION(*):: BMT
      REAL, DIMENSION(P_NODES,3):: PMEM
      REAL:: FAKT
      INTEGER, DIMENSION(*):: LV(*)
C
      DOUBLE PRECISION F4
      INTEGER RHO
      DIMENSION KPQ(2,4), BX(4), PAX(2)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C######################################################################
C
C
      REAL :: STIFFX,EPSWEB
      COMMON /TEST/ PAX,STIFFX,EPSWEB
C	  
      STIFFX=STEIFX(1,1)	  
C	  
C
      IER = 0
      JFCT = 1
C      IXP = 1
C      GOTO 999
C
C     ORDER OF DIFFERENTIATION, INCREMENTED FOR USE AS SUBSCRIPTS
      NUE = 2; RHO = 2
      IF (XORY .EQ. 'X') THEN
         IMA  = NOX
         IIMA = MX - 1
C         NUE = 2
C         MUE = 1
C         RHO = 2
C         LAM = 1
      ELSE IF (XORY .EQ. 'Y') THEN
         IMA  = NOY
         IIMA = MY - 1
C         NUE = 2
C         MUE = 2
C         RHO = 1
C         RHO = 2
C         LAM = 2
      ELSE
         IER = 1
         WRITE (NWRITE,2000)
         WRITE (NWRITE,2001)
         GOTO 999
      END IF
C
C     LOOP OVER STIFFENERS
C
      DO 800, I=1,IMA
C        GET AXIAL FORCE AT FIRST NODE OF STIFFENER
C
         IF (XORY .EQ. 'X') THEN
            JJ   = ISTX(I)
            KNOD = LEIT(JJ,1)
            F1   = STEIFX(1,I)
C            PAX(2) = QVSKPS(PMEM(KNOD,1),AIJ(1,1),3,130,1)*F1
            PAX(2) = F1*DOT_PRODUCT(PMEM(KNOD,(/1,3,2/)),AIJ(1,:))
         ELSE IF (XORY .EQ. 'Y') THEN
            JJ   = ISTY(I)
            KNOD = LEIT(1,JJ)
            F1   = STEIFY(1,I)
C            PAX(2) = QVSKPS(PMEM(KNOD,1),AIJ(1,2),3,130,1)*F1
            PAX(2) = F1*DOT_PRODUCT(PMEM(KNOD,(/1,3,2/)),AIJ(2,:))
         END IF
C
C        LOOP OVER ELEMENTS ALONG STIFFENER
         DO 500, II = 1,IIMA
C           TO ESTABLISH MATRIX BX(4) USE MATRIX B1 (COMMON/F07PD)
            BX(1) = B1(1,1)
            IF (XORY .EQ. 'X') THEN
               RA = A(II)
               BX(2) = RA*B1(1,2)
            ELSE
               RA = B(II)
               BX(2) = RA*B1(2,1)
            END IF
            BX(3) = BX(1)
            BX(4) = BX(2)
C           F2 = FAKT/RA**IXP
C           SINCE IXP=1 USE THE NEXT STATEMENT (NO EXPONENTIATON OF RA)
            F2 = FAKT/RA
            CALL KUORKV(XORY,JJ,II,JFCT,KPQ, IERR)
               IF (IERR .NE. 0) THEN
                  IER = 2
                  WRITE (NWRITE,2000)
                  WRITE (NWRITE,2002) JJ,II
                  GOTO 999
               END IF
C
C           GET AXIAL FORCE AT NODES OF ELEMENT
            PAX(1) = PAX(2)
            IF (XORY .EQ. 'X') THEN
C               KNOD = LEIT(I,II+1)
               KNOD = LEIT(JJ,II+1)
C               PAX(2) = QVSKPS(PMEM(KNOD,1),AIJ(1,1),3,130,1)*F1
               PAX(2) = F1*DOT_PRODUCT(PMEM(KNOD,(/1,3,2/)),AIJ(1,:))
            ELSE
C               KNOD = LEIT(II+1,I)
               KNOD = LEIT(II+1,JJ)
C               PAX(2) = QVSKPS(PMEM(KNOD,1),AIJ(1,2),3,130,1)*F1
               PAX(2) = F1*DOT_PRODUCT(PMEM(KNOD,(/1,3,2/)),AIJ(2,:))
            END IF
C
C           INTERPOLATION LOOPS
            DO 400, IS=1,4
               F3 = F2*BX(IS)
               JLS = KPQ(1,IS)
               IF (JLS .EQ. 0) GOTO 400
               DO 300, IQ=1,4
                  KMQ = KPQ(1,IQ)
                  IF (KMQ .EQ. 0) GOTO 300
                  F4 = F3*BX(IQ)*(PAX(1)*S1(NUE,IQ,RHO,IS)
     *                          + PAX(2)*S2(NUE,IQ,RHO,IS))
C                 UPDATE MATRIX
                  IF (JLS .GE. KMQ) THEN
                    IBMT = LV(JLS) + KMQ
                  ELSE
                    IBMT = LV(KMQ) + JLS
                  END IF
                  IF (JLS .EQ. KMQ) THEN
                     BMT(IBMT) = BMT(IBMT) + F4
                  ELSE
                     BMT(IBMT) = BMT(IBMT) + 0.5D0*F4
                  END IF
  300          CONTINUE
  400       CONTINUE
  500    CONTINUE
  800 CONTINUE
C#######################################################################
C
C
  999 RETURN
C
 2000 FORMAT(/1X,'MESSAGE FROM SUBROUTINE BMATST:')
 2001 FORMAT(1X,'INADMISSIBLE FIRST ARGUMENT, NEITHER ''X'' NOR ''Y''')
 2002 FORMAT(1X,'ERROR RETURN FROM KUORKV, I=',I4, 'J=',I4)
C     END OF SUBROUTINE BMATST
      END

