C     Last change:  BG   21 Feb 2005    2:59 pm
C
      SUBROUTINE CMPA11(A11, IER)
C
C ======================================================================
C
C                             C M P A 1 1
C                             =============
C                             =============
C
C     S T A N D            :  06.02.2001
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C     M O D I F I E D:        19.11.2007 by C. Schillo
C                             DLR BRAUNSCHWEIG, FA-SM
C
C     Z W E C K :             COMPUTES MATRIX A11
C     ===========
C
C
C
C
C     P A R A M E T E R :
C     ===================
C
C     INPUT :
C        A11(*)               ARRAY STORING A11
C        STORE                (LOGICAL)
C                             INDICATES WHETHER ARRAY HAS
C                             TO BE STORED ON SEQUENTIAL FILE
C
C     OUTPUT :
C        A11
C        IER                  ERROR INDEX
C                             IER .EQ. 0:  NO ERROR
C                             IER .NE. 0:  ERROR IN SUBROUTINE CMPBMT,
C                                          WHICH IS CALLED FROM HERE
C
C     S U B R O U T I N E S CALLED
C     =============================
C
C     CMPBMT                  COMPUTE MATRIX B
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
      INTEGER, DIMENSION(1:P_NX):: LVTRI,LVB
      INTEGER, DIMENSION(1:P_NY):: LVA22
      COMMON /COMLV/  LVTRI,LVA22,LVB
C
      INTEGER, PARAMETER :: P_ITRM=340
      INTEGER, DIMENSION (1:P_ELMTS):: IKT
      REAL, DIMENSION(1:P_ITRM,P_ELMTS):: FQUAD
      INTEGER, DIMENSION(1:P_ITRM,1:3,1:P_ELMTS)::
     *  KQUAD
      COMMON /F01QUA/ FQUAD, KQUAD, IKT
C
      REAL, DIMENSION(1:P_NODES,1:3):: PFEST
      COMMON /CPFEST/ PFEST
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
      DOUBLE PRECISION, DIMENSION(*):: A11
C
      DOUBLE PRECISION :: F,F1,F2,F3,F4
      INTEGER :: AB
C            
      DOUBLE PRECISION, DIMENSION
     * (1:4,1:4,1:4,1:4,P_ELMTS):: 	PQRS
      INTEGER :: IELM
      REAL, DIMENSION(1:4,1:4):: B2
      INTEGER::          RHO
      INTEGER, DIMENSION(1:4,1:4):: KPQ
      LOGICAL::        ADDB
C
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IER = 0
C      IF (STORE) THEN
C         INQUIRE (11, OPENED=OP11)
CC        IF (.NOT. OP11) OPEN (11, FILE='RCA11',FORM='UNFORMATTED')
C         IF (.NOT. OP11) OPEN (11, FILE='RCA11',FORM='FORMATTED')
C         REWIND 11
C      END IF
      LNGA11=LVTRI(IX) + IX
      DO 10, I=1,LNGA11
         A11(I) = 0.D0
   10 CONTINUE
C
      AB=(MX-1)*(MY-1)
C        LOOP OVER SUBDIVISIONS
      DO 9001, IYY = 1,MY-1
        DO 9000, IXX=1,MX-1
            IELM=(IXX-1)*(MY-1)+IYY
C      
C     LOOP OVER QUADRATIC ENERGY TERMS
C
         DO 1000, ITRM=1,IKT(IELM)
         JTRM= KQUAD(ITRM,3,IELM)
         JF1 = JTRM/10
         JF2 = MOD(JTRM,10)
C
C        EXCLUDE NON-RELEVANT TERMS
C
         IF (JF1 .NE. 1 .OR. JF2 .NE. 1) GOTO 1000
C
         MUE = MOD(KQUAD(ITRM,1,IELM),10)
         NUE = MOD(KQUAD(ITRM,1,IELM),100)/10
         LAM = MOD(KQUAD(ITRM,2,IELM),10)
         RHO = MOD(KQUAD(ITRM,2,IELM),100)/10
         IPA = NUE + RHO - 1
         IPB = MUE + LAM - 1
C
C        FOR USE AS SUBSCRIPTS NUE,...,LAM ARE INCREMENTED
         MUE = MUE + 1
         NUE = NUE + 1
         RHO = RHO + 1
         LAM = LAM + 1
C
C        COMPUTE PART THAT IS INDEPENDENT OF SUBDIVISION SIZE
C        STORE IT IN ARRAY PQRS
         F = FQUAD(ITRM,IELM)*FA
         IF (DABS(F) .LT. 1.D-20) GOTO 1000
C
         DO 620, IS=1,4
         DO 618, IQ=1,4
            F1 = F*(S1(NUE,IQ,RHO,IS) + S2(NUE,IQ,RHO,IS))
            DO 616, IR=1,4
               F2 = F1*B1(IR,IS)
               DO 614, IP=1,4
                  PQRS(IP,IQ,IR,IS,IELM) =
     *            F2*(S1(MUE,IP,LAM,IR) + S2(MUE,IP,LAM,IR))*B1(IP,IQ)
  614          CONTINUE
  616       CONTINUE
  618    CONTINUE
  620    CONTINUE
C
            SMB = B(IYY)
            F1 = 1.D0/(SMB**IPB)
               SMA = A(IXX)
               F2 = F1/(SMA**IPA)
               CALL IUORIV(IYY,IXX,JF1,KPQ, IERR)
                  IF (IERR .NE. 0) THEN
                     WRITE (NWRITE,5001)
                     WRITE (NWRITE,5002)
                     IER = 2
                     STOP
                  END IF
C              COMPUTE MATRIX B2(4,4)
               DO 702, I=1,3,2
                  B2(1,I)   = 1.0
                  B2(1,I+1) = SMA
                  B2(I,1)   = 1.0
                  B2(I+1,1) = SMB
  702          CONTINUE
               DO 710, I=2,4
               DO 710, J=2,4
                  B2(I,J) = B2(1,J)*B2(I,1)
  710          CONTINUE
C
C              LOOPS OVER S,Q,R,P
C
               DO 802, IP=1,4
               DO 802, IQ=1,4
                  KKPQ = KPQ(IP,IQ)
                  IF (KKPQ .EQ. 0) GOTO 802
                  F3 = F2*B2(IP,IQ)
                  DO 801, IR=1,4
                  DO 800, IS=1,4
C                     NLRS = NRS(IR,IS)
                     NLRS = KPQ(IR,IS)
                     IF (NLRS. EQ. 0) GOTO 800
                        F4 = F3*PQRS(IP,IQ,IR,IS,IELM)*B2(IR,IS)
C                       UPDATE MATRIX
                        IF (NLRS .GE. KKPQ) THEN
                           IA11 = LVTRI(NLRS) + KKPQ
                        ELSE
                           IA11 = LVTRI(KKPQ) + NLRS
                        END IF
                        IF (NLRS .EQ. KKPQ) THEN
                           A11(IA11) = A11(IA11) + F4
                        ELSE
                           A11(IA11) = A11(IA11) + 0.5D0*F4
                        END IF
  800             CONTINUE
  801             CONTINUE
  802          CONTINUE
 1000    CONTINUE  
 9000   CONTINUE
 9001  CONTINUE
C
C***     TEST AUSGABE!!!!
C      WRITE (NWRITE,5006)
C      DO II=1,P_LA11
C      WRITE (NWRITE,*) A11(II)
C      END DO
C     ADD CONTRIBUTION OF STIFFENERS
C
      IF (NOX .GT. 0) THEN
         CALL A11XST(A11, IERR)
            IF (IERR .NE. 0) THEN
               IER = 3
               WRITE (NWRITE,5001)
               WRITE (NWRITE,5003)
               GOTO 999
            END IF
      END IF
      IF (NOY .GT. 0) THEN
         CALL A11YST(A11, IERR)
            IF (IERR .NE. 0) THEN
               IER = 4
               WRITE (NWRITE,5001)
               WRITE (NWRITE,5004)
               GOTO 999
            END IF
      END IF
C
C     ADD LOAD-DEPENDENT PART IN CASE OF SHIFT (PFEST .NE. 0)
C
      ADDB = .FALSE.
      IIII=MX*MY
      DO 910, I=1,IIII
      DO 910, J=1,3
         ADDB = ADDB .OR. (ABS(PFEST(I,J)) .GT. 1.E-20)
  910 CONTINUE
      IF (ADDB) THEN
         FAKT = -1.0
         CALL CMPBMT(A11,LVTRI,PFEST,FAKT, IERR)
            IF (IERR. NE. 0) THEN
               IER = 3
C              ERROR IN CMPBMT
               WRITE (NWRITE,5001)
               WRITE (NWRITE,5005)
               STOP
C              GOTO 999
            END IF
      END IF
C
  999 RETURN
C
 5001 FORMAT(/1X,'MESSAGE FROM SUBROUTINE CMPA11: ')
 5002 FORMAT(1X,'ERROR IN SUBROUTINE IUORIV.')
 5003 FORMAT(1X,'ERROR IN SUBROUTINE A11XST.')
 5004 FORMAT(1X,'ERROR IN SUBROUTINE A11YST.')
 5005 FORMAT(1X,'ERROR IN SUBROUTINE CMPBMT.')
 5006 FORMAT(1x,'GLOBAL STIFFNESS MATRIX A11')
C     END OF SUBROUTINE CMPA11
      END

