C     Last change:  BG   21 Feb 2005    2:33 pm
      SUBROUTINE CMPA21(A21,LONG, IER)
C
C ======================================================================
C
C                             C M P A 2 1
C                             =============
C                             =============
C
C     S T A N D            :  08.01.2002
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C     M O D I F I E D:        19.11.2007 by C. Schillo
C                             DLR BRAUNSCHWEIG, FA-SM
C
C     P U R P O S E :    COMPUTES MATRIX A21 (=A12-TRANPOSED).
C     =============
C
C
C
C
C     P A R A M E T E R S :
C     ===================
C
C     INPUT :
C        A21(LONG,*)  (DOUBLE PRECISION): ARRAY STORING A21
C        LENGTH       NUMBER OF ROWS OF ARRAY A21 AS DEFINED IN THE
C                     CALLING SUBROUTINE (DIMENSION STATEMENT)
C        LONG         (.LE.LENGTH): ACTUAL NUMBER OF ROWS OF ARRAY A21
C
C     OUTPUT :
C        A21
C        IER          ERROR INDEX. IER .EQ. 0:  NO ERROR
C                                  IER .NE. 0:  ARGUMENT LONG INCORRECT
C
C     S U B R O U T I N E S CALLED:
C     =============================
C
C       IUORIV        FORM MATRIX CONTAINING NUMBERS OF DEGREES OF
C                     FREEDOM FOR AN ELEMENT (SUBDIVISION) OF BEOS
C
C       A21AST        CONTRIBUTION OF STIFFENERS
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
      INTEGER P_ITRM
      PARAMETER (P_ITRM=340)
      INTEGER, DIMENSION (1:P_ELMTS):: IKT
      REAL, DIMENSION(1:P_ITRM,P_ELMTS):: FQUAD
      INTEGER, DIMENSION(1:P_ITRM,1:3,1:P_ELMTS)::
     * KQUAD
      COMMON /F01QUA/ FQUAD, KQUAD, IKT
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
#ifndef MBEOS5
      DOUBLE PRECISION, DIMENSION(1:P_NY,1:*):: A21	 
#else
      DOUBLE PRECISION, DIMENSION(1:16*P_NODES,1:*):: A21
#endif
C
      INTEGER::           							RHO
      LOGICAL::           							VLD
      DOUBLE PRECISION :: F,F1,F2,F3,F4
      INTEGER, DIMENSION(1:4,1:4):: 			KPQ, NRS
      REAL, DIMENSION(1:4,1:4):: 				B2
      DOUBLE PRECISION, DIMENSION
     * (1:4,1:4,1:4,1:4,P_ELMTS):: 	PQRS
      INTEGER :: IELM
      INTEGER :: AB
C
      IER = 0
      IF (LONG .NE. IY) THEN
         IER = 1
         WRITE (NWRITE,5000)
         WRITE (NWRITE,5001)
         GOTO 999
      END IF
C
C      IF (STORE) THEN
C         INQUIRE (21, OPENED=OP21)
C         IF (.NOT. OP21)
C     *       OPEN (21,FILE='RCA21',STATUS='UNKNOWN',FORM='FORMATTED')
C         REWIND 21
C      END IF
      DO 10, I=1,IY
      DO 10, J=1,IX
         A21(I,J) = 0.D0
   10 CONTINUE
C
       AB=(MX-1)*(MY-1)   
C        LOOP OVER SUBDIVISIONS
      DO 9001, IYY = 1,MY-1
        DO 9000, IXX=1,MX-1
            IELM=(IXX-1)*(MY-1)+IYY  
C     LOOP OVER QUADRATIC ENERGY TERMS
C
        DO 1000, ITRM=1,IKT(IELM)
         JTRM= KQUAD(ITRM,3,IELM)
         JF1 = JTRM/10
         JF2 = MOD(JTRM,10)
C
C        EXCLUDE NON-RELEVANT TERMS
C
         VLD = .FALSE.
         DO, KKK=1,KNFUN
            VLD = VLD .OR. (JF1.EQ.KU(KKK))
         END DO
         IF (.NOT.VLD) GOTO 1000
         VLD = .FALSE.
         DO, KKK=1,KNFUN
            VLD = VLD .OR. (JF2.EQ.KU(KKK))
         END DO
         IF (.NOT.VLD) GOTO 1000
         IF (JF1 .EQ. 1) THEN
            IF (JF2 .EQ. 1) THEN
               VLD = .FALSE.
            ELSE
               KQ1 = KQUAD(ITRM,1,IELM)
               KQ2 = KQUAD(ITRM,2,IELM)
            END IF
         ELSE
            IF (JF2 .EQ. 1) THEN
               JF2 = JF1
               JF1 = 1
               KQ1 = KQUAD(ITRM,2,IELM)
               KQ2 = KQUAD(ITRM,1,IELM)
            ELSE
               VLD = .FALSE.
            END IF
         END IF
         IF (.NOT.VLD) GOTO 1000
C
         MUE = MOD(KQ1,10)
         NUE = MOD(KQ1,100)/10
         LAM = MOD(KQ2,10)
         RHO = MOD(KQ2,100)/10
         IPA = NUE + RHO - 1
         IPB = MUE + LAM - 1
C
C     FOR USE AS SUBSCRIPS NUE,...,LAM ARE INCREMENTED
         MUE = MUE + 1
         NUE = NUE + 1
         RHO = RHO + 1
         LAM = LAM + 1
C
C        COMPUTE PART THAT IS INDEPENDENT OF SUBDIVISION SIZE
C        STORE IT IN ARRAY PQRS
         F = FQUAD(ITRM,IELM)*FA
         IF (DABS(F) .LT. 1.D-20) GOTO 1000
C
         DO 620, IS=1,4
         DO 618, IQ=1,4
            F1 = F*(S1(NUE,IQ,RHO,IS) + S2(NUE,IQ,RHO,IS))
            DO 616, IR=1,4
               F2 = F1*B1(IR,IS)
               DO 614, IP=1,4
                  IF (PQRS(IP,IQ,IR,IS,IELM).LE.1.D-20) THEN
                    PQRS(IP,IQ,IR,IS,IELM)=0.0
                  END IF
                  PQRS(IP,IQ,IR,IS,IELM) =
     *            F2*(S1(MUE,IP,LAM,IR) + S2(MUE,IP,LAM,IR))*B1(IP,IQ)
  614          CONTINUE
  616       CONTINUE
  618    CONTINUE
  620    CONTINUE
C
C***     TEST AUSGABE!!!!
C                    WRITE (NWRITE,5009)
C
            SMB = B(IYY)
            F1 = 1.D0/(SMB**IPB)
               SMA = A(IXX)
               F2 = F1/(SMA**IPA)
               CALL IUORIV(IYY,IXX,JF1,KPQ, IER)
                  IF (IER .NE. 0) THEN
                     WRITE (NWRITE,5000)
                     WRITE (NWRITE,5002)
                     STOP
                  END IF
               CALL IUORIV(IYY,IXX,JF2,NRS, IER)
                  IF (IER .NE. 0) THEN
                     WRITE (NWRITE,5000)
                     WRITE (NWRITE,5002)
                     STOP
                  END IF
C               DO 700, I=1,4
C               DO 700, J=1,4
C                  IF (NRS(I,J) .NE. 0) NRS(I,J) = NRS(I,J) - IX
C  700          CONTINUE
C
C              COMPUTE MATRIX B2(4,4)
C
               DO 702, I=1,3,2
                  B2(1,I)   = 1.0
                  B2(1,I+1) = SMA
                  B2(I,1)   = 1.0
                  B2(I+1,1) = SMB
  702          CONTINUE
               DO 710, I=2,4
               DO 710, J=2,4
                  B2(I,J) = B2(1,J)*B2(I,1)
  710          CONTINUE
C
C              LOOPS OVER S,Q,R,P
C
               DO 803, IP=1,4
               DO 802, IQ=1,4
                  KKPQ = KPQ(IP,IQ)
                  IF (KKPQ .EQ.0) GOTO 802
                  F3 = F2*B2(IP,IQ)
                  DO 801, IR=1,4
                  DO 800, IS=1,4
                     NLRS = NRS(IR,IS)
                     IF (NLRS. EQ. 0) GOTO 800
                     F4 = F3*B2(IR,IS)*PQRS(IP,IQ,IR,IS,IELM)
C                    UPDATE MATRIX
                     A21(NLRS,KKPQ) = A21(NLRS,KKPQ) + 0.5D0*F4
C***     TEST AUSGABE!!!!
C                    WRITE (NWRITE,*) A21(NLRS,KKPQ)
  800             CONTINUE
  801             CONTINUE
  802          CONTINUE
  803          CONTINUE
 1000   CONTINUE
 9000  CONTINUE
 9001  CONTINUE
C
C    ADD CONTRIBUTION OF STIFFENERS
C
      IF (NOX .GT. 0) THEN
         CALL A21AST('X',A21, IERR)
            IF (IERR .NE. 0) THEN
               WRITE (NWRITE,5000 )
               WRITE (NWRITE,5003 )
               IER = 3
               GOTO 999
            END IF
      END IF
      IF (NOY .GT. 0) THEN
         CALL A21AST('Y',A21, IERR)
            IF (IERR .NE. 0) THEN
               WRITE (NWRITE,5000 )
               WRITE (NWRITE,5004 )
               IER = 4
               GOTO 999
            END IF
      END IF
C
C      IF (STORE) THEN
C         DO 1010, J=1,IX
CKS          WRITE (21) (A21(I,J),I=1,IY)
C             WRITE (21, '(8D16.6)')   (A21(I,J),I=1,IY)
C 1010    CONTINUE
C      END IF
C
  999 RETURN
 5000 FORMAT(1X,'MESSAGE FROM CMPA21:')
 5001 FORMAT(1X,'WRONG NUMBER OF ROWS SPECIFIED FOR A21')
 5002 FORMAT(1X,'ERROR IN SUBROUTINE IUORIV')
 5003 FORMAT(1X,'ERROR IN SUBROUTINE A21AST,X-DIRECTION')
 5004 FORMAT(1X,'ERROR IN SUBROUTINE A21AST,Y-DIRECTION')
 5009 FORMAT(1x,'GLOBAL STIFFNESS MATRIX A21')
C     END OF SUBROUTINE CMPA21
      END
