C     Last change:  BG   21 Feb 2005    3:02 pm
      SUBROUTINE CMPA22(A22, IER)
C
C ======================================================================
C
C                             C M P A 2 2
C                             =============
C                             =============
C
C     S T A N D            :  04.03.2001
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C     M O D I F I E D:        19.11.2007 by C. Schillo
C                             DLR BRAUNSCHWEIG, FA-SM
C
C     Z W E C K :    COMPUTES MATRIX A22
C     ===========
C
C
C     P A R A M E T E R S :
C     ===================
C
C     INPUT :
C        A22(N22)  ARRAY STORING A22
C        N22       DIMENSION OF ARRAY A22
C
C     OUTPUT :
C        A22
C        IER                  ERROR INDEX
C                             IER=0:    NO ERROR ENCOUNTERED
C                             IER=1:    ERROR IN SUBROUTINE IUORIV
C                             IER=2:    ERROR IN SUBROUTINE IUORIV
C                             IER=3:    ERROR IN SUBR. A22AST, X-DIRECT.
C                             IER=4:    ERROR IN SUBR. A22AST, Y-DIRECT.
C
C
C     S U B R O U T I N E S CALLED
C     =============================
C
C     IUORIV                  FORM MATRIX CONTAINING NUMBERS OF DEGREES
C                             OF FREEDOM FOR AN ELEMENT (SUBDIVISION)
C                             OF BEOS
C     A22AST                  ADD CONTRIBUTION OF STIFFENERS
C                             TO MATRIX A22

C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C      
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
      INTEGER, DIMENSION(1:P_NX):: LVTRI,LVB
      INTEGER, DIMENSION(1:P_NY):: LVA22
      COMMON /COMLV/  LVTRI,LVA22,LVB
C
C
      INTEGER P_ITRM, M
      PARAMETER (P_ITRM=340)
      INTEGER, DIMENSION (1:P_ELMTS):: IKT
      REAL, DIMENSION(1:P_ITRM,P_ELMTS):: FQUAD
      INTEGER, DIMENSION(1:P_ITRM,1:3,1:P_ELMTS):: KQUAD
      COMMON /F01QUA/ FQUAD, KQUAD, IKT
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C
      INTEGER:: NREAD,NWRITE,NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
      DOUBLE PRECISION, DIMENSION(*):: A22
C
      INTEGER::           RHO
C      LOGICAL::           STORE, OP22, VLD
      LOGICAL::           VLD
      DOUBLE PRECISION :: F,F1,F2,F3,F4
      INTEGER, DIMENSION(1:4,1:4):: KPQ, NRS
      REAL, DIMENSION(1:4,1:4):: B2
      DOUBLE PRECISION, DIMENSION
     * (1:4,1:4,1:4,1:4,1:P_ELMTS):: PQRS
C
      INTEGER :: AB
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IER = 0
C      IF (STORE) THEN
C         INQUIRE (22, OPENED=OP22)
CKS      IF (.NOT. OP22) OPEN (22, FILE='RCA22',FORM='UNFORMATTED')
C         IF (.NOT. OP22) OPEN (22, FILE='RCA22',FORM='FORMATTED')
C         REWIND 22
C      END IF
      LNGA22=LVA22(IY) + IY
      DO, I=1,LNGA22
         A22(I) = 0.D0
      END DO
C
C
      AB=(MX-1)*(MY-1)
      DO 9001, IYY = 1,MY-1
         DO 9000, IXX=1,MX-1
           IELM=(IXX-1)*(MY-1)+IYY
C     LOOP OVER QUADRATIC ENERGY TERMS
C
      DO 1000, ITRM=1,IKT(IELM)
         JTRM= KQUAD(ITRM,3,IELM)
         JF1 = JTRM/10
         JF2 = MOD(JTRM,10)
C
C        EXCLUDE NON-RELEVANT TERMS
C
         VLD = .FALSE.
         DO, KKK=1,KNFUN
            VLD = VLD .OR. (JF1.EQ.KU(KKK))
         END DO
         IF (.NOT.VLD) GOTO 1000
         VLD = .FALSE.
         DO, KKK=1,KNFUN
            VLD = VLD .OR. (JF2.EQ.KU(KKK))
         END DO
         IF (.NOT.VLD) GOTO 1000
         IF (JF1 .LE. 1 .OR. JF2 .LE. 1) GOTO 1000
C
         MUE = MOD(KQUAD(ITRM,1,IELM),10)
         NUE = MOD(KQUAD(ITRM,1,IELM),100)/10
         LAM = MOD(KQUAD(ITRM,2,IELM),10)
         RHO = MOD(KQUAD(ITRM,2,IELM),100)/10
         IPA = NUE + RHO - 1
         IPB = MUE + LAM - 1
C
C        FOR USE AS SUBSCRIPTS MUE,...,LAM ARE INCREMENTED
         MUE = MUE + 1
         NUE = NUE + 1
         RHO = RHO + 1
         LAM = LAM + 1
C
            F = FQUAD(ITRM,IELM)*FA
            IF (DABS(F) .LT. 1.D-20) GOTO 1000
C
C        COMPUTE PART THAT IS INDEPENDENT OF SUBDIVISION SIZE
C        STORE IT IN ARRAY PQRS
C
         DO 620, IS=1,4
         DO 618, IQ=1,4
            F1 = F*(S1(NUE,IQ,RHO,IS) + S2(NUE,IQ,RHO,IS))
            DO 616, IR=1,4
               F2 = F1*B1(IR,IS)
               DO 614, IP=1,4
               PQRS(IP,IQ,IR,IS,IELM) =
     *         F2*(S1(MUE,IP,LAM,IR)+ S2(MUE,IP,LAM,IR))*B1(IP,IQ)
  614          CONTINUE
  616       CONTINUE
  618    CONTINUE
  620    CONTINUE
C
C
            SMB = B(IYY)
            F1 = 1.D0/(SMB**IPB)
               SMA = A(IXX)
               F2 = F1/(SMA**IPA)
               CALL IUORIV(IYY,IXX,JF1,KPQ, IERR)
                  IF (IERR .NE. 0) THEN
                     IER = 1
                     WRITE (NWRITE,5000)
                     WRITE (NWRITE,5001)
                     GOTO 999
                  END IF
C               DO 690, I=1,4
C               DO 690, J=1,4
C                  IF (KPQ(I,J) .NE. 0) KPQ(I,J) = KPQ(I,J) - IX
C  690          CONTINUE
               IF (JF2 .NE. JF1) THEN
                  CALL IUORIV(IYY,IXX,JF2,NRS, IERR)
                     IF (IERR .NE. 0) THEN
                        IER = 2
                        WRITE (NWRITE,5000)
                        WRITE (NWRITE,5001)
                        GOTO 999
                     END IF
C                  DO 695, I=1,4
C                  DO 695, J=1,4
C                     IF (NRS(I,J) .NE. 0) NRS(I,J) = NRS(I,J) - IX
C  695             CONTINUE
               ELSE
                  DO 698, I=1,4
                  DO 698, J=1,4
                     NRS(I,J) = KPQ(I,J)
  698             CONTINUE
               END IF
C
C              COMPUTE MATRIX B2(4,4)
C
               DO 702, I=1,3,2
                  B2(1,I)   = 1.0
                  B2(1,I+1) = SMA
                  B2(I,1)   = 1.0
                  B2(I+1,1) = SMB
  702          CONTINUE
               DO 710, I=2,4
               DO 710, J=2,4
                  B2(I,J) = B2(1,J)*B2(I,1)
  710          CONTINUE
C
C              LOOPS OVER S,Q,R,P
C
               DO 803, IP=1,4
               DO 802, IQ=1,4
                  KKPQ = KPQ(IP,IQ)
                  IF (KKPQ .EQ. 0) GOTO 802
                  F3 = F2*B2(IP,IQ)
                  DO 801, IR=1,4
                  DO 800, IS=1,4
                     NLRS = NRS(IR,IS)
                     IF (NLRS. EQ. 0) GOTO 800
                     F4 = F3*B2(IR,IS)*PQRS(IP,IQ,IR,IS,IELM)
C                    UPDATE MATRIX
                     IF (NLRS .GE. KKPQ) THEN
                        IA22 = LVA22(NLRS) + KKPQ
                     ELSE
                        IA22 = LVA22(KKPQ) + NLRS
                     END IF
                     IF (NLRS .EQ. KKPQ) THEN
                        A22(IA22) = A22(IA22) + F4
                     ELSE
                        A22(IA22) = A22(IA22) + 0.5D0*F4
                     END IF
C                  *** TEST AUSGABE!!!!
C                     WRITE (*,*)IA22,A22(IA22)
  800             CONTINUE
  801             CONTINUE
  802          CONTINUE
  803          CONTINUE
 1000    CONTINUE
 9000   CONTINUE
 9001   CONTINUE
C
C     TEST AUSGABE!!!!
C      DO II=2,52
C        JJ=LVA22(II)
C      WRITE (NWRITE,*) A22(JJ)
c      END DO
C      JJ=0
C      DO II=1,99
C        JJ=JJ+II
C      WRITE(NWRITE,*)'A22'
C      DO JJ=1,300
C       WRITE(NWRITE,*)A22(JJ)
C      END DO
C ADD CONTRIBUTIONS OF STIFFENERS
C
      IF (NOX .GT. 0) THEN !hier steigt er aus
         CALL A22AST('X',A22, IERR)
            IF (IERR .NE. 0) THEN
               IER = 3
               WRITE(NWRITE,5000)
               WRITE(NWRITE,5002)
               GOTO 999
            END IF
      END IF
      IF (NOY .GT. 0) THEN
         CALL A22AST('Y',A22, IERR)
            IF (IERR .NE. 0) THEN
               IER = 4
               WRITE(NWRITE,5000)
               WRITE(NWRITE,5003)
               GOTO 999
            END IF
      END IF
CKS   IF (STORE) WRITE (22) (A22(I),I=1,LNGA22)
C      WRITE (22,'(I10,''ELEMENTE'')')   LNGA22
C      WRITE (22,'(8D16.6)')   (A22(I),I=1,LNGA22)
  999 RETURN
C
 5000 FORMAT(1X,'MESSAGE FROM SUBROUTINE A22:')
 5001 FORMAT(1X,'ERROR IN SUBROUTINE IUORIV')
 5002 FORMAT(1X,'ERROR IN SUBROUTINE A22AST, X-DIRECTION')
 5003 FORMAT(1X,'ERROR IN SUBROUTINE A22AST, YX-DIRECTION')
C     END SUBROUTINE CMPA22
      END

