C     Last change:  BG   21 Feb 2005    3:04 pm
      SUBROUTINE CMPBMT(BMT,LV,PMEM,FAKT, IER)
C
C ======================================================================
C
C                             C M P B M T
C                             =============
C                             =============
C
C     S T A N D            :  04.03.2001
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C
C     Z W E C K :             COMPUTES LOAD-GEOMETRIC MATRIX BMT
C     ===========
C
C
C
C     P A R A M E T E R :
C     ===================
C
C     INPUT :
C        BMT(*)               (DOUBLE PRECISION)
C                             ARRAY STORING BMT. MATRIX IS UPDATED AND
C                             HAS TO BE INITIALISED BEFORE.
C        LV(*)                   INTEGER ARRAY SUPPORTING ADDRESSING
C                             OF MATRIX ELEMENTS
C        PMEM(P_NODES,3)          MEMBRANE FORCES
C
C        FKT                  FACTOR TO BE APPLIED ON MATRIX ELEMENTS
C
C     OUTPUT :
C        BMT(*)               UPDATED MATRIX
C        IER                  ERROR INDEX
C                             IER=0:    NO ERROR ENCOUNTERED
C                             IER=1:    ERROR IN SUBROUTINE IUORIV
C                             IER=2:    ERROR IN SUBR. BMATST, X-DIRECT.
C                             IER=3:    ERROR IN SUBR. BMATST, Y-DIRECT.
C
C
C     S U B R O U T I N E S CALLED
C     =============================
C
C     IUORIV                  FORM MATRIX CONTAINING NUMBERS OF DEGREES
C                             OF FREEDOM FOR AN ELEMENT (SUBDIVISION)
C                             OF BEOS
C     BMATST                  ADD CONTRIBUTION OF STIFFENERS TO
C                             GEOMETRIC STIFFNESS MATRIX
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C
      INTEGER:: NREAD,NWRITE,NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      DOUBLE PRECISION,DIMENSION(*):: BMT
      INTEGER, DIMENSION(*):: LV
      REAL, DIMENSION(1:P_NODES,1:3):: PMEM
C
      DOUBLE PRECISION F,F1,F2,FM1,FM2,FPQ11,FPQ12,F2M1,
     *                 F4,FPQ21,FPQ22,BN1,BN2,C11,C12,C21,C22,F2M2,WNZ
      DOUBLE PRECISION,DIMENSION(1:4,1:4,1:4,1:4,1:2,1:2):: PQRS
      REAL, DIMENSION(1:4,1:4):: B2
      INTEGER          RHO

      INTEGER, DIMENSION(1:4,1:4):: KPQ
      INTEGER, DIMENSION(1:3,1:4):: NMRL
C      LOGICAL          OP24
      PARAMETER        (WNZ=1.D-25)
      DATA             NMRL/1,1,0, 0,0,1, 1,0,0, 0,1,1/
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      FKT = FAKT
      IER = 0
C      IF (STORE) THEN
C         INQUIRE (24, OPENED=OP24)
CC        IF (.NOT. OP24) OPEN (24, FILE='RCBMT')
C         IF (.NOT. OP24) OPEN (24, FILE='RCBMT',FORM='FORMATTED')
C         REWIND 24
C      END IF
C      LNGBMT = LV(IX) + IX
C     ***Test Ausgabe
C      WRITE (NWRITE,*) 'B-Matrix'
C     LOOP OVER ENERGY TERMS
C
      JF1 = 1
      DO 1000, ITRM=1,3
         NUE = NMRL(ITRM,1)+1
         MUE = NMRL(ITRM,2)+1
         RHO = NMRL(ITRM,3)+1
         LAM = NMRL(ITRM,4)+1
         IPA = NUE + RHO - 3
         IPB = MUE + LAM - 3
C
         IF (ITRM .EQ. 2) THEN
            F = FKT + FKT
         ELSE
            F = FKT
         END IF
         F = F*FA
C
C     COMPUTE PART THAT IS INDEPENDENT OF SUBDIVISION SIZE
C
      DO 220, IS=1,4
      DO 218, IQ=1,4
         FM1 = F*S1(NUE,IQ,RHO,IS)
         FM2 = F*S2(NUE,IQ,RHO,IS)
         DO 216, IR=1,4
            F2M1 = FM1*B1(IR,IS)
            F2M2 = FM2*B1(IR,IS)
            DO 214, IP=1,4
               BN1 = B1(IP,IQ)*S1(MUE,IP,LAM,IR)
               BN2 = B1(IP,IQ)*S2(MUE,IP,LAM,IR)
               PQRS(IP,IQ,IR,IS,1,1) = BN1*F2M1
               PQRS(IP,IQ,IR,IS,1,2) = BN1*F2M2
               PQRS(IP,IQ,IR,IS,2,1) = BN2*F2M1
               PQRS(IP,IQ,IR,IS,2,2) = BN2*F2M2
  214       CONTINUE
  216    CONTINUE
  218 CONTINUE
  220 CONTINUE
C
C     LOOP OVER SUBDIVISIONS
C
      DO 501, IYY=1,MY-1
         SMB = B(IYY)
         F1 = 1.D0/(SMB**IPB)
         DO 500, IXX=1,MX-1
            SMA = A(IXX)
            F2  = F1/(SMA**IPA)
            CALL IUORIV(IYY,IXX,JF1,KPQ, IER)
               IF (IER.NE.0) THEN
                  WRITE(NWRITE,5000)
                  WRITE(NWRITE,5001)
                  IER = 1
                  GOTO 999
               END IF
C
C           COMPUTE MATRIX B2
C
            DO 302, I=1,3,2
               B2(1,I)   = 1.0
               B2(1,I+1) = SMA
               B2(I,1)   = 1.0
               B2(I+1,1) = SMB
  302       CONTINUE
            DO 306, I=2,4
            DO 304, J=2,4
               B2(I,J) = B2(I,1)*B2(1,J)
  304       CONTINUE
  306       CONTINUE
C
C     MODIFIED MEMBRANE FORCES AT CORNERS OF THE SUBDIVISION
C
C            C11 = F2*PMEM(LEIT(IYY,IXX),ITRM)
C            C12 = F2*PMEM(LEIT(IYY,IXX+1),ITRM)
C            C21 = F2*PMEM(LEIT(IYY+1,IXX),ITRM)
C            C22 = F2*PMEM(LEIT(IYY+1,IXX+1),ITRM)
C     Only membrane forces from "left" side of the element are used!
            C11 = F2*PMEM(LEIT(IYY,IXX),ITRM)
            C12 = F2*PMEM(LEIT(IYY,IXX+1),ITRM)
            C21 = F2*PMEM(LEIT(IYY,IXX),ITRM)
            C22 = F2*PMEM(LEIT(IYY,IXX+1),ITRM)
            IF ((ABS(C11) .LT. WNZ .AND. ABS(C12) .LT. WNZ)
     *         .AND. (ABS(C21) .LT. WNZ .AND. ABS(C22) .LT. WNZ))
     *         GOTO 500
C
            DO 403, IP=1,4
            DO 402, IQ=1,4
               KKPQ = KPQ(IP,IQ)
               IF (KKPQ .EQ. 0) GOTO 402
               FPQ11 = C11*B2(IP,IQ)
               FPQ12 = C12*B2(IP,IQ)
               FPQ21 = C21*B2(IP,IQ)
               FPQ22 = C22*B2(IP,IQ)
               DO 401, IR=1,4
               DO 400, IS=1,4
                  NLRS = KPQ(IR,IS)
                  IF (NLRS .EQ. 0) GOTO 400
                  F4 = B2(IR,IS)*
     *                (PQRS(IP,IQ,IR,IS,1,1)*FPQ11
     *                +PQRS(IP,IQ,IR,IS,1,2)*FPQ12
     *                +PQRS(IP,IQ,IR,IS,2,1)*FPQ21
     *                +PQRS(IP,IQ,IR,IS,2,2)*FPQ22)
                  IF (NLRS .GE. KKPQ) THEN
                     K = LV(NLRS) + KKPQ
                  ELSE
                     K = LV(KKPQ) + NLRS
                  END IF
                  IF (KKPQ .EQ. NLRS) THEN
                     BMT(K) = BMT(K) + F4
                  ELSE
                     BMT(K) = BMT(K) + 0.5D0*F4
                  END IF
C     ***Test Ausgabe
C                WRITE (NWRITE,*) BMT(K)
  400          CONTINUE
  401          CONTINUE
  402       CONTINUE
  403       CONTINUE
  500    CONTINUE
  501    CONTINUE
 1000 CONTINUE
C
C     ADD CONTRIBUTION OF STIFFENERS
      IF (NOX .GT. 0) THEN
         CALL BMATST('X',BMT,LV,PMEM,FKT, IERR)
            IF (IERR .NE. 0) THEN
               WRITE (NWRITE,5000)
               WRITE (NWRITE,5002)
               IER = 2
               GOTO 999
            END IF
      END IF
      IF (NOY .GT. 0) THEN
         CALL BMATST('Y',BMT,LV,PMEM,FKT, IERR)
            IF (IERR .NE. 0) THEN
               WRITE (NWRITE,5000)
               WRITE (NWRITE,5003)
               IER = 3
               GOTO 999
            END IF
      END IF
C
CKS   IF (STORE) WRITE (24) (BMT(IBMT), IBMT=1,LNGBMT)
C      IF (STORE) WRITE (24,'(8D16.6)')   (BMT(IBMT), IBMT=1,LNGBMT)
C
  999 RETURN
C
 5000 FORMAT(/1X,'MESSAGE FROM SUBROUTINE CMPBMT:')
 5001 FORMAT(1X,'ERROR IN SUBROUTINE IUORIV')
 5002 FORMAT(1X,'ERROR IN SUBROUTINE BMATST, X-DIRECTION')
 5003 FORMAT(1X,'ERROR IN SUBROUTINE BMATST, Y-DIRECTION')
C     END OF SUBROUTINE CMPBMT
      END

