C     Last change:  BG   21 Feb 2005    2:35 pm
      SUBROUTINE CMPMMT(MMT,LV, IER)
C
C ======================================================================
C
C                             C M P M M T
C                             =============
C                             =============
C
C     S T A N D            :  23.07.2002
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C
C     Z W E C K :             COMPUTES MASS MATRIX
C     ===========
C
C
C
C
C     P A R A M E T E R S:
C     ===================
C
C     INPUT :
C        MMT(*)				   (DOUBLE PRECISION)
C									   ARRAY STORING MASS MATRIX
C
C     OUTPUT :
C        MMT
C        IER                  ERROR INDEX
C                             IER .EQ. 0:  NO ERROR
C                             IER .NE. 0:  ERROR IN SUBROUTINE CMPBMT,
C                                          WHICH IS CALLED FROM HERE
C
C     S U B R O U T I N E S CALLED
C     =============================
C
C     MMTST                  COMPUTES STIFFENER CONTRIBUTION
C
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      REAL:: DOM, PDOM
      COMMON /DENSIT/ DOM, PDOM
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
C
      DOUBLE PRECISION,INTENT(INOUT),DIMENSION(*):: MMT
      INTEGER,INTENT(IN),DIMENSION(*)::             LV
      INTEGER,INTENT(OUT)::                         IER
C
      INTEGER,DIMENSION(1:4,1:4)::    KPQ
      DOUBLE PRECISION F1,F2,F3,F4
      DOUBLE PRECISION,DIMENSION(1:4,1:4,1:4,1:4):: PQRS
      REAL, DIMENSION(1:4,1:4):: B2
      INTEGER          RHO
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IER = 0
C      IF (STORE) THEN
C        INQUIRE (26, OPENED=OP26)
C        IF (.NOT. OP26) OPEN (26, FILE='RCMMT',FORM='UNFORMATTED')
CC         IF (.NOT. OP26) OPEN (26, FILE='RCMMT',FORM='FORMATTED')
C         REWIND 26
C      END IF
      LNGMMT=LV(IX) + IX
      DO, I=1,LNGMMT
         MMT(I) = 0.0D0
      END DO
C
C     Characteristics of term
      MUE = 0
      NUE = 0
      LAM = 0
      RHO = 0
C
C     FOR USE AS SUBSCRIPTS NUE,...,LAM ARE INCREMENTED
      MUE = MUE + 1
      NUE = NUE + 1
      RHO = RHO + 1
      LAM = LAM + 1
C
C     COMPUTE PART THAT IS INDEPENDENT OF SUBDIVISION SIZE
C     STORE IT IN ARRAY PQRS
C
      F = DOM*FA
      DO, IS=1,4
      DO, IQ=1,4
         F1 = F*(S1(NUE,IQ,RHO,IS) + S2(NUE,IQ,RHO,IS))
         DO, IR=1,4
            F2 = F1*B1(IR,IS)
            DO, IP=1,4
               PQRS(IP,IQ,IR,IS) =
     *         F2*(S1(MUE,IP,LAM,IR) + S2(MUE,IP,LAM,IR))*B1(IP,IQ)
            END DO
         END DO
      END DO
      END DO
C
C        LOOP OVER SUBDIVISIONS
C
      JF1 = 1
      DO, IYY = 1,MY-1
         SMB = B(IYY)
         F1 = SMB
         DO, IXX=1,MX-1
            SMA = A(IXX)
            F2 = F1*SMA
            CALL IUORIV(IYY,IXX,JF1,KPQ, IERR)
               IF (IERR .NE. 0) THEN
                  WRITE (NWRITE,5001)
                  WRITE (NWRITE,5002)
                  IER = 2
                  STOP
               END IF
C
C           COMPUTE MATRIX B2(4,4)
C
            DO, I=1,3,2
               B2(1,I)   = 1.0
               B2(1,I+1) = SMA
               B2(I,1)   = 1.0
               B2(I+1,1) = SMB
            END DO
            DO, I=2,4
            DO, J=2,4
               B2(I,J) = B2(1,J)*B2(I,1)
            END DO
            END DO
C
C           LOOPS OVER S,Q,R,P
C
            DO, IP=1,4
            DO, IQ=1,4
               KKPQ = KPQ(IP,IQ)
               IF (KKPQ .EQ. 0) CYCLE
               F3 = F2*B2(IP,IQ)
               DO, IR=1,4
               DO, IS=1,4
                  NLRS = KPQ(IR,IS)
                  IF (NLRS. EQ. 0) CYCLE
                     F4 = F3*PQRS(IP,IQ,IR,IS)*B2(IR,IS)
C                    UPDATE MATRIX
                     IF (NLRS .GE. KKPQ) THEN
                        IMMT = LV(NLRS) + KKPQ
                     ELSE
                        IMMT = LV(KKPQ) + NLRS
                     END IF
                     IF (NLRS .EQ. KKPQ) THEN
                        MMT(IMMT) = MMT(IMMT) + F4
                     ELSE
                        MMT(IMMT) = MMT(IMMT) + 0.5D0*F4
                     END IF
               END DO
               END DO
            END DO
            END DO
         END DO
      END DO
C
C     ADD CONTRIBUTION OF STIFFENERS
C
      IF (NOX .GT. 0) THEN
         CALL MMTST('X',MMT, IERR)
            IF (IERR .NE. 0) THEN
               IER = 3
               WRITE (NWRITE,5001)
               WRITE (NWRITE,5004) 'X'
               GOTO 999
            END IF
      END IF
      IF (NOY .GT. 0) THEN
         CALL MMTST('Y',MMT, IERR)
            IF (IERR .NE. 0) THEN
               IER = 4
               WRITE (NWRITE,5001)
               WRITE (NWRITE,5004) 'Y'
               GOTO 999
            END IF
      END IF
C
C      IF (STORE) THEN
CC         WRITE (26,'(I10,'' ELEMENTE'')')   LNGMMT
C         WRITE (26) (MMT(I),I=1,LNGMMT)
C      ENDIF
  999 RETURN
C
 5001 FORMAT(/1X,'MESSAGE FROM SUBROUTINE CMPMMT: ')
 5002 FORMAT(1X,'ERROR IN SUBROUTINE IUORIV.')
 5004 FORMAT(1X,'ERROR IN SUBROUTINE MMTST. DIRECTION: ',A)
C     END OF SUBROUTINE CMPA11
      END

