C     Last change:  BG   13 Apr 2005   11:43 pm
      SUBROUTINE CNTOUR
C     Compute z-coordinates of panel shape
      IMPLICIT NONE
C
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C     COMMON blocks
C     *****************************************************************
C
C
C       / P L O T I N /
C      ===============
      REAL:: SCAL
      INTEGER :: INDPLT,NPX,NPY,ISYMX,ISYMY,NMOD
      INTEGER,DIMENSION(1:P_NGRQ):: MDSPLT
      COMMON /PLOTIN/ SCAL,INDPLT,NPX,NPY,ISYMX,ISYMY,MDSPLT,NMOD
C
C      / F 0 1 E P S /
C      ===============
      REAL, DIMENSION(1:11,1:3):: FEPS
      INTEGER, DIMENSION(1:11,1:3):: KEPS
      COMMON /F01EPS/ FEPS, KEPS
C
C      /  P L O T F L S /
C       ==================
      REAL::                              LX,LY,DX,DY
      REAL,DIMENSION(1:81)::              XPLT,YPLT
      REAL,DIMENSION(1:81,1:81)::         CNTR
      COMMON /PLOTFLS/ XPLT,YPLT,LX,LY,DX,DY,CNTR
C
C     *****************************************************************

      DOUBLE PRECISION, DIMENSION(1:4,1:3)::  PHI
      DOUBLE PRECISION, DIMENSION(1:4)::      XCORN,YCORN,EPSS
      DOUBLE PRECISION, DIMENSION(1:3)::      CK
      REAL::                                  B11,B12,B22,XP,YP
      INTEGER::                               I,J
C
C     Curvature coefficients
      B11=FEPS(1,2); B22=FEPS(2,2); B12=FEPS(3,3)!(Actually 2*B12)
C     Edge nodes' x,y-coordinates
      XCORN(1)=0.0D0;    XCORN(2)=LX;    XCORN(3)=0.0D0; XCORN(4)=LX
      YCORN(1)=0.0D0;    YCORN(2)=0.0D0; YCORN(3)=LY;    YCORN(4)=LY
C
      IF (ISYMX.EQ.+1 .or. ISYMX.EQ.-1) THEN
         XCORN(2)=2.*LX;  XCORN(4)=2.*LX
      ELSE IF (ISYMX.EQ.+2 .or. ISYMX.EQ.-2) THEN
         XCORN(1)=-LX;  XCORN(3)=-LX
      END IF
C
      IF (ISYMY.EQ.+1 .or. ISYMY.EQ.-1) THEN
         YCORN(3)=2.*LY;  YCORN(4)=2.*LY
      ELSE IF (ISYMY.EQ.+2 .or. ISYMY.EQ.-2) THEN
         YCORN(1)=-LY;  YCORN(2)=-LY
      END IF
C
C     Least-square fit to make all four edges close to CNTR=0
      DO, I=1,4
         PHI(I,1)=XCORN(I); PHI(I,2)=YCORN(I); PHI(I,3)=1.0D0
         EPSS(I)=0.5D0*(B11*XCORN(I)**2 + B12*XCORN(I)*YCORN(I)
     *                                            + B22*YCORN(I)**2)
      END DO
      CALL LQFIT(PHI,3,4,4,EPSS,CK)
C
C     Compute CNTR (z-values) for grid points
      DO, I=1,NPX+1
         XP=XPLT(I)
         DO, J=1,NPY+1
            YP=YPLT(J)
            CNTR(I,J)=0.5*(B11*XP**2+B12*XP*YP+B22*YP**2)
     *                               +CK(1)*XP+CK(2)*YP+CK(3)
         END DO
      END DO
CC     Output to file 'cntour.txt'
      REWIND 26
      WRITE (26,1003) NPX, NPY
      IF (NPY.LE.NPX ) THEN
         WRITE (26,1002) 'X'
         WRITE (26,1001) 0.0E0, (YPLT(J),J=1,NPY+1)
         DO, I=1,NPX+1
            WRITE(26,1001) XPLT(I),(CNTR(I,J),J=1,NPY+1)
         END DO
      ELSE
         WRITE (26,1002) 'Y'
         WRITE (26,1001) 0.0E0, (XPLT(J),J=1,NPX+1)
         DO, I=1,NPY+1
            WRITE(26,1001) YPLT(I),(CNTR(J,I),J=1,NPX+1)
         END DO
      END IF
      RETURN
 1001 FORMAT (1X,82(E12.4,' '))
 1002 FORMAT ('#CONTOUR. ',A1,' increases from line to line')
 1003 FORMAT ('Next line: Nmbr of grid points in x- and y-direction'/
     *         I4,' ',I4)
      END SUBROUTINE
