C ######################################################################
C
C                               CRIPPLINGT and CRIPPLINGO
C                     ###########################################
C                                       COPYRIGHT BY DLR 2007
C
C     S T A T E    :   22.08.2007
C	M O D I F I E D: 11.06.2007 by Conny Schillo
C                                 DLR BRAUNSCHWEIG, INST. FA-SM
C                                 to include crippling analysis
C
C     A U T H O R  :  Conny Schillo, DLR BRAUNSCHWEIG, INST. FA-SM
C
C
C     P U R P O S E : Calculates crippling force of T-or O-stringer profile
C     =============== based on HSB 45111-08
C
C
C     I N P U T :
C     ===========
C     Stringer geometry
C     Bending stiffness DDST
C     Clamping condition
C
C     S U B P R O G R A M S :
C     =======================
C     -
C
C ######################################################################
C      
      SUBROUTINE CRIPPLINGO(IER)
C      
      INTEGER:: NREAD,NWRITE,NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE  
C      
      DIMENSION PAX(2)
      COMMON /TEST/ PAX 
C      
C        / O S T R I N G E R /
C        ====================      
C      INTEGER :: STYPE   
      REAL :: FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,ALPHA 
      REAL, DIMENSION (1:6) :: DDST 
C 
      COMMON /STRINGERCOM/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,
     * DDST,CHORDWIDTH,CHORDTH,ALPHA
C      NAMELIST /STRINGER/ STYPE
C
C      NAMELIST /TSTRINGER/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,DDST
C     
      REAL :: HALPHA,Q,BETA,ETA,KX,FNCRIPWEB,FCRIPWEB,PI,
     * FNCRIPCHORD,FCRIPCHORD
C
C     Calculate C R I P P L I N G    F O R C E following HSB (Handbuch
C     Struktur Berechnung), 45111-08
C
      HALPHA=2.0
      Q=2.0
C
      PI=3.14159265
      BETA=(DDST(2)+2.0*DDST(6))/SQRT(DDST(1)*DDST(3))
      ETA=2.0*DDST(6)/SQRT(DDST(1)*DDST(3))      
      KX=HALPHA+Q*BETA
C
C     Caluculate "true" web height
      WEBHEIGHT=WEBHEIGHT/cos((ALPHA/2)*PI/180)       
C          
C     C R I P P L I N G   F O R C E    W E B     
      FNCRIPWEB=KX*(PI/WEBHEIGHT)**2*SQRT(DDST(1)*DDST(3))
      FCRIPWEB=FNCRIPWEB*WEBHEIGHT
C
C     C R I P P L I N G   F O R C E  C H O R D
      FNCRIPCHORD=KX*(PI/CHORDWIDTH)**2*SQRT(DDST(1)*DDST(3))
      FCRIPCHORD=FNCRIPCHORD*CHORDWIDTH
C    
      WRITE (NWRITE,3010) 
3010  FORMAT (//1x,' CRIPPLING FORCE OF WEB:')
      WRITE (NWRITE,'(E20.5)//') FCRIPWEB
      WRITE (NWRITE,3011) 
3011  FORMAT (//1x,' CRIPPLING FORCE OF CHORD:')
      WRITE (NWRITE,'(E20.5)//') FCRIPCHORD 
C
111   RETURN             
      END
