C ######################################################################
C
C                               CRIPPLINGT and CRIPPLINGO
C                     ###########################################
C                                       COPYRIGHT BY DLR 2007
C
C     S T A T E    :   22.08.2007
C	M O D I F I E D: 11.06.2007 by Conny Schillo
C                                 DLR BRAUNSCHWEIG, INST. FA-SM
C                                 to include crippling analysis
C
C     A U T H O R  :  Conny Schillo, DLR BRAUNSCHWEIG, INST. FA-SM
C
C
C     P U R P O S E : Calculates crippling force of T-or O-stringer profile
C     =============== based on HSB 45111-08
C
C
C     I N P U T :
C     ===========
C     Stringer geometry
C     Bending stiffness DDST
C     Clamping condition
C
C     S U B P R O G R A M S :
C     =======================
C     -
C
C ######################################################################
      SUBROUTINE CRIPPLINGT(IER)
C       
      INTEGER:: NREAD,NWRITE,NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE  
C      
      REAL :: PAX
      DIMENSION :: PAX(2)
      REAL :: STIFFX,EPSWEB,SIGMWEB
      COMMON /TEST/ PAX,STIFFX,EPSWEB,SIGMWEB
      INTEGER :: IER

C         / F 0 7 D I S /
C         ===============
C      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
C      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
C      INTEGER :: NOX, NOY,STYPE
C      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
C      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY,STYPE
C      
C        / T S T R I N G E R /
C        ====================      
C      INTEGER :: STYPE   
      REAL :: FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT 
      REAL, DIMENSION (1:6) :: DDST 
C 
      COMMON /STRINGERCOM/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,DDST
C      NAMELIST /STRINGER/ STYPE
C
C      NAMELIST /TSTRINGER/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,DDST
C      
      REAL :: HALPHA,Q,R,BETA,ETA,KX,FNCRIPWEB,FCRIPWEB,EPSSTR
      PARAMETER (PI = 3.1415926535897930D0)
C           
C     Calculate C R I P P L I N G    F O R C E following HSB (Handbuch
C     Struktur Berechnung), 45111-08
C
C      HALPHA=1/(ALPHA)**2
C      Q=0.0
C      R=0.608
C      PI=3.14159265
C      BETA=(DDST(2)+2.0*DDST(6))/SQRT(DDST(1)*DDST(3))
C      ETA=2.0*DDST(6)/SQRT(DDST(1)*DDST(3))
C      
C      KX=HALPHA+Q*BETA+R*ETA
      FNCRIPWEB=KX*(PI/WEBHEIGHT)**2*SQRT(DDST(1)*DDST(3))
C      FNCRIPWEB=(12/WEBHEIGHT**2)*DDST(6)
      FCRIPWEB=FNCRIPWEB*WEBHEIGHT
C    TESTTESTTEST***
      SIGMWEB=FNCRIPWEB/WEBTH
C      EPSSTR=PAX(2)/STIFFX  
C     Compute strain in stringer at crippling load
C     ***Annahme: StringerfuÃ und Web gleiches Material!!***
      EPSWEB=FCRIPWEB/(STIFFX*(WEBTH*WEBHEIGHT/(WEBTH*WEBHEIGHT+
     *FOOTWIDTH*FOOTTH)))
C      CALL GLOBALEFFECTIVEWIDTH (SIGMWEB,EPSWEB)
C######################################
      WRITE (NWRITE,3010) 
3010  FORMAT (//1x,' CRIPPLING FORCE:')
      WRITE (NWRITE,'(E20.5)//') FCRIPWEB
C      READ(*,'(A8)')
111   RETURN       
C       
      END
