C     Last change:  BG   11 Feb 2002   11:08 am
      SUBROUTINE EIGVPR(UNIT,X,M,NEIGA)
C
C ======================================================================
C
C                               E I G V P R
C                               ===========
C                               ===========
C
C     S T A N D            :  26.01.88
C
C     B E A R B E I T E R  :  SCHOUREK
C                             DFVLR BRAUNSCHWEIG, INST. WB-SM
C
C     Z W E C K :   AUSDRUCKEN DER EIGENVEKTOREN.
C     ===========   WURDE GESCHRIEBEN, UM DIE DURCH DIE EINDIMENSIONALE
C                   SPEICHERUNG DER EIGENVEKTOREN ERFORDERLICHE INDEX-
C                   BERECHNUNG EINZUSPAREN.
C
C
C
C     P A R A M E T E R : (REIHENFOLGE NACH DER PARAMETERLISTE)
C     ===================
C
C     EINGABE :
C     X....... (REAL*8)  (M,NEIGA)-MATRIX, ENTHAELT DIE EIGENVEKTOREN
C     M....... (INTEGER) ANZAHL DER ZEILEN DER MATRIX X
C     NEIGA... (INTEGER) ANZAHL DER SPALTEN DER MATRIX X,
C                        (ENTSPRICHT DER ANZAHL DER EIGENVEKTOREN)
C
C     AUSGABE :
C     ........
C
C     U N T E R P R O G R A M M E :
C     =============================
C     ........
C
C     H I N W E I S E :
C     =================
C
C     ........
C
C ======================================================================
C
      DOUBLE PRECISION X(M,NEIGA)
      INTEGER UNIT
      CHARACTER*4      FORM(10), FORMA(6)
C
      DATA  FORM / '(1H0',  ',4X,',  '''DOF',  ''',7X',  ',6(''',
     &             'EIGE',  'NMOD',  'E '',',  'I2,5',   'X)) '/,
     &     FORMA /  ',1(''',   ',2(''',   ',3(''',
     &              ',4(''',   ',5(''',   ',6('''/
C
      JU = 1
      JO = 6
C
C     KOPFZEILE DRUCKEN
   50 IF ( JO.GT.NEIGA )   JO = NEIGA
      JP = JO - JU + 1
      FORM(5) = FORMA(JP)
      WRITE (UNIT,FORM)   (J1,J1=JU,JO)
C
C     DRUCKEN DER EIGENVEKTOREN  JU BIS JO
      DO 100     I=1,M
         WRITE (UNIT,9000)   I,(X(I,J),J=JU,JO)
  100 CONTINUE
C
C     ABFRAGE, OB ALLE EIGENVEKTOREN GEDRUCKT
      IF ( JO.EQ.NEIGA )   GOTO 500
C
C     ZAEHLER JU UND JO ERHOEHEN
      JU = JU + 6
      JO = JO + 6
      GOTO 50
C
 9000 FORMAT (1H ,I6,E21.7,5E17.7)
C
  500 RETURN
      END

