C     Last change:  DBG  27 Dec 2001    2:23 pm
      SUBROUTINE F01KTF (C,CH,BB,DD,BD,RR,DR,BR,SS)
C                                                                               
C ######################################################################        
C                                                                               
C                               F 0 1 K T F
C                               ###########                                     
C                               ###########        COPYRIGHT BY DLR 1991        
C                                                                               
C     S T A T E    :  27.12.2001
C                                                                               
C     A U T H O R  :  K. ROHWER, DLR BRAUNSCHWEIG, INST. WB-SM
C                     Changed by B.Geier
C                                                                               
C     P U R P O S E : ASSIGN STIFFNESSES TO C AND CH, RESPECTIVELY,
C     =============== WITHOUT TRANSFORMATION
C                     STORE UPPER TRIANGLE ROW-WISE
C                                                                               
C     A R G U M E N T S :                                                       
C     ===================                                                       
C                                                                               
C     INPUT   : BB  MEMBRANE STIFFNESSES
C               BD  MEMBRANE-BENDING COUPLING STIFFNESSES
C               BR  MEMBRANE-BENDING CORRECTION COUPLING STIFFNESSES
C               DD  BENDING STIFFNESSES
C               DR  BENDING-BENDING CORRECTION COUPLING STIFFNESSES
C               RR  BENDING CORRECTION STIFFNESSES
C               SS  TRANSVERSE SHEAR STIFFNESSES
C
C     C O M M O N B L O C K S :                                                 
C     =========================                                                 
C                                                                               
C     OUTPUT  :                                                                 
C     /SHLSTF/   
C       C(45)     SHELL STIFFNESSES
C                 MEMBRANE, BENDING, BENDING CORRECTION AND COUPLING
C                 UPPER TRIANGLE, ROW-WISE
C       CH(3)     TRANSVERSE SHEAR STIFFNESSES, UPPER TRIANGLE
C                                                                               
C     I N D I C A T I O N S :                                                   
C     =======================                                                   
C                                                                               
C ######################################################################        
C
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C   
C        / F 0 7 I N A /
C        ===============
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
      REAL, DIMENSION(45,P_ELMTS):: C
      REAL, DIMENSION(3,P_ELMTS) :: CH                                                                            
      REAL, DIMENSION (6,P_ELMTS):: BB,BD,DD,BR,DR,RR
      REAL, DIMENSION(3,P_ELMTS):: SS
      INTEGER :: AB
C  
      AB=(MX-1)*(MY-1)
      DO IELM=1,AB                                                                             
C                        MEMBRANSTEIFIGKEITEN                                   
      C(1,IELM) = BB(1,IELM)                                                              
      C(2,IELM) = BB(2,IELM)                                                              
      C(3,IELM) = BB(4,IELM)                                                              
      C(10,IELM) = BB(3,IELM)                                                             
      C(11,IELM) = BB(5,IELM)                                                             
      C(18,IELM) = BB(6,IELM)                                                             
C                        KOPPLUNG MEMBRAN-BIEGUNG                               
      C(4,IELM) = BD(1,IELM)                                                              
      C(5,IELM) = BD(2,IELM)                                                              
      C(6,IELM) = BD(4,IELM)                                                              
      C(12,IELM) = BD(2,IELM)                                                             
      C(13,IELM) = BD(3,IELM)                                                             
      C(14,IELM) = BD(5,IELM)                                                             
      C(19,IELM) = BD(4,IELM)                                                             
      C(20,IELM) = BD(5,IELM)                                                             
      C(21,IELM) = BD(6,IELM)                                                             
C                        BIEGESTEIFIGKEITEN                                     
      C(25,IELM) = DD(1,IELM)                                                             
      C(26,IELM) = DD(2,IELM)                                                             
      C(27,IELM) = DD(4,IELM)                                                             
      C(31,IELM) = DD(3,IELM)                                                             
      C(32,IELM) = DD(5,IELM)                                                             
      C(36,IELM) = DD(6,IELM)                                                             
C                        KOPPLUNG MEMBRAN-BIEGEKORREKTUR                        
      C(7,IELM) = BR(1,IELM)                                                              
      C(8,IELM) = BR(2,IELM)                                                              
      C(9,IELM) = BR(4,IELM)                                                              
      C(15,IELM) = BR(2,IELM)                                                             
      C(16,IELM) = BR(3,IELM)                                                             
      C(17,IELM) = BR(5,IELM)                                                             
      C(22,IELM) = BR(4,IELM)                                                             
      C(23,IELM) = BR(5,IELM)                                                             
      C(24,IELM) = BR(6,IELM)                                                             
C                        KOPPLUNG BIEGUNG-BIEGEKORREKTUR                        
      C(28,IELM) = DR(1,IELM)                                                             
      C(29,IELM) = DR(2,IELM)                                                             
      C(30,IELM) = DR(4,IELM)                                                             
      C(33,IELM) = DR(2,IELM)                                                             
      C(34,IELM) = DR(3,IELM)                                                             
      C(35,IELM) = DR(5,IELM)                                                             
      C(37,IELM) = DR(4,IELM)                                                             
      C(38,IELM) = DR(5,IELM)                                                             
      C(39,IELM) = DR(6,IELM)                                                             
C                        BIEGEKORREKTURSTEIFIGKEITEN                            
      C(40,IELM) = RR(1,IELM)                                                             
      C(41,IELM) = RR(2,IELM)                                                             
      C(42,IELM) = RR(4,IELM)                                                             
      C(43,IELM) = RR(3,IELM)                                                             
      C(44,IELM) = RR(5,IELM)                                                             
      C(45,IELM) = RR(6,IELM)                                                             
C                        QUERSCHUBSTEIFIGKEITEN                                 
      CH(1,IELM) = SS(1,IELM)                                                             
      CH(2,IELM) = SS(2,IELM)                                                             
      CH(3,IELM) = SS(3,IELM)
      END DO
      RETURN                                                                    
      END                                                                       
