C ######################################################################
C
C                               GLOBALEFFECTIVEWIDTH
C                           ##########################
C                                           COPYRIGHT BY DLR 2007
C
C     S T A T E    :   22.08.2007
C	M O D I F I E D: -
C
C     A U T H O R  :  Conny Schillo, DLR BRAUNSCHWEIG, INST. FA-SM
C
C
C     P U R P O S E : Computes global buckling force based on effective width approach 
C     =============== Reference: Baker, Kovalevsky, Rish, Structural Analysis of Shells
C
C
C     I N P U T :
C     ===========
C     BY ARGUMENT:
C
C     S U B P R O G R A M S :
C     =======================
C
C
C ######################################################################
C
      SUBROUTINE GLBUCK (BB,DD,BD,IER,FSTBUG)
C      
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C      
      REAL:: PANELLENGTH,PANWTH,AFOOT,AWEB,CG,AEFSS,AEFSK,IEFF,RADGYR,
     *       PI,SLENDRATIO,SIGMWEB,SIGMCO,SIGCP1,SIGPC2,NUEXY,NUEYX,
     *       KSTAR,EPSWEB,CHECK,WEFF 
      REAL:: CC,KK
C      INTEGER :: IERR
      PARAMETER (PI = 3.1415926535897930D0)
      INTEGER :: IER,II,JJ
C
      REAL:: FSTBUG
C      COMMON /TEST2/ FSTBUK
C
      INTEGER:: NREAD,NWRITE,NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE  
C      
C        / F 0 7 I N A /
C        ===============
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
C        / F 0 7 A I J /            
C        ==============
      REAL, DIMENSION(1:3,1:3):: AIJ
      COMMON /F07AIJ/ AIJ
C
C        / F 0 7 I N B /
C        ===============
      REAL :: RX, RY, RXY
      REAL, DIMENSION(1:6,*):: BB, DD, BD
      COMMON /F07INB/ RX,RY,RXY
C      ,BB,DD,BD
C      
C    G L O B A L  B U C K L I N G  D A T A
C    =====================================
      REAL :: SKINTH,STPITCH
      COMMON /GLBUCKCOM/ SKINTH,STPITCH
C   
      REAL :: PAX
      DIMENSION :: PAX(2)
      REAL :: STIFFX
      COMMON /TEST/ PAX,STIFFX,EPSWEB,SIGMWEB
C      
C        T S T R I N G E R   &   O S T R I N G E R 
C       / S T R I N G E R C O M /
C       ====================
      REAL :: FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,CHORDWIDTH,CHORDTH,ALPHA 
      REAL, DIMENSION (1:6) :: DDST
      COMMON /STRINGERCOM/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,DDST
C     * ,CHORDWIDTH,CHORDTH,ALPHA
C	 
C      
C     CLAMPING CONDITION : SIMPLY SUPPORTED
      CC=1
C     PRE-COMPUTATIONS
C
      ASTRINGER=FOOTTH*FOOTWIDTH+WEBTH*WEBHEIGHT
      AFOOT=FOOTTH*FOOTWIDTH
	  AWEB=WEBTH*WEBHEIGHT
	  AEFSK=0
	  AEFSS=AFOOT+AWEB
	  SIGCP1=0
	  WEFF=0
	  CHECK=100
C	
	  PANELLENGTH=0
	  II=1
	  DO WHILE (A(II).NE.0) 
	    PANELLENGTH = PANELLENGTH+A(II)
	    II=II+1
        END DO
       PANWTH=0
       JJ=1
        DO WHILE (B(JJ).NE.0)
          PANWTH = PANWTH+B(JJ)
          JJ=JJ+1  
        END DO
C
      NUEXY=AIJ(2,1)/AIJ(1,1)
      NUEYX=AIJ(1,2)/AIJ(2,2)
C     Shell parameter
      OMEG=STPITCH/(sqrt(RY*SKINTH))*((12*(1-NUEXY*NUEYX))**0.25/PI)
      IF (OMEG.LE.2)THEN
        KK=4+OMEG**4/4
       ELSE
        KK=2*OMEG**2
      END IF
      KSTAR=KK*PI**2/(12*(1-NUEXY*NUEYX))
C    
      II=0
      DO  
      SIGCP2=SIGCP1
      II=II+1
C     Step 1: Determine radius of gyration	 
      CG=(AFOOT*(FOOTTH/2+SKINTH)+AWEB*(WEBHEIGHT/2+SKINTH+FOOTTH)+
     *AEFSK*(SKINTH/2))/(AFOOT+AWEB+AEFSK)

      IEFF=(FOOTWIDTH*FOOTTH**3)/12+(SKINTH+FOOTTH/2-CG)**2*AFOOT+
     *(WEBTH*WEBHEIGHT**3)/12+(SKINTH+FOOTTH+WEBHEIGHT/2-CG)**2*AWEB
     *+(WEFF*SKINTH**3)/12+(SKINTH/2-CG)**2*AEFSK
C 
      RADGYR = sqrt(IEFF/AEFSS)
C	  
C     STEP 2: Determine effective slenderness ratio L'/rho  
	  SLENDRATIO = PANELLENGTH/(RADGYR*sqrt(CC))
C
C     STEP 3: CRIPPLING STRESS / **TORSIONAL STRESS**
      SIGMCO=SIGMWEB
C     STEP 4: Record value for SigmaCp
C***************!!!!!!!! SUBSCRIPT OF BB WRONG!!!!!!!!!!!!!!!!
      SIGCP1=SIGMCO-SIGMCO**2*(SLENDRATIO**2)/(4*(PI**2)*
     *(BB(1,1)*(1-NUEXY*NUEYX)/SKINTH))
      CHECK=-100+SIGCP2/SIGCP1*100  
      IF ((CHECK < 1).AND.(CHECK.GT.0))THEN
        IER=0
       EXIT
      END IF
      IF ((II.EQ.100).OR.(SIGPC1.LT.0))THEN
        IER=11
        EXIT
      END IF
C     STEP 5: Effective width
      WEFF=sqrt(KSTAR*(BB(1,1)*(1-NUEXY*NUEYX)/SKINTH)/SIGCP1)*SKINTH
C      WEFFECTIVE=(EPSSKN/EPSSTR)**(1/3)
      AEFSK=SKINTH*WEFF
C
      AEFSS=ASTRINGER+AEFSK
C      
C     STEP 6: Compute rho of stiffener+effective width
      END DO
C
      FGBUCK=SIGCP1*(AFOOT+AWEB+WEFF*SKINTH)
      FGBUCK=(FGBUCK+FSTBUG*(STPITCH-WEFF))*(PANWTH/STPITCH)
C     */PANWTH
C
C     P R I N T  R E S U L T 
      WRITE (NWRITE,4010) 
4010  FORMAT (//1x,' GLOBAL BUCKLING LOAD:')
      WRITE (NWRITE,'(E20.5)//') FGBUCK
C      READ(*,'(A8)')
222   RETURN   
      END