C     Last change:  BG   13 Mar 2006    4:20 pm
C
      SUBROUTINE INCS3(LONG,BB,DD,BD,RR,DR,BR,SS,IER,FSTBUI)
C
C ======================================================================
C
C                               I N C S 3
C                               ===========
C                               ===========
C
C     S T A T E :            : 24.10.2005
C
C     B E A R B E I T E R  :  DR. B. GEIER
C                             DFVLR BRAUNSCHWEIG, INST. WB-SM
C     M O D I F I E D      : 08.06.2007
C							 Conny Schillo
C                            DLR BRAUNSCHWEIG, INST. FA-SM
C
C     Z W E C K :    PREPARES EIGENVALUE PROBLEM AND SUBMITS TO SOLVER.
C     ===========    PRINTS EIGENVALUES AND EIGENVECTORS AND, OPTIONALLY,
C                    MEMBRANE AND SIFFENER FORCES
C
C
C
C     A R G U M E N T S :
C     ===================
C
C     INPUT:       LONG  Actually used number of lines
C                        of matrix A21=A12**T.
C                        LONG MUST BE EQUAL TO IY.
C     OUTPUT:      IER   Error index
C
C     S U B P R O G R A M S
C     =====================
C     CHODEC..  CHOLESKY-decomposition of the symmetric Band matrix A:
C                            A=> R**(TRANSP)*R
C               A will be destroyed and replaced by R.
C
C     CHOSOL..  Equation solution using decomposed matrix, for m
C               right hand sides => Xnew from R**(Transp)*A *Xnew = Xold
C               Xnew replaces Xold
C
C
C     SIMVIT..  Computation of eigenvalues and modes of the problem
C                  (A - LAMBDA * B) * X = 0
C               by simultaneous inverse iteration
C     EIGVPR..  Prints modes
C
C
C
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C     DUMMY ARGUMENTS
      INTEGER::    LONG
      INTEGER::   IER
      REAL:: FSTBUI
C      COMMON /TEST2/FSTBUK
C
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: RX, RY, RXY
      REAL, DIMENSION(1:6,*):: BB, DD, BD
      COMMON /F07INB/ RX,RY,RXY
C      ,BB,DD,BD
C
      REAL, DIMENSION(1:P_NODES,1:3):: PVAR, PFEST
      COMMON /CPVAR/  PVAR
      COMMON /CPFEST/ PFEST
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
      DOUBLE PRECISION, DIMENSION(1:P_NGIT):: ELAM
      COMMON /VALUS/  ELAM

      REAL, DIMENSION(1:3,1:3):: AIJ
      COMMON /F07AIJ/ AIJ
C
      INTEGER, DIMENSION(1:P_NX):: LVTRI,LVB
      INTEGER, DIMENSION(1:P_NY):: LVA22
      COMMON /COMLV/  LVTRI,LVA22,LVB
C
      DOUBLE PRECISION, DIMENSION(1:P_LA22):: A22
      DOUBLE PRECISION, DIMENSION(1:P_LA11):: A11
      DOUBLE PRECISION, DIMENSION(1:P_LB11):: B11
      DOUBLE PRECISION, DIMENSION(1:P_NY,1:P_NX):: A21
      COMMON /MATRIX/ A22,A11,B11,A21
C
      DOUBLE PRECISION, DIMENSION(1:P_NX,1:P_NGIT):: X
      COMMON /VECTRS/ X
C      
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
      LOGICAL:: DRVEK
      INTEGER:: IZU
      COMMON /F07HIL/ DRVEK,IZU
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*28 FQ
      CHARACTER*2 FP(3)
      CHARACTER*26 FNT
      DIMENSION PHILF(6)
C
      REAL, DIMENSION(1:6,*) :: RR, DR, BR
      REAL, DIMENSION(1:3,*) :: SS
C  
C     results for python
      DOUBLE PRECISION, DIMENSION(1:(P_NGIT),1:5):: membraneforces
      COMMON /PYTHRES/ membraneforces
C
      DOUBLE PRECISION, DIMENSION(1:IX*(IX+1)/2):: A11TR
C
C     AUTOMATIC ARRAYS
      DOUBLE PRECISION, DIMENSION(1:LONG):: ZZ, AUX, HILY
      DOUBLE PRECISION, DIMENSION(1:LONG):: X2
      INTEGER, DIMENSION(1:LONG):: ISUBSC
C
      DOUBLE PRECISION  EPSILN
      LOGICAL OP25,PCC
C
C      DATA FQ/'(1H0',',10X',',''ME','MBRA','NE F','ORCE','S  N',
C     *    'X'' )'/ ,FP/'X'' )','XY'')','Y '')'/
C      DATA FMT/'(/11','X,2(','10X,','3HIX','=,I1',',5X)',')   '/,
C     *       F/'X,1(','X,2(','X,3(','X,4(','X,5(','X,6('/
C
      DATA FQ/'(/10X,''MEMBRANE FORCES NX '')'/, FP/'X ','XY','Y'/
      DATA FNT/'(/11X, (10X,''IX='',I2,4X),)'/
C
C      PARAMETER (PI = 3.1415926535897930D0)
CC++++++++++++++++++For Test only: Test A11 for definitness++++++++++*
C                    IER =0
C                    ISIZA = IX*(IX+1)
C                    ISIZA = ISIZA/2
C                    DO LALALA=1,ISIZA
C                       A11TR(LALALA) = A11(LALALA)
C                    END DO
C                    CALL CHODEC(A11TR,IX,IX,LVTRI,IER)
C            WRITE (NWRITE,'("After CHOLESKY of A11TR: IER=",I4)') IER
CC++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IER = 0
C
      IF (KNFUN.GT.1) THEN
C
         IER=0
         IBDDY = IBDY
         CALL CHODEC(A22,IY,IBDDY,LVA22,IER)
            IF ( IER.NE.0 )   THEN
               WRITE (NWRITE,9900) IER
               WRITE (*,9900) IER
               IER = 1
               GOTO 9999
            END IF
C
C-----------------------------------------------------------------------
C        Condensation of eigenvalue problem
C
C        For later usage the columns of matrix (A22**-1)*A21
C        are written to file 25
         INQUIRE (25, OPENED=OP25)
         IF (.NOT. OP25) THEN
          OPEN (25, FILE='RCA25',FORM='UNFORMATTED')
         END IF
         REWIND 25
C
C     	INITIALISE SUBSCRIPT VECTOR
      	DO , I=1,LONG
         	ISUBSC(I)=I
      	END DO
      	K=1
      	AUX = A21(ISUBSC,1)
      	ZZ=AUX
      	CALL CHOSOL(A22,IY,IBDDY,LVA22,ZZ,1,HILY)
      	WRITE (25) ZZ
      	A11(K)=A11(K) - DOT_PRODUCT(ZZ,AUX)
      	DO, J=2,IX
         	ZZ = A21(ISUBSC,J)
         	CALL CHOSOL(A22,IY,IBDDY,LVA22,ZZ,1,HILY)
         	WRITE (25) ZZ
         	DO, I=1,J
            	AUX = A21(ISUBSC,I)
            	K=K+1
            	A11(K) = A11(K) - DOT_PRODUCT(ZZ,AUX)
         	END DO
      	END DO
C
C      	WRITE(NWRITE,'(" MATRIX A11 UPDATED")')
CC++++++++++++++++++For Test only: Test A11 for definitness++++++++++++
C                    IER =0
C                    ISIZA = IX*(IX+1)
C                    ISIZA = ISIZA/2
C                    DO LALALA=1,ISIZA
C                       A11TR(LALALA) = A11(LALALA)
C                    END DO
C                    CALL CHODEC(A11TR,IX,IX,LVTRI,IER)
C         WRITE (NWRITE,'("After scd CHOLESKY of A11TR: IER=",I4)') IER
CC+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      	IF ( ITAB.NE.0 ) THEN
      		WRITE (NWRITE,8990)   (A11(I),I=1,LVTRI(IX)+IX)
 8990 		FORMAT (1X,T36,'UPDATED MATRIX A11'/(1X,7D17.6))
         END IF
      END IF
C
C-----------------------------------------------------------------------
C
C     S O L V E   E I G E N V A L U E   P R O B L E M
C     (A11(I,J) - ELAM(K)*B11(I,J))  *  X(J,K) = 0
C+++++++++++++++++++TEST 11.06.01+++++++++++++++++++++++++++++++++
C      WRITE (NWRITE,'("  PART OF MATRIX A11")')
C      CALL PRTAB(A11,LVTRI,ISTY(2),MY,NWRITE)
C      WRITE (NWRITE,'("  PART OF MATRIX B11")')
C      CALL PRTAB(B11,LVB,ISTY(2),MY,NWRITE)
C      STOP
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IBDB  = IBDX
      EPSILN = 1.0D-08
      CALL SIMVIT(NEIGRQ,NEIGIT,A11,B11,IX,IX,IBDB,LVTRI,LVB,EPSILN,
     &            ELAM,X(:IX,:NEIGIT),JAC,IP, LVTRI, IER)
         IF (IER .NE. 0) THEN
            WRITE (NWRITE,9910)         
            WRITE (*,9910)
            IER = 2
            GOTO 9999
         END IF
C
      FSTBUI=ELAM(1)*PVAR(1,1)+PFEST(1,1)
C      WRITE (NWRITE,9009)FSTBUI
 9009 FORMAT(/1X,'Test 1.BL = ',6E19.6)
C     STATISTICS OF INVERSE POWER METHOD AND COMPUTED EIGENVALUES
      WRITE (NWRITE,9000)   IP,JAC,EPSILN
C
      WRITE (NWRITE,9005)
C     CONSTANT MEMBRANE FORCES?
      PCC = .TRUE.
      NND = MX*MY
      DO I=1,3
      	PV1 = PVAR(1,I); PF1=PFEST(1,I)
        DO J=2,NND
           VDEL=ABS(PVAR(J,I)-PV1); FDEL=ABS(PFEST(J,I)-PF1)
           PCC=PCC.AND.(VDEL.LT.1.E-20.AND.FDEL.LT.1.E-20)
        END DO
      END DO
      IF (PCC)  THEN
      	DO I=1,NEIGRQ
      	   WRITE(NWRITE,9006) I,ELAM(I),ELAM(I)*PVAR(1,1)+PFEST(1,1),
     &       ELAM(I)*PVAR(1,2)+PFEST(1,2),ELAM(I)*PVAR(1,3)+PFEST(1,3)
      	END DO
      ELSE
        DO I=1,NEIGRQ
      	    WRITE (NWRITE,9008) I,ELAM(I)
      	END DO
      END IF
C
C     COPY EIGENVECTORS INTO ARRAY Y
C      DO 204 I=1,
C         Y(I) = 0.0D0
C  204 CONTINUE
C      LLLL = 0
C      DO 210  I=1,NEIG
C         KKK = (I-1)*400
C         DO 205 J=1,IX
C            KKK = KKK + 1
C            LLLL= LLLL + 1
C            Y(KKK) = X(LLLL)
C  205    CONTINUE
C  210 CONTINUE
C
C     C A L C U L A T E   AND   P R I N T  MEMBRANE FORCES
      IF (MEMPRI )  THEN
      DO   240        I = 1, NEIGRQ
        WRITE (NWRITE,9060)   I
        RZ = ELAM(I)
        DO 2371 II = 1,3
          FQ (24:25) = FP ( II )
          WRITE (NWRITE,FQ )
          KK = 0
          KZ = 6
          DO 2371 JJ = 1,MX,6
            KK = KK + 6
            IF (KK .LE. MX)   GOTO 220
            KK = MX
            KZ = MX - JJ + 1
  220       WRITE (FNT(7:7),'(I1)') KZ
            WRITE (NWRITE,FNT)   (K, K = JJ, KK)
            DO  237   K = 1, MY
              L = 0
              DO  235   J = JJ, KK
                L = L + 1
  235           PHILF(L) = PVAR(LEIT(K,J),II)*RZ + PFEST(LEIT(K,J),II)
  237         WRITE (NWRITE,9070) K,(PHILF(J),J = 1,L)
            membraneforces(I,II)=PHILF(1)
 2371       WRITE (NWRITE,9030)
        IF (NOX.EQ.0.AND.NOY.EQ.0) GOTO 240
        WRITE (NWRITE,9080) I
        IF (NOX.EQ.0) GOTO 2380
        WRITE (NWRITE,9090)
        KK = 0
        KZ = 6
        DO 2378 JJ = 1,MX,6
          KK = KK + 6
          IF (KK.LT.MX) GOTO 2372
          KK = MX
          KZ = MX-JJ+1
 2372     WRITE (FNT(7:7),'(I1)') KZ
          WRITE (NWRITE,FNT) (K,K=JJ,KK)
          DO 2378 K = 1,NOX
            L = 0
            LL = ISTX(K)
            DO 2376 MM = JJ,KK
              L = L + 1
              H = 0.
C             C LEIT== transformation of grid coordinates to node number
C              LE = LEIT(LL,MM)
              DO 2374 NN = 1,3
C               PVAR,PFEST have order (NX,NXY,NY); AIJ order (X,Y,XY)
                NP = NN
                IF (NN.EQ.2) NP = 3
                IF (NN.EQ.3) NP = 2
C                AIJ is skin compliance; thus PVAR and PFEST must be used 
C                from a skin-only location
 2374           H = H + AIJ(NN,1) * (PVAR(1,NP)*RZ+PFEST(1,NP))
 2376         PHILF(L) = H*STEIFX(1,K)
 2378       WRITE (NWRITE,9070) LL,(PHILF(J),J = 1,L)
        membraneforces(I,4)=PHILF(1)
 2380   CONTINUE
        IF (NOY.EQ.0) GOTO 240
        WRITE (NWRITE,9100)
        KK = 0
        KZ = 6
        DO 2388 JJ = 1,NOY,6
          KK = KK + 6
          IF (KK.LT.NOY) GOTO 2382
          KK = NOY
          KZ = NOY - JJ + 1
 2382     WRITE (FNT(7:7),'(I1)') KZ
          WRITE (NWRITE,FNT) (ISTY(K),K = JJ,KK)
          DO 2388 K = 1,MY
            L = 0
            DO 2386 MM = JJ,KK
              L = L + 1
              LL = ISTY(MM)
C              LE = LEIT(K,LL)
              H = 0.
              DO 2384 NN = 1,3
C               PVAR,PFEST have order (NX,NXY,NY); AIJ order (X,Y,XY)
                NP = NN
                IF (NN.EQ.2) NP = 3
                IF (NN.EQ.3) NP = 2
C                AIJ is skin compliance; thus PVAR and PFEST must be used 
C                from a skin-only location
 2384           H = H + AIJ(NN,2)*(PVAR(1,NP)*RZ+PFEST(1,NP))
 2386         PHILF(L) = H * STEIFY(1,MM)
            membraneforces(I,5)=PHILF(1)
 2388       WRITE (NWRITE,9070) K,(PHILF(J),J = 1,L)
C       
C       P R I N T   X - EIGENVECTORS
  240   WRITE (NWRITE,9030)

      END IF
C
C  245 WRITE (NWRITE,9010)
      WRITE (NWRITE,9010)
      DRVEK = .TRUE.
      IZU = 0
      CALL EIGVPR(NWRITE,X(1:IX,1:NEIGRQ),IX,NEIGRQ)
C **********************************************************************
C      IF (N0)   GOTO 5000
C      IF (.NOT. X2PRI )   GOTO 5000
      IF ( X2PRI.AND. IY .GT.0 )  THEN
C
C     C O M P U T E   AND   P R I N T   SECOND PARTS OF EIGENVECTORS
C     I. E. FREEDOMS DESCRIBING U,V,BETA,GAMMA: X2(I,K)=-AUX(I,J)*X(J,K)
C
      WRITE (NWRITE,9020)
      WRITE (NWRITE,9021)
      REWIND 25
      DO  330     L=1,NEIGRQ
C         SET ELEMENTS OF VECTOR  X2  TO ZERO
          DO 300     I=1,IY
             X2(I) = 0.0D0
  300     CONTINUE
C         READ  IX  VECTORS OF (A22**-1)*X AND COMPUTE  X2
          DO 320     J=1,IX
             READ (25)   AUX
             DO 310     I=1,IY
                X2(I) = X2(I) - AUX(I)*X(I,J)
  310        CONTINUE
  320     CONTINUE
C         PRINT THE L-TH EIGENVECTOR
          WRITE (NWRITE,9040)   L
          WRITE (NWRITE,9050)   (X2(I),I=1,IY)
  330 CONTINUE
      END IF
C
 9999 RETURN
 9000 FORMAT(///'1',' STATISTICS OF INVERSE POWER METHOD:'//,
     &       5X,'IP=',I3,', JAC =',I3/,
     &       5X,'MAXIMUM CONTAMINATION OF HIGHER EIGENVECTORS BY LOWER',
     &       ' ONES: EPSILN =',E12.4//)
      WRITE (NWRITE,'(A6)') 'Hallo1'
 9005 FORMAT(' COMPUTED EIGENVALUES:'/)
      WRITE (NWRITE,'(A6)') 'Hallo2'
 9006 FORMAT (1X,I3,'.   LAMBDA=',6E19.6,',     NX=',6E19.6,
     &                       ', NXY=',6E19.6,', NY=',6E19.6)
 9008 FORMAT(1X,I5,'. EIGENVALUE =',6E19.6)
 9010 FORMAT(/1X,'X-EIGENVECTORS DESCRIBING NORMAL DISPLACEMENT W')
 9020 FORMAT(/1X,'X2-EIGENVECTORS DESCRIBING TANGENTIAL DISPLACEMENTS')
 9021 FORMAT(1X, 'AND TRANSVERSE SHEAR STRAINS')
 9030 FORMAT (///)
 9040 FORMAT (1H0,' EIGENMODE ',I2)
 9050 FORMAT (1H ,5D20.8)
 9060 FORMAT(/1H0,'MEMBRANE FORCES AT THE ',I5,' . EIGENVALUE')
 9070 FORMAT (1H ,7X,'IY=',I1,6E19.7)
 9080 FORMAT(/1H0,'FORCES IN STIFENERS AT THE',I5,' . EIGENVALUE')
 9090 FORMAT(1H0,10X,'STIFFENERS IN X-DIRECTION')
 9100 FORMAT(1H0,10X,'STIFFENERS IN Y-DIRECTION')
 9550 FORMAT (///2H0 ,
     &       'COMPUTED EIGENVALUES :'///
     &       (1H ,7X,' EIGENVALUE',I3,':',D14.6,' =',D14.6,' HZ'))
 9900 FORMAT (/,' SUBROUTINE INCS3: CHOLESKY DECOMPOSITION ',
     &            'OF MATRIX A22 FAILED. IER= ',I5)
 9910 FORMAT (1X,'SUBROUTINE INCS3: ERROR ENCOUNTERED IN SUBR: SIMVIT')
C      End Subroutine INCS3
      END
