C     Last change:  BG   17 Nov 2004    2:24 pm
      SUBROUTINE LQFIT (PHI,IJ,K,M,EPSS,AK)
C
C ######################################################################
C
C                               L Q F I T
C                               ##########
C                               ##########       COPYRIGHT BY DFVLR 1988
C
C     S T A T E    :  12.04.2004
C
C     A U T H O R  :  B. GEIER, U. RENKEN,
C                      DFVLR BRAUNSCHWEIG, INST. WB-SM
C
C     P U R P O S E : BESTIMMUNG DER KOEFFIZIENTEN AK(J) DER
C     =============== FEHLERGLEICHUNGEN
C                        PHI(I,J) * AK(J) + EPSS(I) = 0.0
C                        I = 1, K    ,    J = 1, IJ
C                     DURCH ORTHOGONALISIEREN DER SPALTEN VON PHI(I,J).
C                     (LEAST SQUARE FIT BY ORTHOGONOLIZATION)
C
C     A R G U M E N T S :
C     ===================
C
C     INPUT   :
C     PHI..... (DOUBLE)  (K,IJ)-MATRIX
C     IJ...... (INTEGER) ANZAHL DER UNBEKANNTEN
C     K....... (INTEGER) ANZAHL DER GLEICHUNGEN
C     M....... (INTEGER) KANTENLAENGE (=VEREINBARTE ZEILENZAHL)
C                        DES FELDES PHI
C     EPSS.... (DOUBLE)  VEKTOR DER LAENGE K, NEGATIVE RECHTE SEITE
C     IJK..... (INTEGER) KANTENLAENGE (=VEREINBARTE ZEILENZAHL)
C                        DER HILFSMATRIX A
C     OUTPUT  :
C     PHI..... (DOUBLE)  (K,IJ)-MATRIX
C     AK...... (DOUBLE)  ERGEBNISVEKTOR DER LAENGE IJ
C
C     O U T P U T   V I A   F I L E   6 :
C     ===================================
C
C     AUSGABE VON FEHLERMELDUNGEN AUF DEM DRUCKER.
C
C     S U B P R O G R A M S :
C     =======================
C
C     QVSKPX.. BERECHNUNG EINES SKALARPRODUKTES
C
C     I N D I C A T I O N S :
C     =======================
C
C     THEORETISCHE GRUNDLAGEN S. BUCH VON SCHWARZ/RUTISHAUSER/STIEFEL:
C     NUMERIK SYMMETRISCHER MATRIZEN. STUTTGART 1968: B.G. TEUBNER
C
C ######################################################################
C
      IMPLICIT NONE
C     ARGUMENTS:
      INTEGER,INTENT(IN)::IJ,K,M   
	  DOUBLE PRECISION,DIMENSION(1:M,*)::PHI
      DOUBLE PRECISION,DIMENSION(*)::AK,EPSS

C     AUTOMATIC ARRAY:
      DOUBLE PRECISION,DIMENSION(1:IJ,1:IJ):: A
C
      DOUBLE PRECISION:: GRENZW,C
      INTEGER:: I,J,L,LL
      PARAMETER (GRENZW=1.D-30)
C
      DO 7, L=1,IJ
         IF (L .EQ. 1) GOTO 4
         LL = L - 1
         DO 3, J=1,LL
            C = DOT_PRODUCT(PHI(:K,J),PHI(:K,L))
            DO 2, I=1,K
               PHI(I,L) = PHI(I,L) - C * PHI(I,J)
    2       CONTINUE
            A(J,L) = C
    3    CONTINUE
    4    C = SQRT(DOT_PRODUCT(PHI(:K,L),PHI(:K,L)))
         IF (C .GE. GRENZW) GOTO 50
         WRITE(6,1000) L,(A(J,L),J=1,LL)
 1000 FORMAT(1H ,' LQFIT: SPALTE',I4,' IST LINEAR ABHAENGIG'/
     1          ('       KOEFF=',8E15.4))
         A(L,L) = 1.D0
         GOTO 7
   50    A(L,L) = C
         DO 6, I=1,K
            PHI(I,L) = PHI(I,L) / C
    6    CONTINUE
    7 CONTINUE
      DO 9, J=1,IJ
         AK(J) = DOT_PRODUCT(PHI(1:K,J),EPSS(1:K))
    9 CONTINUE
      J = IJ
      AK(J) = -AK(J) / A(J,J)
      LL = IJ - 1
      DO 11, L=1,LL
         J = J - 1
         AK(J) = (-AK(J) - DOT_PRODUCT(A(J,J+1:),AK(J+1:IJ)))/A(J,J)
   11 CONTINUE
      RETURN
      END
