!     Last change:  DBG  13 Dec 2001    3:33 pm
      SUBROUTINE MKLVBD(LV,NN,IBD,IER)
!
!     MAKE AUXILIARY VECTOR FOR ACCESS TO DENSELY STORED TRIANGULAR
!     OR SYMMETRIC MATRICES.
!
!     ARGUMENTS
!     LV(NN)         AUXILIARY VECTOR THAT WILL BE ESTABLISHED IN THIS
!                    SUBROUTINE
!     NN             DIMENSION OF LV
!     IBD            BAND WIDTH OF THE MATRIX FOR WHICH LV IS TO BE USED
!                    IBD = MAXIMUM NUMBER ELEMENTS TO THE RIGHT OF
!                    (AND INCLUDING) THE DIAGONAL
!     IER            ERROR INDICATOR, WILL BE SET TO ZERO IN CASE OF
!                    COMPATIBLE ARGUMENTS NN AND IBD.
!
!     ALL ARGUMENTS ARE OF TYPE INTEGER
!
!
      DIMENSION LV(*)
      N    = NN
      IB   = IBD
      IER  = 1
      IF((IB .LE. N) .AND. (N .GT. 1)) THEN
         IER   = 0
         IBM1 = IB - 1
         LV(1) = 0
         IF (IB .GT. 1) THEN
            DO 30, I=2,IB
               IM1   = I - 1
               LV(I) = LV(IM1) + IM1
   30       CONTINUE
         END IF
         IF (N .GT. IB) THEN
            DO 50, I=IB+1,N
               IM1   = I - 1
               LV(I) = LV(IM1) + IBM1
   50       CONTINUE
         END IF
      END IF
      RETURN
!     END OF SUBROUTINE MKLVBD
      END

