C     Last change:  BG   18 Nov 2004    4:20 pm
      SUBROUTINE MMTST(XORY,MMT, IER)
C
C ======================================================================
C
C                             M M T S T
C                            ============
C                            ============
C
C     S T A N D            :  23.07.2001
C
C     B E A R B E I T E R  :  DR.-ING. BODO GEIER
C                             DLR BRAUNSCHWEIG, INST. WB-SM
C
C     Z W E C K :             ADDS CONTRIBUTION OF STIFFENERS
C     ===========             TO MASS MATRIX
C
C
C     P A R A M E T E R S :
C     ===================
C
C     INPUT :
C        XORY                 (CHARACTER*1)
C                             DECIDES WHETHER TO TREAT STIFFENERS
C                             RUNNING IN X-DIRECTION (XORY .EQ. 'X')
C                             OR Y-DIRECTION (XORY .EQ. 'Y')
C        MMT(*)               (DOUBLE PRECISION) MATRIX TO BE UPDATED
C
C     OUTPUT :
C        MMT
C        IER                  ERROR INDEX
C                             IER=0:  NO ERROR
C                             IER=1:  ARGUMENT XORY NEITHER 'X' NOR 'Y'
C                             IER=2:  ERROR FROM SUBROUTINE KUORKV
C
C     S U B R O U T I N E  CALLED
C     =============================
C        KUORKV               FINDS DOFS FOR SECTION OF STIFFENER
C
C     C O M M O N  B L O C K S :
C     ==========================
C ======================================================================
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: SA, SB, FA, FS
      REAL, DIMENSION(1:4,1:4):: B1
      COMMON /F07PD/  SA,SB,FA,B1,FS
C
      INTEGER, DIMENSION(1:P_NX):: LVTRI,LVB
      INTEGER, DIMENSION(1:P_NY):: LVA22
      COMMON /COMLV/  LVTRI,LVA22,LVB
C
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * (1-ZETA)
      REAL, DIMENSION(1:3,1:4,1:3,1:4):: S1, S2
      COMMON /F07IN1/ S1
C     INTEGRALS OVER POLYNOMIAL PRODUCTS * ZETA
      COMMON /F07IN2/ S2
C
      INTEGER:: NREAD,NWRITE,NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
C     DUMMY ARGUMENTS
      CHARACTER*1,INTENT(IN)::                      XORY
      DOUBLE PRECISION,DIMENSION(*),INTENT(INOUT):: MMT
      INTEGER,INTENT(OUT)::                         IER
C
C     INTERNAL VARIABLES
      DOUBLE PRECISION::               F2,F3,F4
      INTEGER::                        RHO
      INTEGER,DIMENSION(1:2,1:4)::     KPQ
      REAL,DIMENSION(1:4)::            BX
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IER = 0
      JFCT = 1
      IF (XORY .EQ. 'X') THEN
         IMA  = NOX
         IIMA = MX - 1
      ELSE IF (XORY .EQ. 'Y') THEN
         IMA  = NOY
         IIMA = MY - 1
      ELSE
         IER = 1
         WRITE (NWRITE,2000)
         WRITE (NWRITE,2001)
         GOTO 999
      END IF
         RHO = 0
         NUE = 0
C         IXP = NUE + RHO - 1
C        FOR USE AS MATRIX SUBSCRIPTS NUE, RHO ARE INCREMENTED BY 1
         NUE = NUE + 1
         RHO = RHO + 1
C
C     LOOP OVER STIFFENERS
C
      DO 800, I=1,IMA
C       Get MASS FACTOR.
         IF (XORY .EQ. 'X') THEN
            FQ   = DOMX(I)
            III  = ISTX(I)
         ELSE IF (XORY .EQ. 'Y') THEN
            FQ   = DOMY(I)
            III  = ISTY(I)
         END IF
         IF (ABS(FQ) .LT. 1.D-30) GOTO 800
C
C        LOOP OVER TERMS (ONE TERM ONLY, NO LOOP)
C        LOOP OVER SUBDIVISIONS
         DO 500, II = 1,IIMA
C           TO ESTABLISH MATRIX BX(4) USE MATRIX B1 (COMMON/F07PD)
            BX(1) = B1(1,1)
            IF (XORY .EQ. 'X') THEN
               RA = A(II)
               BX(2) = B1(1,2)*RA
            ELSE
               RA = B(II)
               BX(2) = B1(2,1)*RA
            END IF
C            F2 = FQ/RA**IXP; SINCE IXP=-1 USE NEXT STATEMENT
            F2 = FQ*RA
            BX(3) = BX(1)
            BX(4) = BX(2)
            CALL KUORKV(XORY,III,II,JFCT,KPQ, IER)
               IF (IER .NE. 0) THEN
                  WRITE (NWRITE,2000)
                  WRITE (NWRITE,2002) III,II
                  IER = 2
                  GOTO 999
               END IF
C
C           INTERPOLATION LOOPS
            DO 400, IS=1,4
               F3 = F2*BX(IS)
               JLS = KPQ(1,IS)
               IF (JLS .EQ. 0) GOTO 400
               DO 300, IQ=1,4
                  KMQ = KPQ(1,IQ)
                  IF (KMQ .EQ. 0) GOTO 300
                  F4  =
     *            F3*BX(IQ)*(S1(NUE,IQ,RHO,IS)+S2(NUE,IQ,RHO,IS))
C                 UPDATE MATRIX
                  IF (JLS .GE. KMQ) THEN
                     IMMT = LVB(JLS) + KMQ
                  ELSE
                     IMMT = LVB(KMQ) + JLS
                  END IF
                  IF (JLS .EQ. KMQ) THEN
                     MMT(IMMT) = MMT(IMMT) + F4
                  ELSE
                     MMT(IMMT) = MMT(IMMT) + 0.5D0*F4
                  END IF
  300          CONTINUE
  400       CONTINUE
  500    CONTINUE
  800 CONTINUE

  999 RETURN
C
 2000 FORMAT(/1X,'MESSAGE FROM SUBROUTINE MMTST:')
 2001 FORMAT(1X,'INADMISSIBLE FIRST ARGUMENT, NEITHER ''X'' NOR ''Y''')
 2002 FORMAT(1X,'ERROR RETURN FROM KUORKV, I=',I4,' J=',I4)
      END SUBROUTINE MMTST
