C     Last change:  BG   28 Mar 2007   12:45 pm
      SUBROUTINE MODES(IER)
C
C     *****************************************************************
C     For Propgram BEOS:
C     Establish file 26 required to plot mode shapes KK(1:NN)
C     State: 19.07.04
C     Author: Dr. B. Geier, DLR WB-SM
C     Changed by C. Schillo, DLR BS SM
C     08.05.07
C
C     Argument:
C     NN       Number of modes (how many) to be plotted
C     KK(1:N)  Mode numbers (which) to be plotted
C     IER      Error index (IER=0 means 'No error')
C
      IMPLICIT NONE
      INTEGER:: IER
C     *****************************************************************
C
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C       / P L O T I N /
C      ===============
      REAL:: SCAL
      INTEGER :: INDPLT,NPX,NPY,ISYMX,ISYMY,NMOD
      INTEGER,DIMENSION(1:P_NGRQ):: MDSPLT
      COMMON /PLOTIN/ SCAL,INDPLT,NPX,NPY,ISYMX,ISYMY,MDSPLT,NMOD
C
C      /  P L O T F L S /
C       ==================
      REAL::                              LX,LY,DX,DY
      REAL,DIMENSION(1:81)::              XPLT,YPLT
      REAL,DIMENSION(1:81,1:81)::         CNTR
      COMMON /PLOTFLS/ XPLT,YPLT,LX,LY,DX,DY,CNTR
C
C      / F 0 7 I N A /
C      ===============
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
C      /V E C T R S /
C     ===============
      DOUBLE PRECISION, DIMENSION(1:P_NX,1:P_NGIT):: X
      COMMON /VECTRS/ X
C
C      / D A T R A N /
C      ===============
      INTEGER:: NREAD, NWRITE, NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
C     *****************************************************************
      INTEGER:: I,J,K,N,IP,JP,IXA,IXM,IYA,IYM,IEL,JEL,IFUN,P,Q,L
      INTEGER,DIMENSION(1:4,1:4):: IU
      REAL:: FC,XEL,YEL,XP,YP,XLV,YLV,SX,SY,PI,SHP,SCLF,VALX,VALY
      REAL,DIMENSION(1:NPX+1,1:NPY+1):: MDSHP
      REAL,DIMENSION(1:4,1:4):: BPQ,B1PQ
C
      IER=0
      PI=3.141592654
      IFUN=1
      B1PQ(1,1)=1.
      B1PQ(1,2)=PI/LX
      B1PQ(2,1)=PI/LY; B1PQ(2,2)=PI**2/(LX*LY)
      B1PQ(1:2,3:4)=B1PQ(1:2,1:2)
      B1PQ(3:4,1:2)=B1PQ(1:2,1:2)
      B1PQ(3:4,3:4)=B1PQ(1:2,1:2)
      BPQ=B1PQ
      MDSHP=0.
C
      IF (ISYMX .EQ. 0) THEN
         IXA=1; IXM=NPX+1
      ELSE IF (ISYMX.EQ.2 .OR. ISYMX.EQ.-2) THEN
         IXA=NPX/2+1; IXM=NPX+1
      ELSE IF (ISYMX.EQ.1 .OR. ISYMX.EQ.-1) THEN
         IXA=1; IXM=NPX/2+1
      END IF
C
      IF (ISYMY .EQ. 0) THEN
         IYA=1; IYM=NPY+1
      ELSE IF (ISYMY.EQ.2 .OR. ISYMY.EQ.-2) THEN
         IYA=NPX/2+1; IYM=NPX+1
      ELSE IF (ISYMY.EQ.1 .OR. ISYMY.EQ.-1) THEN
         IYA=1; IYM=NPX/2+1
      END IF
C
      DO, L=1,NMOD
      K=MDSPLT(L)
      MDSHP=0.
      DO, IP=IXA,IXM
         XP=XPLT(IP)
         XEL=0.
         DO, I=1,MX
            XLV=XEL
            XEL=XEL+A(I)
            IF(XP .LE. XEL) THEN
               IEL=I
               SX=(XP-XLV)/A(I)
               BPQ(:,(/2,4/))=A(I)*B1PQ(:,(/2,4/))
               EXIT
            END IF
         END DO
         DO, JP=IYA,IYM
            YP=YPLT(JP)
            YEL=0.
            DO, I=1,MY
               YLV=YEL
               YEL=YEL+B(I)
               IF(YP .LE. YEL) THEN
                  JEL=I
                  SY=(YP-YLV)/B(I)
                  BPQ((/2,4/),:)=B(I)*B1PQ((/2,4/),:)
                  EXIT
               END IF
            END DO
            CALL IUORIV(JEL,IEL,IFUN,IU,IER)
            IF (IER. NE. 0) THEN
               WRITE (*,1001)
               WRITE (NWRITE,1001)
               GOTO 999
            END IF
            SHP=0.
            DO, P=1,4
               CALL PHI(P,SY,VALY,IER)
               IF (IER .NE. 0) THEN
C                  WRITE (NWRITE,1004)
                  WRITE (*,1004) 1, P, SY
                  GOTO 999
               END IF
               DO, Q=1,4
                  IF (IU(P,Q) .EQ. 0) CYCLE
                  CALL PHI(Q,SX,VALX,IER)
                  IF (IER .NE. 0) THEN
C                     WRITE (NWRITE,1004)
                     WRITE (*,1004) 2, Q, SX
                     GOTO 999
                  END IF
                  SHP=SHP+X(IU(P,Q),K)*BPQ(P,Q)*VALX*VALY
               END DO
            END DO
            MDSHP(IP,JP)=SHP
         END DO
      END DO
      SCLF=SCAL/MAXVAL(ABS(MDSHP(IXA:IXM,IYA:IYM)))
      MDSHP(IXA:IXM,IYA:IYM)=MDSHP(IXA:IXM,IYA:IYM)*SCLF
C     Epand, ie. evaluate symmetry conditions
      IF (ISYMX.EQ.2 .OR. ISYMX.EQ.-2) THEN
C CS: changed 1. to 1
         FC=SIGN(1,-ISYMX)
         DO, N=1,NPX/2
            MDSHP(N,IYA:IYM)=MDSHP(NPX+2-N,IYA:IYM)*FC
         END DO
      ELSE IF (ISYMX.EQ.1 .OR. ISYMX.EQ.-1) THEN
C CS: changed 1. to 1
         FC=SIGN(1,-ISYMX)
         DO, N=1,NPX/2
            MDSHP(NPX+2-N,IYA:IYM)=MDSHP(N,IYA:IYM)*FC
         END DO
      END IF
C
      IF (ISYMY.EQ.2 .OR. ISYMY.EQ.-2) THEN
C CS: changed 1. to 1
         FC=SIGN(1,-ISYMY)
         DO, N=1,NPY/2
            MDSHP(:,N)=MDSHP(:,NPY+2-N)*FC
         END DO
      ELSE IF (ISYMY.EQ.1 .OR. ISYMY.EQ.-1) THEN
C CS: changed 1. to 1      
         FC=SIGN(1,-ISYMY)
         DO, N=1,NPX/2
            MDSHP(:,NPY+2-N)=MDSHP(:,N)*FC
         END DO
      END IF
C
C      WRITE (26,1002) K
      IF (NPY.LE.NPX ) THEN
         WRITE (26,1002) K,'X'
         WRITE (26,1003) 0.0E0, (YPLT(J),J=1,NPY+1)
         DO, I=1,NPX+1
C            WRITE(26,1003) XPLT(I),(CNTR(I,J)+MDSHP(I,J),J=1,NPY+1)
            WRITE(26,1003) XPLT(I),(MDSHP(I,J),J=1,NPY+1)
         END DO
      ELSE
         WRITE (26,1002) K, 'Y'
         WRITE (26,1003) 0.0E0, (XPLT(J),J=1,NPX+1)
         DO, I=1,NPY+1
C            WRITE(26,1003) YPLT(I),(CNTR(J,I)+MDSHP(J,I),J=1,NPX+1)
            WRITE(26,1003) YPLT(I),(MDSHP(J,I),J=1,NPX+1)
         END DO
      END IF
      END DO
  999 RETURN
 1001 FORMAT (1X,'Message from subroutine MODES:'/
     *            ' Error return from IUORIV')
 1002 FORMAT (' MODE ',I2,'. ',A1,' increases from line to line')
 1003 FORMAT (1X,82(E12.4,' '))
 1004 FORMAT (1X,'Message from SUBROUTINE MODES:'/
     *            ' Error return from PHI. Call/Args: ',2I3, F8.4)
C      END OF SUBROUTINE MODES
      END SUBROUTINE
