C     Last change:  BG   28 Mar 2007    1:29 pm
      SUBROUTINE PHI(I,Z,VAL, IER)
C     Evaluate Hermitean interpolation polynomials
C     State: 20.07.04
C     Author: Dr. B.Geier, DLR WB-SM
C     There are four polynomial PH(1)...PHI(4). The first argument, I,
C     indicates which polynomial has to be evaluated.
C     The second argument, Z, has to be between 0. and 1. and indicates
C     for which argument the polynomial has to be evaluated.
C     VAL is the result. IER is an error index.
C
      IMPLICIT NONE
      INTEGER:: I,IER
      REAL::    Z,VAL,EP
C
      IER=0; EP=0.00001
      IF (Z.LT.-EP .OR. Z.GT.1.0+EP) THEN
         IER =1; GOTO 999
      END IF
      SELECT CASE (I)
         CASE (1)
            VAL=(2.*Z-3.)*Z*Z+1.
         CASE (2)
            VAL=((Z-2.)*Z+1.)*Z
         CASE (3)
            VAL=(-2.*Z+3.)*Z*Z
         CASE (4)
            VAL=(Z-1.)*Z*Z
         CASE DEFAULT
            IER=2
      END SELECT
  999 RETURN
C     END OF SUBROUTINE PHI
      END SUBROUTINE
