C     Last change:  BG   21 Feb 2005    2:40 pm
      SUBROUTINE PRTOUT (BB,DD,BD,RR,DR,BR,SS)                                                        
C                                                                               
C ######################################################################        
C                                                                               
C                               P R T O U T
C                               ###########                                     
C                               ###########        COPYRIGHT BY DLR 2001
C     S T A T E    :  28.08.2001
C                                                                               
C     A U T H O R  : Dr. B. Geier DLR Braunschweig, Inst. WB-SM
C                    Program is based on a subroutine written by
C                    K. Rohwer, DLR Braunschweig, Inst. WB-SM
C                                                                               
C     P U R P O S E : CHECK OUTPUT OF INPUT DATA
C     =============== 
C                                                                               
C     C O M M O N B L O C K S :                                                 
C     =========================                                                 
C                                                                               
C     INPUT   :                                                                 
C     DATRAN..                                                                  
C                                                                               
C     OUTPUT  :                                                                 
C     MAN.....                                                                  
C     F07INA..                                                                  
C     F07INB..                                                                  
C     CPVAR ..  PVAR(P_NODES,3)  DISTRIBUTION OF VARIABLE MEMBRANE FORCES
C     CPFEST..  PFEST(P_NODES,3) DISTRIBUTION OF PRESCRIBED MEMBRANE FORCES
C     F07INC..
C     F07IND..                                                                  
C     F07INE..                                                                  
C     F07ANG..                                                                  
C     F07DIS..                                                                  
C     F07MAT..                                                                  
C                                                                               
C
C     I N D I C A T I O N S :                                                   
C     =======================                                                   
C                                                                               
C     ----                                                                      
C     ----                                                                      
C     ----                                                                      
C                                                                               
C ######################################################################        
C                                                                               
      EQUIVALENCE  (RX,RADII(1))
C     Parameters used in BEOS
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
      CHARACTER*1  KZEI(6)
      CHARACTER*4  DISFMT(12),DISFX,DISFY,FORCE(4),FORCEC(2,3),
     *             FORFMT(7),FORCON(6)                                          
      CHARACTER*8  EDGFMT(5),EDGBEG(4),EDGCON(3,3),                             
     *             RADFMT(4),RADBEG(3),RADCON(2,2)                              
C                                                                               
      DIMENSION   HH(9),IDHH(9),RADII(3)
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: RX, RY, RXY
      REAL, DIMENSION(1:6,*):: BB, DD, BD
      COMMON /F07INB/ RX,RY,RXY
C      ,BB,DD,BD
C
      REAL, DIMENSION(1:P_NODES,1:3):: PVAR, PFEST
      COMMON /CPVAR/  PVAR
      COMMON /CPFEST/ PFEST
C
      REAL, DIMENSION(1:6,*) :: RR, DR, BR
      REAL, DIMENSION(1:3,*) :: SS
C      COMMON /F07INC/ RR,DR,BR,SS
C
      LOGICAL SEITEN
      INTEGER, DIMENSION(1:7,1:4):: KI
      INTEGER, DIMENSION(1:4,1:P_NSUP):: IDESUP
      COMMON /F07IND/ SEITEN,KI,IDESUP,NUMSUP
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
C
      INTEGER, DIMENSION(1:5,1:4,1:P_NODES):: LM
      COMMON /F07MAT/ LM
C
      REAL :: ALFAX, ALFAY
      COMMON /F07ANG/ ALFAX,ALFAY
C
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE                                       
C                                                                               
      DATA EDGFMT/'  (7X,'' ', 'Y = 0   ', '!'',12X,''', 'ANTI-SYM',            
     *            'METRY'') '/                                                  
      DATA EDGBEG/'Y = 0   ', 'X = 0   ', 'Y = LY  ', 'X = LX  '/               
      DATA EDGCON/'!'',15X,''', 'SYMMETRY', ''')      ',                        
     *            '!'',5A6, ', 'A10)    ', '        ',                          
     *            '!'',12X,''', 'ANTI-SYM', 'METRY'') '/                        
      DATA RADFMT/' (7X,  ''', 'RX  = '',', '3X,''INFI', 'NITE'')  '/           
      DATA RADBEG/'RX  = '',', 'RY  = '',', 'RXY = '','/                        
      DATA RADCON/'3X,''INFI', 'NITE'')  ', 'E14.7) ', '        '/              
      DATA DISFMT/'(///', ',1X,', '''DIS', 'CRET', 'E ST', 'IFFN',              
     *            'ESSE', 'S IN', ' Y''''', '-DIR', 'ECTI', 'ON'')'/            
      DATA DISFX/' X'''''/, DISFY/' Y'''''/                                     
      DATA FORCE/' (/3', '0X,''', 'NX'')', '    '/                              
      DATA FORCEC/'NX'')', '    ',                                              
     *            'NXY''', ')   ',                                              
     *            'NY'')', '    '/                                              
      DATA FORFMT/'(/11', 'X,2(', '10X,', '''IX=',                              
     *            ''',I2', ',4X)', ')   '/                                      
      DATA FORCON/'X,1(', 'X,2(', 'X,3(', 'X,4(', 'X,5(', 'X,6('/               
      DATA IDHH/1,2,4, 2,3,5, 4,5,6/                                            
C                                                                               
C                                                                               
C     OUTPUT OF BOUNDARY CONDITIONS                                             
C                                                                               
      IF (SEITEN)   THEN                                                        
C                             OUTPUT OF BOUNDARY CONDITIONS, EDGE-WISE          
         WRITE (NWRITE,9510)                                                    
         DO 70     J=1,4                                                        
            EDGFMT(2) = EDGBEG(J)                                               
            KEN = KI(1,J)                                                       
            IF ( KEN.LT.0 )   THEN                                              
               DO 10     I=1,3                                                  
                  IP = I + 2                                                    
                  EDGFMT(IP) = EDGCON(I,1)                                      
   10          CONTINUE                                                         
               WRITE (NWRITE,EDGFMT)                                            
            ELSE   IF ( KEN.EQ.0 )   THEN                                       
               DO 20     I=1,6                                                  
                  KZEI(I) = '-'                                                 
   20          CONTINUE                                                         
               DO 30     I=1,6                                                  
                  IP = I + 1                                                    
                  L = KI(IP,J)                                                  
                  IF ( L.GT.0 )   KZEI(L) = '0'                                 
   30          CONTINUE                                                         
               IF ( KNFUN.EQ.1 )   THEN                                         
                  DO 40     I=2,5                                               
                     KZEI(I) = '*'                                              
   40             CONTINUE                                                      
               ELSE   IF ( KNFUN.EQ.3 )   THEN                                  
                  IF ( KU(2).EQ.2 )   THEN                                      
                     KZEI(4) = '*'                                              
                     KZEI(5) = '*'                                              
                  ELSE                                                          
                     KZEI(2) = '*'                                              
                     KZEI(3) = '*'                                              
                  ENDIF                                                         
               ENDIF                                                            
               DO 50     I=1,3                                                  
                  IP = I + 2                                                    
                  EDGFMT(IP) = EDGCON(I,2)                                      
   50          CONTINUE                                                         
               WRITE (NWRITE,EDGFMT)   KZEI                                     
            ELSE                                                                
               DO 60     I=1,3                                                  
                  IP = I + 2                                                    
                  EDGFMT(IP) = EDGCON(I,3)                                      
   60          CONTINUE                                                         
               WRITE (NWRITE,EDGFMT)                                            
            ENDIF                                                               
   70    CONTINUE                                                               
      ENDIF                                                                     
C                                                                               
      IF ( NUMSUP.GT.0 )   THEN                                                 
C                                OUTPUT OF SUPPRESSED FREEDOMS                  
         WRITE (NWRITE,9520)   NUMSUP                                           
         DO 80     I=1,NUMSUP                                                   
            WRITE (NWRITE,9530)   (IDESUP(J,I),J=3,4),                          
     *                            (IDESUP(J,I),J=1,2)                           
   80    CONTINUE                                                               
      ENDIF                                                                     
C                                                                               
C     OUTPUT OF GEOMETRICAL DESCRIPTION                                         
C                                                                               
      WRITE (NWRITE,9535)   (KU(I),I=1,KNFUN)                                   
      WRITE (NWRITE,9540)   MX,MY                                               
      WRITE (NWRITE,9550)                                                       
      MXM = MX - 1                                                              
      MYM = MY - 1                                                              
      M = MIN0(MXM,MYM)                                                         
      N = MAX0(MXM,MYM)                                                         
      DO 90     I=1,M                                                           
         WRITE (NWRITE,9560)   A(I),B(I)                                        
   90 CONTINUE                                                                  
      IF ( M.NE.N )   THEN                                                      
         MP = M + 1                                                             
         DO 100     I=MP,N                                                      
            IF ( MXM.GT.MYM )   WRITE (NWRITE,9570)   A(I)                      
            IF ( MYM.GT.MXM )   WRITE (NWRITE,9580)   B(I)                      
  100    CONTINUE                                                               
      ENDIF                                                                     
      WRITE (NWRITE,9590)                                                       
      EDGX = 0.0                                                                
      DO 110     I=1,MXM                                                        
         EDGX = EDGX + A(I)                                                     
  110 CONTINUE                                                                  
      EDGY = 0.0                                                                
      DO 120     I=1,MYM                                                        
         EDGY = EDGY + B(I)                                                     
  120 CONTINUE                                                                  
      WRITE (NWRITE,9600)   EDGX,EDGY                                           
      WRITE (NWRITE,9610)   ALFAX,ALFAY                                         
      ALFAX = 3.1415927 * ALFAX / 180.0                                         
      ALFAY = 3.1415927 * ALFAY / 180.0                                         
      WRITE (NWRITE,9620)                                                       
      DO 140     J=1,3                                                          
         RADFMT(2) = RADBEG(J)                                                  
         K = 2                                                                  
         IF ( ABS(RADII(J)) .GT. 0.1E20 )   K = 1                               
         DO 130     I=1,2                                                       
            L = I + 2                                                           
            RADFMT(L) = RADCON(I,K)                                             
  130    CONTINUE                                                               
         IF ( K.EQ.1 )   WRITE (NWRITE,RADFMT)                                  
         IF ( K.EQ.2 )   WRITE (NWRITE,RADFMT)   RADII(J)                       
  140 CONTINUE                                                                  
C                                                                               
C     OUTPUT OF STIFFNESS COEFFICIENTS                                          
C      
      IELM=(MY-1)                                                                         
      WRITE (NWRITE,9630)                                                       
      DO 150 JJ=1,IELM
        DO I=1,9                                                          
         HH(I) = BB(IDHH(I),JJ)
        END DO
      WRITE (NWRITE,9770)   JJ                                                    
      WRITE (NWRITE,9640)   HH                                                   
  150 CONTINUE                                                                                                                        
      DO 160     JJ=1,IELM 
        DO I=1,9                                                        
         HH(I) = DD(IDHH(I),JJ)
        END DO    
      WRITE (NWRITE,9650) 
      WRITE (NWRITE,9770)   JJ                                                
      WRITE (NWRITE,9640)   HH                                                    
  160 CONTINUE                                                                  
                                                     
      DO 170     JJ=1,IELM           
        DO I=1,9                                         
         HH(I) = BD(IDHH(I),JJ)
        END DO 
       WRITE (NWRITE,9660) 
       WRITE (NWRITE,9770)   JJ   
       WRITE (NWRITE,9640)   HH                                                 
  170 CONTINUE                                                                                                     
C     FOLLOWING STATEMENTS ONLY FOR SANDWICH PLATE OR SANDWICH SHELL            
      IF ( KU(2).EQ.4 .OR. KNFUN.EQ.5 )   THEN                                  
         WRITE (NWRITE,9670)                                                    
         DO 180     I=1,9                                                      
            DO JJ=1,IELM 
            HH(I) = RR(IDHH(I),JJ)                                                 
            END DO
  180    CONTINUE                                                               
         WRITE (NWRITE,9640)   HH                                               
         WRITE (NWRITE,9680)                                                    
         DO 190     I=1,9                                                       
            DO JJ=1,IELM
            HH(I) = BR(IDHH(I),IELM)
            END DO                                                 
  190    CONTINUE                                                               
         WRITE (NWRITE,9640)   HH                                               
         WRITE (NWRITE,9690)                                                    
         DO 200     I=1,9            
            DO JJ=1,IELM                                           
            HH(I) = DR(IDHH(I),JJ)                                                 
            END DO
  200    CONTINUE                                                               
         WRITE (NWRITE,9640)   HH
C	   
	   DO JJ=1,IELM                                               
		 WRITE (NWRITE,9700)                                                    
		 WRITE (NWRITE,9645)   SS(1,JJ), SS(2,JJ), SS(2,JJ), SS(3,JJ)
	   END DO                                               
      ENDIF                                                                     
C                                                                               
C     OUTPUT OF DISCRETE STIFFNESSES                                            
C                                                                               
C      NOST = 10
C      NOX  =  0
C      DO 210     I=1,NOST
C         IF ( ISTX(I).EQ.0 )   GOTO 220
C         NOX = NOX + 1
C  210 CONTINUE
C  220 CONTINUE                                                                  
      IF ( NOX.NE.0 )   THEN                                                    
         DISFMT(9) = DISFX                                                      
         WRITE (NWRITE,DISFMT)                                                  
         WRITE (NWRITE,9710)                                                    
         DO 230     I=1,NOX                                                     
            WRITE (NWRITE,9720)   ISTX(I),(STEIFX(J,I),J=1,4)                   
  230    CONTINUE                                                               
      ENDIF                                                                     
C      NOY  =  0
C      DO 240     I=1,NOST
C         IF ( ISTY(I).EQ.0 )   GOTO 250
C        NOY = NOY + 1
C  240 CONTINUE
C  250 CONTINUE
      IF ( NOY.NE.0 )   THEN                                                    
         DISFMT(9) = DISFY                                                      
         WRITE (NWRITE,DISFMT)                                                  
         WRITE (NWRITE,9710)                                                    
         DO 260     I=1,NOY                                                     
            WRITE (NWRITE,9720)   ISTY(I),(STEIFY(J,I),J=1,4)                   
  260    CONTINUE                                                               
      ENDIF                                                                     
C                                                                               
C     OUTPUT OF PRESCRIBED MEMBRANE FORCES                                      
C                                                                               
      WRITE (NWRITE,9740)                                                       
      DO 300     II=1,3                                                         
         DO 270   K=1,2                                                         
            L = K + 2                                                           
            FORCE(L) = FORCEC(K,II)                                             
  270    CONTINUE                                                               
         WRITE (NWRITE,FORCE)                                                   
         KK = 0                                                                 
         KZ = 6                                                                 
         DO 290     K=1,MX,6                                                    
            KK = KK + 6                                                         
            IF ( KK.GT.MX )   THEN                                              
               KK = MX                                                          
               KZ = MX - K + 1                                                  
            ENDIF                                                               
            FORFMT(2) = FORCON(KZ)                                              
            WRITE (NWRITE,FORFMT)   (J,J=K,KK)                                  
            DO 280     I=1,MY                                                   
               WRITE (NWRITE,9750)   I,(PFEST(LEIT(I,J),II),J=K,KK)             
  280       CONTINUE                                                            
  290    CONTINUE                                                               
  300 CONTINUE                                                                  
C
C     OUTPUT OF DISTRIBUTION OF VARIABLE MEMBRANE FORCES                        
C                                                                               
      WRITE (NWRITE,9760)                                                       
      DO 340     II=1,3                                                         
         DO 310     K=1,2                                                       
            L = K + 2                                                           
            FORCE(L) = FORCEC(K,II)                                             
  310    CONTINUE                                                               
         WRITE (NWRITE,FORCE)                                                   
         KK = 0                                                                 
         KZ = 6                                                                 
         DO 330     K=1,MX,6                                                    
            KK = KK + 6                                                         
            IF ( KK.GT.MX )   THEN                                              
               KK = MX                                                          
               KZ = MX - K + 1                                                  
            ENDIF                                                               
            FORFMT(2) = FORCON(KZ)                                              
            WRITE (NWRITE,FORFMT)   (J,J=K,KK)                                  
            DO 320     I=1,MY                                                   
               WRITE (NWRITE,9750)   I,(PVAR(LEIT(I,J),II),J=K,KK)              
  320       CONTINUE                                                            
  330    CONTINUE                                                               
  340 CONTINUE                                                                  
C                                                                               
 9999 RETURN                                                                    
C
C     FORMAT - STATEMENTS                                                       
C                                                                               
 9510 FORMAT (///1X,'BOUNDARY CONDITIONS, EDGE-WISE'//                          
     *        7X,'0 = FIXED'/7X,'- = FREE'/                                     
     *        7X,'* = NOT SPECIFIED'//                                          
     *        7X,'BOUNDARY !',5X,'W',5X,'U',5X,'V',                             
     *        3X,'BETA  GAMMA  W,X OR W,Y'/7X,9('-'),'+',44('-'))               
 9520 FORMAT (///1X,'NUMBER OF SUPPRESSED FREEDOMS:',I7//5X,'NODE',10X,         
     *        'FUNCTION CODE NUMBER',7X,'KIND OF DERIVATIVE'/2X,                
     *        'NODY  NODX',7X,'1=W,2=U,3=V,4=BETA,5=GAMMA',4X,                  
     *        '1=F,2=FX,3=FY,4=FXY')                                            
 9530 FORMAT (1H ,I4,I6,16X,I3,23X,I3)                                          
 9535 FORMAT (///1X,'CODE NUMBERS OF THE FUNCTIONAL DOFS INVOLVED:',5I3)        
 9540 FORMAT (///1X,'NUMBER OF SUBDIVISION LINES:   IN X-DIRECTION',I5/         
     *        32X,'IN Y-DIRECTION',I5)                                          
 9550 FORMAT (//1X,'SUBDIVISION LENGTHS IN   X-DIRECTION',                      
     *        9X,'Y-DIRECTION')                                                 
 9560 FORMAT (21X,F15.5,5X,F15.5)                                               
 9570 FORMAT (21X,F15.5)                                                        
 9580 FORMAT (41X,F15.5)                                                        
 9590 FORMAT (24X,35('-'))                                                      
 9600 FORMAT (1X,'EDGE LENGTHS',8X,F15.5,5X,F15.5)                              
 9610 FORMAT (///1X,'ANGLES OF OBLIQUENESS',6X,'X''-X:',F9.4/                   
     *        28X,'Y''-Y:',F9.4)                                                
 9620 FORMAT (///1X,'SHELL CURVATURE:')                                         
 9630 FORMAT (////1X,'STIFFNESS COEFFICIENTS'//7X,'MEMBRANE')                   
 9640 FORMAT (3(1X,3E20.7/)/)                                                   
 9645 FORMAT (2(1X,2E20.7/)/)                                                   
 9650 FORMAT (1H0,6X,'BENDING')                                                 
 9660 FORMAT (1H0,6X,'MEMBRANE-BENDING COUPLING')                               
 9670 FORMAT (1H0,6X,'BENDING ADJUSTMENT')                                      
 9680 FORMAT (1H0,6X,'MEMBRANE-BENDING ADJUSTMENT COUPLING')                    
 9690 FORMAT (1H0,6X,'BENDING-BENDING ADJUSTMENT COUPLING')                     
 9700 FORMAT (1H0,6X,'TRANSVERSE SHEAR')                                        
 9710 FORMAT (//7X,'NO OF',6X,'!',34X,'STIFFNESSES:'/1X,                        
     *        'SUBDIVISION LINE !',9X,'AXIAL',13X,'COUPLING',                 
     *        11X,'BENDING',12X,'TORSION'/1X,17('-'),'+',75('-'))                 
 9720 FORMAT (1H ,I9,8X,'!',4E19.7)                                             
 9740 FORMAT (///1X,'PRESCRIBED MEMBRANE FORCES')                               
 9750 FORMAT (1H ,6X,'IY=',I2,6E19.7)                                           
 9760 FORMAT (///1X,'DISTRIBUTION OF VARIABLE MEMBRANE FORCES')
 9770 FORMAT (1H0,6X,'ELEMENT STRIP : ',I2)                 
      END SUBROUTINE PRTOUT
