C     Last change:  CS   Aug 2007    4:59 pm
      SUBROUTINE RDDATA(BB,DD,BD,RR,DR,BR,SS,IER)
C
C ######################################################################
C
C                               R D D A T A
C                               ###########
C                               ###########        COPYRIGHT BY DLR 2001
C
C     S T A T E     :   11.06.2007  modified by C. Schillo to include 
C                                   crippling analysis of stiffeners &
C                                   Stringer data (geometry, stiffness)
C                                                                     
C                       24.10.2005
C                       05.09.2004 revised by B. Geier to include optnl.
C                                  computation of stiffness
C
C     A U T H O R   :   Dr. B. Geier, WB-SM, DLR BRAUNSCHWEIG
C                       The subroutine is based on a version written
C                       by K. Schourek, K. Rohwer for BEOS3.0
C
C     P U R P O S E :   INPUT OF ALL DATA NEEDED IN THE BUCKLING BRANCH
C     ===============
C
C     A R G U M E N T :
C     =================
C
C     IER               ERROR INDEX. IER=0: NO ERROR
C
C     C O M M O N B L O C K S :
C     =========================
C
C     INPUT
C     DATRAN..
C
C     OUTPUT  :
C     MAN.....
C     F07INA..
C     F07INB..
C     CPVAR ..  PVAR(P_NODES,3)  DISTRIBUTION OF VARIABLE MEMBRANE FORCES
C     CPFEST..  PFEST(P_NODES,3) DISTRIBUTION OF PRESCRIBED MEMBRANE FORCES
C     F07INC..
C     F07IND..
C     F07INE..
C     F07ANG..
C     F07DIS..
C     F07MAT..
C     RPCONS..
C     PLOTIN..
C
C     I N D I C A T I O N S :
C     =======================
C
C     ----
C     ----
C     ----
C
C
C ######################################################################
C
C PARAMETERS USED IN PROGRAM BEOS:
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C        / A N T Y P E /
C        ===============
      LOGICAL TEMP,STRS,BUCK,VIBR,INPB,CRIPAN,GLBAN
      COMMON /ANTYPE/ TEMP,STRS,BUCK,VIBR,INPB,CRIPAN,GLBAN
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
C        / F 0 7 I N A /
C        ===============
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
C        / F 0 7 I N B /
C        ===============
      REAL :: RX, RY, RXY
      REAL, DIMENSION(1:6,P_ELMTS):: BB, DD, BD
      REAL, DIMENSION(18,P_ABDSTF):: MATABD
      REAL, DIMENSION(21,P_ABDSTF):: MATSW
      COMMON /F07INB/ RX,RY,RXY
	  COMMON /SKSTF/ MATABD,MATSW
C      ,BB,DD,BD
C
C        / F 0 7 I N C /
C        ===============
      REAL, DIMENSION(1:6,P_ELMTS) :: RR, DR, BR
      REAL, DIMENSION(1:3,P_ELMTS) :: SS
C      COMMON /F07INC/ RR,DR,BR,SS
C
C        / F 0 7 I N D /
C       ===============
      LOGICAL SEITEN
      INTEGER :: NUMSUP
      INTEGER, DIMENSION(1:7):: BNDY0,BNDX0,BNDYL,BNDXL
      INTEGER, DIMENSION(1:4,1:P_NSUP):: IDESUP
      COMMON /F07IND/ SEITEN,BNDY0,BNDX0,BNDYL,BNDXL,IDESUP,NUMSUP
C
C         / C P V A R , C P F E S T /
C         ===========================
      REAL, DIMENSION(1:P_NODES,1:3):: PVAR, PFEST
      COMMON /CPVAR/  PVAR
      COMMON /CPFEST/ PFEST
C
C         / D E N S I T /
C         ===============
      REAL:: DOM, PDOM
      COMMON /DENSIT/ DOM, PDOM
C
C         / F 0 7 A N G /
C         ===============
      REAL :: ALFAX, ALFAY
      COMMON /F07ANG/ ALFAX,ALFAY
C
C         / F 0 7 D I S /
C         ===============
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY,STYPE
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY,STYPE
C
C         / F 0 7 M A T /
C         ===============
      INTEGER, DIMENSION(1:5,1:4,1:P_NODES):: LM
      COMMON /F07MAT/ LM
C
C         / P L O T I N /
C         ===============
      REAL:: SCAL
      INTEGER :: INDPLT,NPX,NPY,ISYMX,ISYMY,NMOD
      INTEGER,DIMENSION(1:P_NGRQ):: MDSPLT
      COMMON /PLOTIN/ SCAL,INDPLT,NPX,NPY,ISYMX,ISYMY,MDSPLT,NMOD
C
C        / D A T R A N /
C        ===============
      INTEGER:: NREAD, NWRITE, NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
      
C        T S T R I N G E R   &   O S T R I N G E R 
C       / S T R I N G E R C O M /
C       ====================
      REAL :: FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,CHORDWIDTH,CHORDTH,ALPHA 
      REAL, DIMENSION (1:6) :: DDST
      COMMON /STRINGERCOM/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,DDST
C     * ,CHORDWIDTH,CHORDTH,ALPHA
 
C    G L O B A L  B U C K L I N G  D A T A
C    =====================================
      REAL :: SKINTH,STPITCH
      COMMON /GLBUCKCOM/ SKINTH,STPITCH
C
C    S T I F F N E S S  D I S T R I B U T I O N
C    ===========================================
      INTEGER, DIMENSION (1:P_RTNDS-1) :: ELMSTF
	  COMMON /STIFFCOM/ ELMSTF
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      LOGICAL:: DIRCT,SW
      REAL:: ANGC,HC,EXC
      REAL,DIMENSION(1:4)::Q1,Q2,Q3,Q4,Q5,Q6,Q7,CQ
      REAL,DIMENSION(1:2):: CS
      REAL,DIMENSION(1:4):: Q
      REAL,DIMENSION(1:64):: THKFST,ANGFST,THKSCD,ANGSCD
      REAL, DIMENSION(1:3,1:3):: AAL,ADL,DDL,QR
      REAL,DIMENSION(1:2,1:2):: HHL,H1L
      INTEGER :: NFST,NSCD,MATFST,MATSCD
      INTEGER :: AB,SELM
C
      DATA DIRCT/.TRUE./, SW/.TRUE./
      DATA Q1/123550.9, 8707.9, 0.32, 5695.0/,
     1     Q2/141000.0, 11000.0, 0.3, 6290.0/,
     2     Q3/161100.0, 12100.0, 0.285, 7100.0/,
     3     Q4/60000.0, 60000.0, 0.02, 5000.0/,
     4     Q5/16100.0, 21500.0, 0.14, 6075.0/, Q6/4*0.0/, Q7/4*0.0/
      DATA NFST/1/, NSCD/1/, MATFST/0/, MATSCD/0/,
     1     THKFST/64*0.0/,THKSCD/64*0.0/, ANGFST/64*0.0/,ANGSCD/64*0.0/
      DATA CQ/1.0,0.3,1.0,0.35/,CS/1.0,1.0/,ANGC/0.0/,HC/0.0/,EXC/0.0/
C
      NAMELIST /CONST/  ITAB,NEIGIT,NEIGRQ,MEMPRI,X2PRI,
     &                  INDPLT,NPX,NPY,ISYMX,ISYMY,MDSPLT,SCAL
      NAMELIST /SUBDIV/ KU,A,B
      NAMELIST /BNDCON/ BNDY0,BNDX0,BNDYL,BNDXL,IDESUP
      NAMELIST /RAD/    RX,RY,RXY
      NAMELIST /STIFF/  DIRCT,SW,BB,DD,RR,BD,BR,DR,SS,NFST,NSCD,
     1                  MATFST,MATSCD,THKFST,THKSCD,ANGFST,ANGSCD,
     2                  CQ,CS,ANGC,HC,EXC,Q6,Q7,
     3                  STEIFY,ISTY,STYPE,
     4                  SKINTH,STPITCH
C					  ,ISTX,ELMSTF,STEIFX,MATABD,MATSW
      NAMELIST /LOADF/  FNX,FNXY,FNY
      NAMELIST /LOADV/  VNX,VNXY,VNY
      NAMELIST /INERT/  DOM, DOMX, DOMY
      NAMELIST /ANGL/   ALFAX,ALFAY
      NAMELIST /TSTRINGER/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,DDST
      NAMELIST /OSTRINGER/ FOOTTH,WEBTH,FOOTWIDTH,WEBHEIGHT,DDST,
     & CHORDWIDTH,CHORDTH,ALPHA
C      NAMELIST /GLOBALBUCK/ SKINTH
C
      DO ,I=1,P_NGRQ
	     IF ( NEIGRQ.GE.I ) THEN
		    MDSPLT(I)=I
	     ELSE
		    MDSPLT(I)=0
		 END IF
      END DO
      
	  SCAL = 1.0
      IER = 0
      REWIND NREAD
C
C     READ DATA OF GROUP 1  - NAMELIST CONST -
C      READ (NREAD,CONST,END=101)
      IF ( NEIGIT.GT.P_NGIT ) THEN
         NEIGIT = P_NGIT
         WRITE (NWRITE,1001)
         WRITE (NWRITE,1002) P_NGIT
      END IF
      IF ( NEIGRQ.GT.P_NGRQ ) THEN
         NEIGRQ = P_NGRQ
         WRITE (NWRITE,1001)
         WRITE (NWRITE,1002) P_NGRQ
      END IF
C
      NMOD=0
      DO, I=1,P_NGRQ
         IF (MDSPLT(I).GT.0) THEN
            NMOD=NMOD+1
         END IF
      END DO
C     READ AND EXPLOIT DATA OF GROUP 2 - NAMELIST SUBDIV -
C      REWIND NREAD
C      READ (NREAD,SUBDIV,END=102)
C     DETERMINE  MX  AND  MY  =  NUMBER OF NODES IN X- AND Y-DIRECTION
C      DO, I=1,P_RTNDS-1
C         IF ( A(I).GT.0.1E-20 )   MX = I + 1
C         IF ( B(I).GT.0.1E-20 )   MY = I + 1
C      END DO
C     FILL ARRAY  LEIT(P_RTNDS,P_RTNDS)  WITH THE NUMBERS
C     OF ACTUAL NODE POINTS
      II = 1
      DO, I=1,MX
         DO, J=1,MY
            LEIT(J,I) = II
            II = II + 1
         END DO
      END DO
C
C     READ AND EXPLOIT DATA OF GROUP 3  -NAMELIST BNDCON_
      REWIND NREAD
C      READ (NREAD,BNDCON,END=103)
C     DETERMINE  SEITEN:
C        SEITEN = .FALSE.   IF NO INPUT VALUE .NE.0 FOR BNDY0,BNDX0, ...
C        SEITEN = .TRUE.    IF THERE ARE VALUES  .NE.0  FOR BNDY0, ...
C
      SEITEN = .FALSE.
      DO, I=1,7
         IF (( BNDY0(I).NE.0 ).OR.( BNDX0(I).NE.0 ).OR.
     &       ( BNDYL(I).NE.0 ).OR.( BNDXL(I).NE.0 )) THEN
            SEITEN =.TRUE. ;  EXIT
         END IF
      END DO
C     DETERMINE  NUMSUP  =  NUMBER OF SUPPRESSED DOFS
      NUMSUP = 0
      DO, I=1,P_NSUP
         IFUSUP = IDESUP(1,I)
         IF ( IFUSUP.EQ.0 ) EXIT
         NUMSUP = NUMSUP + 1
      END DO
      IF (SEITEN) THEN
         IF (BNDY0(1) .EQ. -1) ISYMY=-2
         IF (BNDY0(1) .EQ. +1) ISYMY= 2
         IF (BNDYL(1) .EQ. -1) ISYMY=-1
         IF (BNDYL(1) .EQ. +1) ISYMY= 1
         IF (BNDX0(1) .EQ. -1) ISYMX=-2
         IF (BNDX0(1) .EQ. +1) ISYMX= 2
         IF (BNDXL(1) .EQ. -1) ISYMX=-1
         IF (BNDXL(1) .EQ. +1) ISYMX= 1
      END IF
C
C     READ DATA of GROUP 4   - NAMELIST RAD -
C      REWIND NREAD
C      IF (.NOT.(KNFUN.EQ.1.OR.( KNFUN.EQ.3 .AND. KU(2).EQ.4)))
C     *    READ (NREAD,RAD,END=104)
C
C     READ DATA OF GROUP 5   - NAMELIST STIFF -
C      DO, I=1,P_RTNDS-1
C        ELMSTF(I)=0
C      END DO
C      DO, I=1,18
C        DO,J=1,P_ABDSTF
C            MATABD(I,J)=0.0
C        END DO
C	END DO
C	DO, I=1,21
C		DO, J=1,P_ABDSTF
C			MATSW(I,J)=0.0
C		END DO
C     END DO
C      REWIND NREAD
C      READ (NREAD,STIFF,END=105)
      NOX = 0
      DO, WHILE (NOX .LE. MY)
         NOX = NOX + 1
         IF(ISTX(NOX) .EQ. 0) EXIT
      END DO
      NOX = NOX - 1
      NOY = 0
      DO, WHILE (NOY .LE. MX)
         NOY = NOY + 1
         IF(ISTY(NOY) .EQ. 0) EXIT
      END DO
      NOY = NOY - 1
C      
C*************DIRCT=.FALSE. OPTION entfernt!*****
C
      AB=(MX-1)*(MY-1)
      SELM=0
      DO IELM=1,AB
        SELM=SELM+1
        IF (SELM.GT.(MY-1))THEN
            SELM=SELM-(MY-1)
        END IF
        BB(1,IELM)=MATABD(1,ELMSTF(SELM))
        BB(2,IELM)=MATABD(2,ELMSTF(SELM))
        BB(3,IELM)=MATABD(3,ELMSTF(SELM))
        BB(4,IELM)=MATABD(4,ELMSTF(SELM))
        BB(5,IELM)=MATABD(5,ELMSTF(SELM))
        BB(6,IELM)=MATABD(6,ELMSTF(SELM))
C      
        BD(1,IELM)=MATABD(7,ELMSTF(SELM))
        BD(2,IELM)=MATABD(8,ELMSTF(SELM))
        BD(3,IELM)=MATABD(9,ELMSTF(SELM))
        BD(4,IELM)=MATABD(10,ELMSTF(SELM))
        BD(5,IELM)=MATABD(11,ELMSTF(SELM))
        BD(6,IELM)=MATABD(12,ELMSTF(SELM))
C
        DD(1,IELM)=MATABD(13,ELMSTF(SELM))
        DD(2,IELM)=MATABD(14,ELMSTF(SELM))
        DD(3,IELM)=MATABD(15,ELMSTF(SELM))
        DD(4,IELM)=MATABD(16,ELMSTF(SELM))
        DD(5,IELM)=MATABD(17,ELMSTF(SELM))
        DD(6,IELM)=MATABD(18,ELMSTF(SELM))
      END DO
C     Scale for plotting
C     **************!!!!CS:2nd subscript fixed!**********
      SCAL=SCAL*SQRT(SQRT(144.*DD(1,1)*DD(3,1)/(BB(1,1)*BB(3,1))))
C
	  IF (SW.EQV..TRUE.) THEN
	      AB=(MX-1)*(MY-1)
		  SELM=0
		DO IELM=1,AB
			SELM=SELM+1
			IF (SELM.GT.(MY-1))THEN
			  SELM=SELM-(MY-1)
			END IF
	    BR(1,IELM)=MATSW(1,ELMSTF(SELM))
        BR(2,IELM)=MATSW(2,ELMSTF(SELM))
        BR(3,IELM)=MATSW(3,ELMSTF(SELM))
        BR(4,IELM)=MATSW(4,ELMSTF(SELM))
        BR(5,IELM)=MATSW(5,ELMSTF(SELM))
        BR(6,IELM)=MATSW(6,ELMSTF(SELM))
C      
        DR(1,IELM)=MATSW(7,ELMSTF(SELM))
        DR(2,IELM)=MATSW(8,ELMSTF(SELM))
        DR(3,IELM)=MATSW(9,ELMSTF(SELM))
        DR(4,IELM)=MATSW(10,ELMSTF(SELM))
        DR(5,IELM)=MATSW(11,ELMSTF(SELM))
        DR(6,IELM)=MATSW(12,ELMSTF(SELM))
C
        RR(1,IELM)=MATSW(13,ELMSTF(SELM))
        RR(2,IELM)=MATSW(14,ELMSTF(SELM))
        RR(3,IELM)=MATSW(15,ELMSTF(SELM))
        RR(4,IELM)=MATSW(16,ELMSTF(SELM))
        RR(5,IELM)=MATSW(17,ELMSTF(SELM))
        RR(6,IELM)=MATSW(18,ELMSTF(SELM))
C
	    SS(1,IELM)=MATSW(19,ELMSTF(SELM))
	    SS(2,IELM)=MATSW(20,ELMSTF(SELM))
	    SS(3,IELM)=MATSW(21,ELMSTF(SELM))
		END DO
	  END IF

C     READ DATA OF GROUP 6 - NAMELISTS LOADV, LOADF -
C      REWIND NREAD
C      IF (.NOT.VIBR) THEN
C         READ (NREAD,LOADV,END=106)
C      END IF
C      READ (NREAD,LOADF,END=1106)
C
      IF (VIBR) THEN
C     READ DATA OF GROUP 8   - NAMELIST INERT -
         REWIND NREAD
         READ (NREAD,INERT,END=108)
      END IF
C
C     READ DATA OF GROUP 7   - NAMELIST ANGL -
C      REWIND NREAD
C      READ (NREAD,ANGL,END=107)
C      
C     READ DATA OF GROUP 8 - NAMELIST of Stringers -
C	  REWIND NREAD
	  IF (CRIPAN.EQV..TRUE.) THEN	
		IF (STYPE.EQ.1)THEN
			READ (NREAD,TSTRINGER,END=109)  
			WRITE (NWRITE,'(E20.5,E20.5)') DDST(1),WEBTH
		ELSE IF (STYPE.EQ.2) THEN
			READ (NREAD,OSTRINGER, END=109)
		ELSE
			WRITE (NWRITE,1900)
			WRITE (NWRITE,3008) 
          ENDIF
	  ENDIF 
C
      GOTO 9999
C
  101 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) ' CONST'
      WRITE (*,1900)
      WRITE (*,2000) ' CONST'
      IER = 1
      GOTO 9999
C
  102 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) 'SUBDIV'
      WRITE (*,1900)
      WRITE (*,2000) 'SUBDIV'
      IER = 2
      GOTO 9999
C
  103 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) 'BNDCON'
      WRITE (*,1900)
      WRITE (*,2000) 'BNDCON'
      IER = 3
      GOTO 9999
C
  104 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) '   RAD'
      WRITE (*,1900)
      WRITE (*,2000) '   RAD'
      IER = 4
      GOTO 9999
C
  105 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) ' STIFF'
      WRITE (*,1900)
      WRITE (*,2000) ' STIFF'
      IER = 5
      GOTO 9999
C
  106 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) ' LOADV'
      WRITE (*,1900)
      WRITE (*,2000) ' LOADV'
      IER = 6
      GOTO 9999
C
 1106 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) ' LOADF'
      WRITE (*,1900)
      WRITE (*,2000) ' LOADF'
      IER = 6
      GOTO 9999

  107 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) '  ANGL'
      WRITE (*,1900)
      WRITE (*,2000) '  ANGL'
      IER = 7
      GOTO 9999
C
C
  108 WRITE (NWRITE,1900)
      WRITE (NWRITE,2000) ' INERT'
      WRITE (*,1900)
      WRITE (*,2000) ' INERT'
      IER = 8
      GOTO 9999
C
C
  109 WRITE (NWRITE,1900)
      WRITE (NWRITE,3008) 
  110 WRITE (*,1900)
      WRITE (*,3008)
      IER = 8
      GOTO 9999
C  
 9999 RETURN
C
 1001 FORMAT (4X,'WARNING: IN SUBROUTINE RDDATA')
 1002 FORMAT (13X,'NUMBER OF EIGENMODES FOR ITERATION',
     &            ' WAS REDUCED TO',I3)
 1003 FORMAT (13X,'NUMBER OF EIGENMODES REQUESTED WAS REDUCED TO',I3)
 1004 FORMAT (13X,'SOME GRID LINE NUMBER(S) FOR PLOTTING WAS SET',
     &            'TO MAX ALLOWABLE VALUE(S)')
C
 1900 FORMAT (1X,'MESSAGE FROM SUBROUTINE RDDATA:')
 2000 FORMAT (1X,'NAMELIST ',A6,' NOT FOUND')
C
 3001 FORMAT (1X,'Conflict while processing UD-Properties:')
 3002 FORMAT (1X,'Some property not found, possibly Q',I2)
 3004 FORMAT(1X,'Error when computing stiffness of ',A5,' face shell')
 3006 FORMAT (1X,'RDDATA: Error transforming core in-pl. stiffness')
 3007 FORMAT (1X,'RDDATA: Error transforming core transv stiffn.')
 3008 FORMAT (1x,'Some Stringer Data missing for crippling analysis')  
      END SUBROUTINE RDDATA

