C     Last change:  BG   17 Nov 2004    4:05 pm
      SUBROUTINE REDFKQ
C                                                                               
C **********************************************************************        
C      FIND EQUIVALENT COMBINATIONS OF FQUAD AND KQUAD AND REDUCE ARRAYS
C **********************************************************************        
C                                                                               
C ######################################################################        
C                                                                               
C                               R E D F K Q
C                               ###########                                     
C                               ###########        COPYRIGHT BY DLR 2001
C                                                                               
C     S T A T E    : 10.09.2001
C
C     M O D I F I E D: 19.11.2007 by C. Schillo, DLR BRAUNSCHWEIG, FA-SM
C                                                                               
C     A U T H O R  :  Dr. B. Geier, DLR BRAUNSCHWEIG, INST. WB-SM
C                                                                               
C     P U R P O S E : REMOVE REDUNDANCIES IN FILES FQUAD AND KQUAD
C     ===============
C                                                                               
C     C O M M O N B L O C K S :                                                 
C     =========================                                                 
C                                                                               
C     INPUT   :                                                                 
C     /F01QUA/ 
C              FQUAD(340,NODES)   FACTORS OF THE ENERGY TERMS
C              KQUAD(340,3)       KEY NUMBERS OF THE ENERGY TERMS
C              M                  NUMBER OF THE ENERGY TERMS SET UP
C     OUTPUT  :                                                                 
C     /F01QUA/ 
C                           SAME AS INPUT, BUT REARRANGED
C                                                                               
C     I N D I C A T I O N S :                                                   
C     =======================                                                   
C                                                                               
C ######################################################################        
C    
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif                                                                  
      INTEGER P_ITRM
      PARAMETER (P_ITRM=340)
      INTEGER, DIMENSION (1:P_ITRM)::IKT
      REAL, DIMENSION(1:P_ITRM,P_ELMTS):: FQ
      INTEGER, DIMENSION(1:P_ITRM,1:3,P_ELMTS):: KQ
      COMMON /F01QUA/ FQ, KQ, IKT
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN      
C                                                                               
      LOGICAL L1,L2
C
      INTEGER :: IELM,AB
C
C     
      AB=(MX-1)*(MY-1)
      DO 350, IELM=1,AB
      ITRM=IKT(IELM)
      I=1
      DO WHILE(I.LT.ITRM)
         K=I+1
        DO WHILE(K.LE.ITRM)
        L1=KQ(K,1,IELM).EQ.KQ(I,1,IELM).AND.KQ(K,2,IELM).EQ.KQ(I,2,IELM)
        L2=KQ(K,1,IELM).EQ.KQ(I,2,IELM).AND.KQ(K,2,IELM).EQ.KQ(I,1,IELM)
            IF (L1 .OR. L2) THEN
      			FQ(I,IELM)=FQ(I,IELM)+FQ(K,IELM)
               DO J=K,ITRM-1
                  KQ(J,1,IELM)=KQ(J+1,1,IELM)
                  KQ(J,2,IELM)=KQ(J+1,2,IELM)
                  FQ(J,IELM)=FQ(J+1,IELM)
                  KQ(J,3,IELM)=KQ(J+1,3,IELM)
               END DO
               KQ(ITRM,1,IELM)=0
               KQ(ITRM,2,IELM)=0
               FQ(ITRM,IELM)=0.
               KQ(ITRM,3,IELM)=0
               ITRM =ITRM-1
            END IF
            K=K+1
        END DO
        I=I+1
      END DO
      IKT(IELM)=ITRM
 350  END DO
      END
