C     Last change:  BG   16 Mar 2006    4:10 pm
      SUBROUTINE SETKEY(IX,IY)
C
C ######################################################################
C
C                               S E T K E Y
C                               ###########
C                               ###########        COPYRIGHT BY DLR 2001
C     S T A T E    :  04.12.2001
C
C     A U T H O R  :  Dr. B. Geier, DLR Braunschweig, Inst. WB-SM.
C                     The program is based on a subroutine written by
C                     K. Rohwer for BEOS3.0
C                     Aenderungen: FHG fuer w und (u,v,beta,gamma)
C                     werden getrennt gezaehlt,
C											 IBDX, IBDY sind halbe Bandbreiten
C                                 + 1, d.h. inklusive Diagonale
C
C     P U R P O S E : SETS UP KEY MATRIX AND DETERMINES BANDWIDTH
C     ===============
C
C     A R G U M E N T S :
C     ===================
C
C     OUTPUT  : IX    NO. OF DOFS FOR FUNCTION W
C               IY    NO. OF DOFS FOR FUNCTIONS U, V, BETA, GAMMA
C
C     C O M M O N B L O C K S :
C     =========================
C
C     INPUT   :
C     DATRAN..
C     F07INA..
C     F07IND..
C     F07INE..
C
C     OUTPUT  :
C     F07MAT..
C
C     I N D I C A T I O N S :
C     =======================
C
C     ----
C     ----
C     ----
C
C ######################################################################
C
C     Parameters used by BEOS
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C      EQUIVALENCE (LM(1,1,1),LMH(1))
C
      LOGICAL KU4
C
C     DIMENSION LMH(20*P_NODES)
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C MATRIX LEIT(J,I): FIRST INDEX COUNTS NODE LINES PRALLEL TO X-DRECTION
C                   SECND INDEX COUNTS NODE LINES PRALLEL TO Y-DRECTION
      LOGICAL SEITEN
      INTEGER :: NUMSUP
      INTEGER, DIMENSION(1:7):: BNDY0,BNDX0,BNDYL,BNDXL
      INTEGER, DIMENSION(1:4,1:P_NSUP):: IDESUP
      COMMON /F07IND/ SEITEN,BNDY0,BNDX0,BNDYL,BNDXL,IDESUP,NUMSUP
C
      INTEGER, DIMENSION(1:5,1:4,1:P_NODES):: LM
      COMMON /F07MAT/ LM
C
      INTEGER:: NREAD,NWRITE,NSTORE
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
      INTEGER, DIMENSION(1:4):: CORNER(4)
      INTEGER,DIMENSION (1:7,1:2):: KI
C
C
      KU4 = KNFUN.EQ.3 .AND. KU(2).EQ.4
C
C     THE KEY MATRIX IS FIRST COMPLETELY FILLED WITH  -909.
C     THEN THE SUPPRESSED DOFS ARE SET TO ZERO.
C   50 CONTINUE
C      DO,  I=1,20*P_NODES
C         LMH(I) = -909
C      END DO
C
      LM = -909
C
      IF ( NUMSUP.GT.0 )   THEN
C        POINT-WISE SUPPRESSION
         DO,  N=1,NUMSUP
            K = IDESUP(3,N)
            L = IDESUP(4,N)
            NODE = LEIT(K,L)
            IFUN = IDESUP(1,N)
            KND  = IDESUP(2,N)
            LM(IFUN,KND,NODE) = 0
         END DO
      ENDIF
C
C
      IF  ( SEITEN )   THEN
C        EDGE-WISE SUPPRESSION
C        SIDES Y=CONST
         DO,   N=1,7
            KI(N,1)=BNDY0(N)
            KI(N,2)=BNDYL(N)
         END DO
         DO,   KN=1,2      !First KN-Loop
            KZ = KI(1,KN)
            IF ( KZ.NE.0 )   THEN
C              SYMMETRY AND ANTI-SYMMETRY WITH RESPECT TO X-AXIS
               L = 1 + (MY-1)*(KN/2)
               DO,  K=1,MX
                  DO,  IU=1,KNFUN
                     I = KU(IU)
                     IF ( KZ.LT.0 )   THEN  !Symmetry
                        J = 3
                        IF ( I.EQ.3 .OR. I.EQ.5 )   J = 1
                     ELSE                   !Anti-symmetry
                        J = 1
                        IF ( I.EQ.3 .OR. I.EQ.5 )   J = 3
                     ENDIF
                     LLK = LEIT(L,K)
                     LM(I,J,LLK) = 0
                     LM(I,J+1,LLK) = 0
                  END DO
               END DO
            ELSE
C              OTHER BOUNDARY CONDITIONS ALONG EDGES Y=CONST
               L = 1 + (MY-1)*(KN/2)
               DO,   I=2,7
                  K = KI(I,KN)
                  IF ( K.LE.0 )  CYCLE
                  DO,   J=1,MX
                     LLJ = LEIT(L,J)
                     IF ( K.NE.6 )   THEN
                        LM(K,1,LLJ) = 0
                        LM(K,2,LLJ) = 0
                     ELSE
                        LM(1,3,LLJ) = 0
                        LM(1,4,LLJ) = 0
                     ENDIF
                  END DO
               END DO
            END IF
         END DO      !First KN-Loop
C
C        SIDES X=CONST
         DO,   N=1,7
            KI(N,1)=BNDX0(N)
            KI(N,2)=BNDXL(N)
         END DO
         DO,   KN=1,2      !Second KN-Loop
            KZ = KI(1,KN)
            IF ( KZ.NE.0 )   THEN
C              SYMMETRY AND ANTI-SYMMETRY WITH RESPECT TO Y-AXIS
               L = 1 + (MX-1)*(KN/2)
               DO,   K=1,MY
                  DO,   IU=1,KNFUN
                     I = KU(IU)
                     IF ( KZ.LT.0 )   THEN   !Symmetry
                        J = 2
                        IF ( I.EQ.2 .OR. I.EQ.4 )   J = 1
                     ELSE                    !Anti-symmetry
                        J = 1
                        IF ( I.EQ.2 .OR. I.EQ.4 )   J = 2
                     ENDIF
                     LKL = LEIT(K,L)
                     LM(I,J,LKL) = 0
                     LM(I,J+2,LKL) = 0
                  END DO
               END DO
C
            ELSE
C              OTHER BOUNDARY CONDITIONS ALONG EDGES X=CONST
               L = 1 + (MX-1)*(KN/2)
               DO,   I=2,7
                  K = KI(I,KN)
                  IF ( K.LE.0 )   CYCLE
                  DO,   J=1,MY
                     LJL = LEIT(J,L)
                     IF ( K.NE.6 )   THEN
                        LM(K,1,LJL) = 0
                        LM(K,3,LJL) = 0
                     ELSE
                        LM(1,2,LJL) = 0
                        LM(1,4,LJL) = 0
                     ENDIF
                  END DO
               END DO
            ENDIF
         END DO         ! Second KN-Loop
      ENDIF
C
C     COUNT AND ENUMERATE FREEDOMS
C
      IX = 0
      IY = 0
      IF ( MY.LT.MX )   THEN
         JO = MX
         IO = MY
      ELSE
         JO = MY
         IO = MX
      ENDIF
      DO,   J=1,JO      !J-LOOP
         DO,   I=1,IO     !I-LOOP
            IF ( MY.LT.MX )   THEN
               NODE = LEIT(I,J)
            ELSE
               NODE = LEIT(J,I)
            ENDIF
            DO,   LU=1,KNFUN  !LU-LOOP
               L = KU(LU)
               IF ( L.EQ.1 )   THEN
                 DO,   K=1,4     !First_K-LOOP
                     IF ( LM(L,K,NODE).EQ.0 )   CYCLE
                     IX = IX + 1
                     LM(L,K,NODE) = IX
                  END DO                        ! FIRST_K-LOOP
               ELSE
                  DO,   K=1,4    !SECND_K-LOOP
                     IF ( LM(L,K,NODE).EQ.0 )   CYCLE
                     IY = IY + 1
                     LM(L,K,NODE) = IY
                  END DO                        ! SECND_K-LOOP
               ENDIF
            END DO              !LU-LOOP
         END DO                 !I-LOOP
      END DO            ! J-LOOP
C
C     DETERMINE BANDWIDTH
C
      IBDX = 0
      IBDY = 0
C     LOOP OVER SUBDIVISIONS (FINITE ELEMENTS)
      DO, 	JJY=1,MY-1
      DO,   JJX=1,MX-1
         CORNER(1)= LEIT(JJY,JJX);   CORNER(2)= LEIT(JJY,JJX+1)
         CORNER(3)= LEIT(JJY+1,JJX); CORNER(4)= LEIT(JJY+1,JJX+1)
         NXL = IX; NXU = 1; 		   NYL = IY; NYU = 1
         DO,   ND=1,4         !Loop over corners
         DO,   KD=1,4         !Loop over derivatives
            KKXL = LM(1,KD,CORNER(ND))
            IF (KKXL .GT. 0) THEN      !Function w only
               NXL = MIN(NXL,KKXL)
               NXU = MAX(NXU,KKXL)
            END IF                     !End function w
            DO,   NF=2,KNFUN     !Loop over non-w functions
               KKYL = LM(KU(NF),KD,CORNER(ND))
           		IF (KKYL .GT. 0) THEN
              		NYL = MIN(NYL,KKYL)
              		NYU = MAX(NYU,KKYL)
            	END IF
            END DO               !End loop over non-w functions
         END DO               !End loop over derivtives
         END DO               !End loop over corners
         IBDX = MAX(IBDX,NXU-NXL)
         IBDY = MAX(IBDY,NYU-NYL)
      END DO
      END DO      !End Loop over subdivisions
      IBDX = MIN(IBDX+1,IX)   !IBDX counts half-band + diagonal
      IBDY = MIN(IBDY+1,IY)   !IBDY counts half-band + diagonal
C
C     PRINT KEY MATRIX
      KU4 = KNFUN.EQ.3 .AND. KU(2).EQ.4
      WRITE (NWRITE,9500)   IX,IY
      DO, 	I=1,MY      !Loop over subdivisions
      DO,   J=1,MX
      	 IF ( KU4 )   THEN
        	 	WRITE (NWRITE,9510)   I,J,(LM(1,K,LEIT(I,J)),K=1,4),
     *                         ((LM(II,K,LEIT(I,J)),K=1,4),II=4,5)
      		ELSE
         	WRITE (NWRITE,9520)   I,J,
     *                         ((LM(II,K,LEIT(I,J)),K=1,4),II=1,KNFUN)
      	ENDIF
      END DO
      END DO            !End, loop over subdivisions
      WRITE (NWRITE,9530)   IBDX,IBDY
      WRITE (NWRITE,9540)
      RETURN
C
 9500 FORMAT (1H1//1X,'KEY MATRIX'/7X,'NO. OF FREEDOMS',33X,
     *        'FOR THE DISPLACEMENT W :',I5/23X,'FOR THE ',
     *        'DISPLACEMENTS U,V AND THE ROTATIONS BETA,GAMMA :',I5//
     *        1X,'NODE POINT',13X,'W',22X,'U',22X,'V',20X,'BETA',
     *        19X,'GAMMA'/1X,'NODEX NODEY',5X,'W',3X,'WX',3X,'WY',3X,
     *        'WXY',6X,'U',3X,'UX',3X,'UY',3X,'UXY',6X,'V',3X,'VX',3X,
     *        'VY',3X,'VXY',6X,'B',3X,'BX',3X,'BY',3X,'BXY',6X,'G',
     *        3X,'GX',3X,'GY',3X,'GXY')
 9510 FORMAT (1X,I3,3X,I3,5X,4(I4,1X),49X,4(I4,1X),3X,4(I4,1X))
 9520 FORMAT (1X,I3,3X,I3,5X,4(4(I4,1X),3X),4(I4,1X))
 9530 FORMAT ('0','  BANDWIDTHS IBDX=',I3,'    IBDY=',I3)
 9540 FORMAT ('1')
      END SUBROUTINE SETKEY

