C     Last change:  DBG  26 Dec 2001   12:14 pm
      SUBROUTINE TCZINC (TRM,C,BB,D,K,KS,IELM)
C
C ######################################################################
C
C                               T C Z I N C
C                               ###########
C                               ###########        COPYRIGHT BY DLR 2001
C
C     S T A T E    :  17.12.2001
C
C     A U T H O R  :  K. ROHWER, DLR BRAUNSCHWEIG, INST. WB-SM
C                     Changed by B. GEIER
C
C     P U R P O S E : MULTIPLY STFFNESS SUBMATRIX BB WITH TRANSFORMATION
C     =============== MATRIX TRM AND ASSIGN TO C DEPENDING ON D
C
C               BB   STIFFNESS SUBMATRIX
C               D = .TRUE. : SYMMETRIC SUBMATRIX, UPPER TRIANGLE ONLY
C                 = .FALSE.: FULL SUBMATRIX
C               K    INDEX FOR STORING SYMMETRIC SUBMATRICES
C               KS   ADDITIONAL INDEX FOR STORING FULL SUBMATRICES
C
C     OUTPUT  : K    INDEX FOR STORING SYMMETRIC SUBMATRICES
C               KS   ADDITIONAL INDEX FOR STORING FULL SUBMATRICES
C
C     C O M M O N B L O C K S :
C     =========================
C
C     OUTPUT  :
C     /SHLSTF/
C       C(45)     PARTLY TRANSFORMED STIFFNESS MATRIX
C
C     I N D I C A T I O N S :
C     =======================
C
C ######################################################################
C
C      COMMON /SHLSTF/ C(45),CH(3)
C
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
      LOGICAL D
C
	REAL, DIMENSION (45,P_ELMTS) :: C
	REAL, DIMENSION (6,P_ELMTS) :: BB
      DIMENSION TRM(6,6),E(6), VEC(6),BB6(6)
	INTEGER :: IELM
C
	BB6=BB((/(LL,LL=1,6)/),IELM)
      DO, I=1,6
         VEC = TRM(I,(/(J,J=1,6)/))
      	E(I) = DOT_PRODUCT(VEC,BB6)
      END DO
      IF ( D ) THEN
         L = 0
         DO, I=1,3
            K = K + KS
            DO, J=I,3
               K = K + 1
               L = L + 1
               C(K,IELM) = E(L)
            END DO
         END DO
      ELSE
         DO, I=1,3
         	KS = KS - 1
            DO, J=1,3
            	K = K + 1
            	ML = MIN0(I,J)
           	 	L = (6 - ML)*(ML - 1) / 2 + MAX0(I,J)
            	C(K,IELM) = E(L)
            END DO
         K = K + KS
         END DO
      END IF
C
      RETURN
C     END FILE TCZINC
      END

