C     Last change:  DBG   5 Jan 2002   11:50 pm
      SUBROUTINE TMINC (CP,TRM,CH,RX,RY,RXY,SS)
C
C ######################################################################
C
C                               T M I N C
C                               #########
C                               #########          COPYRIGHT BY DLR 1991
C
C     S T A T E    :  06.03.92
C
C     A U T H O R  :  K. ROHWER, DLR BRAUNSCHWEIG, INST. WB-SM
C
C     P U R P O S E : SET UP MATRIX FOR STIFFNESS TRANSFORMATION,
C     =============== TRANSFORM TRANSVERSE SHEAR STIFFNESSES
C                     AND CURVATURE
C
C     A R G U M E N T S :
C     ===================
C
C     INPUT   : CP        ALFAX - ALFAY
C               SS(3)     ORIGINAL TRANSVERSE SHEAR STIFFNESSES
C               RX,RY,RXY CURVATURES IN ORIGINAL DIRECTIONS
C
C     OUTPUT  : TRM(6,6)  TRANSFORMATION MATRIX
C               CH(3)     TRANSFORMEDF TRANSVERSE SHEAR STIFFNESSES

C               RX,RY,RXY CURVATURES IN TRANSFORMED DIRECTIONS
C
C     C O M M O N B L O C K S :
C     =========================
C
C     INPUT   :
C     /F07ANG/
C              ALFAX,ALFAY ANGLES BETWEEN THE ORIGINAL AND THE TRANSFORMED
C                          DIRECTIONS
C     OUTPUT  :
C
C     I N D I C A T I O N S :
C     =======================
C
C ######################################################################
C
C      DIMENSION TRM(6,6),SS(3), CH(3)
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
	REAL,DIMENSION (6,6):: TRM
	REAL,DIMENSION (3,P_ELMTS):: SS,CH
	INTEGER :: SELM,AB,II
C
      REAL :: ALFAX, ALFAY
      COMMON /F07ANG/ ALFAX,ALFAY
C
C        / F 0 7 I N A /
C        ===============
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      C2 = COS(ALFAY)
      C1 = COS(ALFAX)
      C12 = COS(ALFAX + ALFAY)
      S1 = SIN(ALFAX)
      S2 = SIN(ALFAY)
      S12 = 2.0*C1*S1
      S22 = 2.0*C2*S2
      CS21 = C2*S1
      CS12 = C1*S2
      CP = COS(CP)**2
      CQ = 1.0/CP
C
	AB=(MX-1)*(MY-1)
      SELM=0
      DO II=1,AB
C      SELM=SELM+1
C        IF (SELM.GT.(MY-1))THEN
C            SELM=SELM-(MY-1)
C        END IF		
      CH(1,II)=(C2**2*SS(1,II)+
     *			2.0*C2*S2*SS(2,II)+S2**2*SS(3,II))*CQ
      CH(2,II)=(-CS21*SS(1,II)+
     *			2.0*C12*SS(2,II)+CS12*SS(3,II))*CQ
      CH(3,II)=(S1**2*SS(1,II)+
     *			2.0*C1*S1*SS(2,II)+C1**2*SS(3,II))*CQ
	END DO
      CP = CP**2
      CQ = 1.0/CP
      TRM(1,1) = C2**4 * CQ
      TRM(1,2) = S22**2 * CQ * 0.5
      TRM(1,3) = S2**4 * CQ
      TRM(1,4) = 2.0*S22*C2*C2*CQ
      TRM(1,5) = 2.0*S22*C2*S2*CQ
      TRM(1,6) = 2.0*TRM(1,2)
      TRM(2,1) = CS21**2 * CQ
      TRM(2,2) = ((S1*S2)**2 + (C1*C2)**2) * CQ
      TRM(2,3) = CS12**2 * CQ
      TRM(2,4) = -2.0*CS21*C12*CQ
      TRM(2,5) =  2.0*CS12*C12*CQ
      TRM(2,6) = -S12*S22 * CQ
      TRM(3,1) = -CS21*C2**2 * CQ
      TRM(3,3) = CS12*S2**2 * CQ
      TRM(3,4) = (C12 - 2.0*S1*S2)*C2*C2*CQ
      TRM(3,5) = (C12 + 2.0*C1*C2)*S2*S2*CQ
      TRM(3,6) = S22*C12 * CQ
      TRM(3,2) = 0.5 * TRM(3,6)
      TRM(4,1) = S1**4 * CQ
      TRM(4,2) = S12**2 * CQ * 0.5
      TRM(4,3) = C1**4 * CQ
      TRM(4,4) = -2.0*S12*S1*S1*CQ
      TRM(4,5) = -2.0*S12*C1*C1*CQ
      TRM(4,6) = 2.0*TRM(4,2)
      TRM(5,1) = -CS21*S1**2 * CQ
      TRM(5,3) = CS12*C1**2 * CQ
      TRM(5,4) = (C12 + 2.0*C1*C2)*S1*S1*CQ
      TRM(5,5) = (C12 - 2.0*S1*S2)*C1*C1*CQ
      TRM(5,6) = -S12*C12 * CQ
      TRM(5,2) = 0.5*TRM(5,6)
      TRM(6,1) = TRM(2,1)
      TRM(6,2) = 0.5*TRM(2,6)
      TRM(6,3) = TRM(2,3)
      TRM(6,4) = TRM(2,4)
      TRM(6,5) = TRM(2,5)
      TRM(6,6) = C12**2 * CQ
      C1 = C1**2*RX + S12*RXY + S1**2*RY
      S1 = -CS12*RX + C12*RXY + CS21*RY
      RY = C2**2*RY + S2**2*RX -S22*RXY
      RX = C1
      RXY = S1
C
C
      RETURN
C      END SUBROUTINE TMINC
      END
C

