C     Last change:  BG   30 Jan 2006   10:55 am
      SUBROUTINE VIBS3(LONG,BB,DD,BD,RR,DR,BR,SS,IER)
C
C ######################################################################
C
C                               V I B S 3 .
C                               ###########
C                               ###########        COPYRIGHT BY DLR 1991
C
C     S T A T E     :   17.07.2002
C
C     A U T H O R   :   K. ROHWER, WB-SM, DLR BRAUNSCHWEIG
C                       MODIFIED FOR INCORE VERSION BY B. GEIER
C
C     P U R P O S E :   -  SOLVE EIGENVALUE PROBLEM
C     ===============   -  PRINT RESULTS
C
C     A R G U M E N T S :
C     ===================
C
C     INPUT:       LONG  Actually used number of lines
C                        of matrix A21=A12**T.
C                        LONG MUST BE EQUAL TO IY.
C     OUTPUT:      IER   Error index
C
C     S U B P R O G R A M S :
C     =======================
C
C     CHODEC..  CHOLESKY-decomposition of the symmetric Band matrix A:
C                            A=> R**(TRANSP)*R
C               A will be destroyed and replaced by R.
C
C     CHOSOL..  Equation solution using decomposed matrix, for m
C               right hand sides => Xnew from R**(Transp)*A *Xnew = Xold
C               Xnew replaces Xold
C
C
C     SIMVIT..  Computation of eigenvalues and modes of the problem
C                  (A - LAMBDA * B) * X = 0
C               by simultaneous inverse iteration
C     EIGVPR..  Prints modes
C
C
C
C ######################################################################
C
#ifndef MBEOS5
     INCLUDE '#PRAMS'
#endif
C
C     DUMMY ARGUMENTS
      INTEGER::    LONG
      INTEGER::   IER
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     COMMON BLOCKS
C
C         / M A N /
C         =========
      INTEGER :: IX,IY,ITER,NEIGIT,ITAB,NEIGRQ
      LOGICAL MEMPRI,X2PRI
      COMMON /MAN/ IX,IY,ITER,NEIGIT,ITAB,NEIGRQ,MEMPRI,X2PRI
C
      INTEGER :: MX, MY, IBDX, IBDY, KNFUN
      INTEGER, DIMENSION (1:5)::KU
      INTEGER, DIMENSION(1:P_RTNDS,1:P_RTNDS):: LEIT
      REAL, DIMENSION(1:P_RTNDS-1):: A, B
      COMMON /F07INA/ KU,MX,MY,A,B,LEIT,IBDX,IBDY,KNFUN
C
      REAL :: RX, RY, RXY
      REAL, DIMENSION(1:6,*):: BB, DD, BD
      COMMON /F07INB/ RX,RY,RXY
C      ,BB,DD,BD
C
      REAL:: DOM, PDOM
      COMMON /DENSIT/ DOM, PDOM
C
      REAL, DIMENSION(1:P_NODES,1:3):: PFEST
      COMMON /CPFEST/ PFEST
C
      REAL, DIMENSION(1:4,1:P_STF):: STEIFX, STEIFY
      INTEGER, DIMENSION(1:P_STF):: ISTX, ISTY
      INTEGER :: NOX, NOY
      REAL, DIMENSION(1:P_STF):: DOMX, DOMY
      COMMON /F07DIS/ STEIFX,ISTX,NOX,DOMX, STEIFY,ISTY,NOY,DOMY
C
      DOUBLE PRECISION, DIMENSION(1:P_NGIT):: ELAM
      COMMON /VALUS/  ELAM
C
      INTEGER, DIMENSION(1:P_NX):: LVTRI,LVB
      INTEGER, DIMENSION(1:P_NY):: LVA22
      COMMON /COMLV/  LVTRI,LVA22,LVB
C
      DOUBLE PRECISION, DIMENSION(1:P_LA22):: A22
      DOUBLE PRECISION, DIMENSION(1:P_LA11):: A11
      DOUBLE PRECISION, DIMENSION(1:P_LB11):: B11
      DOUBLE PRECISION, DIMENSION(1:P_NY,1:P_NX):: A21
      COMMON /MATRIX/ A22,A11,B11,A21
C
      DOUBLE PRECISION, DIMENSION(1:P_NX,1:P_NGIT):: X
      COMMON /VECTRS/ X
C      
      LOGICAL:: DRVEK
      INTEGER:: IZU
      COMMON /F07HIL/ DRVEK,IZU
C
      COMMON /DATRAN/ NREAD,NWRITE,NSTORE
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      DOUBLE PRECISION::                    EPSILN, PI, NRMA, NRMM
C      CHARACTER*4  FQ(8),FP(3),FMT(7),F(6)
      DOUBLE PRECISION,DIMENSION(1:P_NGIT):: HERZ
      LOGICAL::                             OP25
C
C     AUTOMATIC ARRAYS
      DOUBLE PRECISION, DIMENSION(1:LONG):: ZZ, AUX, HILY
      DOUBLE PRECISION, DIMENSION(1:LONG):: X2
      INTEGER, DIMENSION(1:LONG):: ISUBSC
C
      INTEGER:: LMAT
C
      DOUBLE PRECISION, DIMENSION(1:IX*(IX+1)/2):: A11TR
C
      PARAMETER (PI = 3.1415926535897930D0)
C
C      DATA FQ/'(1H0',',10X',',''ME','MBRA','NE F','ORCE','S  N','X'' )'/
C      DATA FP/'X'' )','XY'')','Y '')'/
C      DATA FMT/'(/11','X,2(','10X,','3HIX','=,I2',',4X)',')   '/,
C     *       F/'X,1(','X,2(','X,3(','X,4(','X,5(','X,6('/
C
C+++++++++++++++++++For Test only: Test A11 for definitness++++++++++*
C                    IER =0
C                    ISIZA = IX*(IX+1)
C                    ISIZA = ISIZA/2
C                    DO LALALA=1,ISIZA
C                       A11TR(LALALA) = A11(LALALA)
C                    END DO
C                    CALL CHODEC(A11TR,IX,IX,LVTRI,IER)
C            WRITE (NWRITE,'("After CHOLESKY of A11TR: IER=",I4)') IER
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      IER = 0
C
C      NOIY = IY .EQ. 0
C      EPS1 = 1.0D-30
C
      IF (KNFUN.GT.1) THEN
C
         IER=0
         IBDDY = IBDY
         CALL CHODEC(A22,IY,IBDDY,LVA22,IER)
            IF ( IER.NE.0 )   THEN
               WRITE (NWRITE,9900) IER
               WRITE (*,9900) IER
               IER = 1
               GOTO 9999
            END IF
C-----------------------------------------------------------------------
C        Condensation of eigenvalue problem
C
C        For later usage the columns of matrix (A22**-1)*A21
C        are written to file 25
         INQUIRE (25, OPENED=OP25)
         IF (.NOT. OP25) THEN
          OPEN (25, FILE='RCA25',FORM='UNFORMATTED')
         END IF
C         IF (.NOT. OP25) OPEN (25, FILE='RCA25',FORM='FORMATTED')
         REWIND 25
C
C     	INITIALISE SUBSCRIPT VECTOR
C      	DO , I=1,LONG
C         	ISUBSC(I)=I
C     	END DO
      	K=1
C      	AUX = A21(ISUBSC,1)
         AUX = A21(:LONG,1)
      	ZZ=AUX
      	CALL CHOSOL(A22,IY,IBDDY,LVA22,ZZ,1,HILY)
      	WRITE (25) ZZ
      	A11(K)=A11(K) - DOT_PRODUCT(ZZ,AUX)
      	DO, J=2,IX
C         	ZZ = A21(ISUBSC,J)
            ZZ = A21(:LONG,J)
         	CALL CHOSOL(A22,IY,IBDDY,LVA22,ZZ,1,HILY)
         	WRITE (25) ZZ
         	DO, I=1,J
C            	AUX = A21(ISUBSC,I)
               AUX = A21(:LONG,I)
            	K=K+1
            	A11(K) = A11(K) - DOT_PRODUCT(ZZ,AUX)
         	END DO
      	END DO
C
C      	WRITE(NWRITE,'(" MATRIX A11 UPDATED")')
C
C+++++++++++++++++++For Test only: Test A11 for definitness+++++++++++
C                   IER =0
C                    ISIZA = IX*(IX+1)
C                    ISIZA = ISIZA/2
C                    DO LALALA=1,ISIZA
C                       A11TR(LALALA) = A11(LALALA)
C                    END DO
C                    CALL CHODEC(A11TR,IX,IX,LVTRI,IER)
C         WRITE (NWRITE,'("After scd CHOLESKY of A11TR: IER=",I4)') IER
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

         IF ( ITAB.NE.0 )   THEN
            WRITE (NWRITE,8990)   (A11(I),I=1,LVTRI(IX)+IX)
 8990 		FORMAT (1X,T36,'UPDATED MATRIX A11'/(1X,7D17.6))
         ENDIF
      ENDIF
C
C     S c a l e   m a s s   m a t r i x.
C     It is necessary for numerical precision of eigenvalue analysis.
C     Scale factor is PDOM = NORM(MMT)/NORM(A11).
C
      LMAT=LVTRI(IX)+IX; NRMA=IX*MAXVAL(ABS(A11(1:LMAT)))
      LMAT=LVB(IX)+IX;   NRMM=IX*MAXVAL(ABS(B11(1:LMAT)))
      PDOM=NRMM/NRMA
      B11(1:LMAT)=B11(1:LMAT)/PDOM; DOM=DOM/PDOM
C
C     S O L V E   E I G E N V A L U E   P R O B L E M
C     (A11(I,J) - ELAM(K)*B11(I,J))  *  X(J,K) = 0
      IBDB  = IBDX
      EPSILN = 1.0D-08
C     CALL SIMVIT(NEIGA,NEIG,A11,B11,IX,IBDA,IBDB,LVTRI,LVB,EPSILN,
C    *            ELAM,X,JAC,IP,IER,Y,HH,CH,BS,LVTRI,YS,LH)
      CALL SIMVIT(NEIGRQ,NEIGIT,A11,B11,IX,IX,IBDB,LVTRI,LVB,EPSILN,
     *            ELAM,X(:IX,:NEIGIT),JAC,IP, LVTRI, IER)
         IF (IER .NE. 0) THEN
            WRITE (NWRITE,9910) IER
            WRITE (*,9910) IER
            IER = 2
            GOTO 9999
         END IF
      DO, I=1,NEIGRQ
         ELAM(I) = ELAM(I)/PDOM
      END DO
C
C      WRITE (NWRITE,'('' SIMVIT LEFT'')')
C
C     P R I N T   R E S U L T S
C
C     PRINT STATISTICS OF INVERSE POWER METHOD  AND  EIGENVALUES
      WRITE (NWRITE,9540)   IP,JAC,EPSILN
      DO, I = 1,NEIGRQ
         HERZ(I) = DSQRT(ELAM(I))/(2.D0*PI)
      END DO
      WRITE (NWRITE,9550) (I,ELAM(I),HERZ(I),I=1,NEIGRQ)
C
C     PRINT X-EIGENVECTORS
  260 WRITE (NWRITE,9610)
      DRVEK = .TRUE.
      IZU = 0
      CALL EIGVPR(NWRITE,X(1:IX,1:NEIGRQ),IX,NEIGRQ)
C **********************************************************************
C
      IF ( X2PRI.AND. IY .GT.0 )  THEN
C     COMPUTE SECOND PARTS OF EIGENVECTORS
C     I. E. FREEDOMS DESCRIBING U,V,BETA,GAMMA: X2(I,K)=-AUX(I,J)*X(J,K)
C
      REWIND 25
C
      DO,    L=1,NEIGRQ
C         SET ELEMENTS OF VECTOR  X2  TO ZERO
C         DO,    I=1,IY
C             X2(I) = 0.0D0
C         END DO
          X2 = 0.D0
C         READ  IX  VECTORS OF (A22**-1)*X AND COMPUTE  X2
          DO,     J=1,IX
             READ (25)   AUX
             DO,    I=1,IY
                X2(I) = X2(I) - AUX(I)*X(I,J)
C  310        CONTINUE
            END DO
         END DO
C         PRINT THE L-TH EIGENVECTOR
          WRITE (NWRITE,9040)   L
          WRITE (NWRITE,9050)   (X2(I),I=1,IY)
C          WRITE (NWRITE,9050)   X2   !Try this instead of previous STMT
      END DO
      END IF
C
 9999 RETURN
C
 9040 FORMAT (1H0,' EIGENMODE ',I2)
 9050 FORMAT (1H ,5D20.8)
 9530 FORMAT (1H1,50X,'M A T R I X  A11, MODIFIED'///)
 9540 FORMAT(1H1,' STATISTICS OF INVERSE POWER METHOD:'//,
     *       5X,'IP=',I3,', JAC =',I3/,
     *       5X,'MAXIMUM CONTAMINATION OF HIGHER EIGENVECTORS BY LOWER',
     *       ' ONES: EPSILN =',D12.4)
 9550 FORMAT (///2H0 ,
     *       'COMPUTED EIGENVALUES :'///
     *       (1H ,7X,' EIGENVALUE',I3,':',D14.6,' =',D14.6,' HZ'))
 9610 FORMAT(1H1,'X-EIGENVECTORS DESCRIBING NORMAL DISPLACEMENT W')
 9620 FORMAT(1H1,'X2-EIGENVECTORS DESCRIBING TANGENTIAL DISPLACEMENT ',
     *       'COMPONENTS U,V AND TRANSVERSE SHEAR STRAINS BETA, GAMMA')
 9900 FORMAT (/,' SUBROUTINE VIBS3: CHOLESKY DECOMPOSITION ',
     *            'OF MATRIX A22 FAILED. IER= ',I5)
 9910 FORMAT (1X,'SUBROUTINE VIBS3: ERROR ENCOUNTERED IN SUBR. SIMVIT'
     1       /,1X,'IER=',I4)
      END

