C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	  
C     Beos - Core
C     Shared data/variable declarations library
C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#include "BEOSData.for" 
C
C     ======================================================================================
C     Beos31	      				          				            // mg 29.07.2024
C
C     Description:
C>    @brief
C>    Predefined parameters for BEOS with 31 effective nodes
C>    @author 
C>    Marc Garbade
C>    @date
C>    29.07.2024
C>    @param P_RTNDS Integer value representing ...
C>    @param P_NGIT  Integer value representing ...
C>    @param P_NGRQ  Integer value representing ...
C>    @param P_NSUP  Integer value representing ...
C>    @param P_ABDSTF Integer value representing ...
C>    @par Notes/Changes
C>    - Created 												       // mg 29.07.2024
C     ======================================================================================
      MODULE BEOS31
      IMPLICIT NONE
C
C     PARAMETERS TO BE SET:
      INTEGER, PARAMETER :: P_RTNDS = 31
      INTEGER, PARAMETER :: P_NGIT  = 55
      INTEGER, PARAMETER :: P_NGRQ  = 50
      INTEGER, PARAMETER :: P_NSUP  = 250
      INTEGER, PARAMETER :: P_ABDSTF= 2
C
#include "#DATA"
C      
      END MODULE BEOS31
	  
C     ======================================================================================
C     Beos19	      				          				            // mg 29.07.2024
C
C     Description:
C>    @brief
C>    Predefined parameters for BEOS with 19 effective nodes
C>    @author 
C>    Marc Garbade
C>    @date
C>    29.07.2024
C>    @param P_RTNDS Integer value representing ...
C>    @param P_NGIT  Integer value representing ...
C>    @param P_NGRQ  Integer value representing ...
C>    @param P_NSUP  Integer value representing ...
C>    @param P_ABDSTF Integer value representing ...
C>    @par Notes/Changes
C>    - Created 												       // mg 29.07.2024
C     ======================================================================================
      MODULE BEOS19
      IMPLICIT NONE
C
C     PARAMETERS TO BE SET:
      INTEGER, PARAMETER :: P_RTNDS = 19
      INTEGER, PARAMETER :: P_NGIT  = 55
      INTEGER, PARAMETER :: P_NGRQ  = 50
      INTEGER, PARAMETER :: P_NSUP  = 250
      INTEGER, PARAMETER :: P_ABDSTF= 2
C
#include "#DATA"
C         
      END MODULE BEOS19
	  
C     ======================================================================================
C     Beos21	      				          				            // mg 29.07.2024
C
C     Description:
C>    @brief
C>    Predefined parameters for BEOS with 21 effective nodes
C>    @author 
C>    Marc Garbade
C>    @date
C>    29.07.2024
C>    @param P_RTNDS Integer value representing ...
C>    @param P_NGIT  Integer value representing ...
C>    @param P_NGRQ  Integer value representing ...
C>    @param P_NSUP  Integer value representing ...
C>    @param P_ABDSTF Integer value representing ...
C>    @par Notes/Changes
C>    - Created 												       // mg 29.07.2024
C     ======================================================================================
      MODULE BEOS21
      IMPLICIT NONE
C
C     PARAMETERS TO BE SET:
      INTEGER, PARAMETER :: P_RTNDS = 21
      INTEGER, PARAMETER :: P_NGIT  = 55
      INTEGER, PARAMETER :: P_NGRQ  = 50
      INTEGER, PARAMETER :: P_NSUP  = 250
      INTEGER, PARAMETER :: P_ABDSTF= 2
C
#include "#DATA"
C          
      END MODULE BEOS21
	  
C     ======================================================================================
C     Beos25	      				          				            // mg 29.07.2024
C
C     Description:
C>    @brief
C>    Predefined parameters for BEOS with 25 effective nodes
C>    @author 
C>    Marc Garbade
C>    @date
C>    29.07.2024
C>    @param P_RTNDS Integer value representing ...
C>    @param P_NGIT  Integer value representing ...
C>    @param P_NGRQ  Integer value representing ...
C>    @param P_NSUP  Integer value representing ...
C>    @param P_ABDSTF Integer value representing ...
C>    @par Notes/Changes
C>    - Created 												       // mg 29.07.2024
C     ======================================================================================
      MODULE BEOS25
      IMPLICIT NONE
C
C     PARAMETERS TO BE SET:
      INTEGER, PARAMETER :: P_RTNDS = 25
      INTEGER, PARAMETER :: P_NGIT  = 55
      INTEGER, PARAMETER :: P_NGRQ  = 50
      INTEGER, PARAMETER :: P_NSUP  = 250
      INTEGER, PARAMETER :: P_ABDSTF= 2
C
#include "#DATA"
C         
      END MODULE BEOS25