      subroutine umat(stress, statev, ddsdde, sse, spd, scd, rpl, 
     & ddsddt, drplde, drpldt, stran, dstran, time, dtime, temp,
     & dtemp, predef, dpred, materl, ndi, nshr, ntens, nstatv,
     & props, nprops, coords, drot, pnewdt, celent, dfgrd0,
     & dfgrd1, noel, npt, kslay, kspt, kstep, kinc)
      include 'ABA_PARAM.INC'
      
      character*80 materl, path
      character*30 outdir

      integer ntens, nstatv, noel, npt, step, counter, kinc
      double precision
     & stress(ntens), statev(nstatv), tch,
     & ddsdde(ntens,ntens), stran(ntens), dstran(ntens), time(2),
     & predef(1), dpred(1), props(nprops), coords(3), drot(3,3),
     & delta, strain_per(6)

      double precision
     & e11, e22, e33, g12, g23, g13, nu12, nu23, nu13, nu21,
     & nu32, nu31, atemp
      

! Properties from ABAQUS
      e11 = props(1)
      e22 = props(2)
      e33 = props(3)

      g12 = props(4)
      g13 = props(5)
      g23 = props(6)

      nu12 = props(7)
      nu13 = props(8)
      nu23 = props(9)

      nu21 = nu12 / e11 * e22
      nu32 = nu23 / e22 * e33
      nu31 = nu13 / e11 * e33

! Tangent stiffness ddsdde of linear elastic material
      ddsdde = 0.0
      atemp = (1.0 - nu12 * nu21 - nu23 * nu32-nu31*nu13-          
     &          2.0 * nu12 * nu23 * nu31)/ (e11 * e22 * e33)

      ddsdde(1,1) = (1.0 - nu23 * nu32) / (atemp * e33 * e22)
      ddsdde(2,2) = (1.0 - nu31 * nu13) / (atemp * e11 * e33)
      ddsdde(3,3) = (1.0 - nu12 * nu21) / (atemp * e11 * e22)
      ddsdde(1,2) = (nu21 + nu31 * nu23) / (atemp * e22 * e33)
      ddsdde(2,1) = (nu21 + nu31 * nu23) / (atemp * e22 * e33)
      ddsdde(1,3) = (nu31 + nu21 * nu32) / (atemp * e22 * e33)
      ddsdde(3,1) = (nu31 + nu21 * nu32) / (atemp * e22 * e33)
      ddsdde(2,3) = (nu32 + nu31 * nu12) / (atemp * e11 * e33)
      ddsdde(3,2) = (nu32 + nu31 * nu12) / (atemp * e11 * e33)
      ddsdde(4,4) = g12
      ddsdde(5,5) = g13
      ddsdde(6,6) = g23

! Stress update
      stress = stress + matmul(ddsdde, dstran)
 

      return
      end
